function updateDataUA_UZ() {
  // в этой функции будем запрашивать данные по ключам UA & UZ с сервера и рендерить их в интерфейс
  // 1 получаем данные конфигурации с сервера
  // 2 запускаем parseAppKey
  // 3 ищем Наши ключи UA и UZ
  // 4 запускаем рендер всех контролов
  parseAppKey();
  searchKey_UA_UZ();
  renderControl();
}

let key_UA_UZ = {}; //Ключи пользователей
function searchKey_UA_UZ() {
  //Ищем ключи OC - выходы ОК
  key_UA_UZ = {};
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("ua") != -1) {
      if (deviceJSON.config[i].key != "ua") {
        let numberUA = deviceJSON.config[i].key.substring(2); // номер
        let mode = deviceJSON.config[i].subvalues[0].value; //режим работы
        let nickname = deviceJSON.config[i].subvalues[1].value; //пвевдоним
        let code = deviceJSON.config[i].subvalues[2].value; // код управления
        let keyUz = "uz" + numberUA; // ключ раздела
        let sections = dataDevice[keyUz] ? dataDevice[keyUz].value : errorCore(keyUz);

        if (code != "000000000000" && code != "" && dataDevice[keyUz]) {
          key_UA_UZ[numberUA] = { mode: mode, code: code, sections: sections, number: numberUA, nickname: nickname };
        }
      }
    }
  }
  render_searchKey_UA_UZ(); //рендер расширителей
}

let key_SN_1_2 = {};

function searchKey_SN_1_2() {
  const _minVerSaturnCodirovka = '0.1O'
  const _currentVerSaturnCodirovka = findCurrentVersion()
  if (saturnDevice.includes(DEVICEMODEL) && verElestaToInt(_minVerSaturnCodirovka) <= verElestaToInt(_currentVerSaturnCodirovka) && _currentVerSaturnCodirovka !== '-1' && _currentVerSaturnCodirovka !== '') {
    searchKey_SN_6()
  } else {
    $.show("#tab_sim_1_sms"); // на вкладке gsm отображаем настройки смс номеров
    key_SN_1_2 = {};
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key.indexOf("sn1") != -1) {
        let numberSN = deviceJSON.config[i].key.substring(2); // номер
        let phone = deviceJSON.config[i].subvalues[0].value; //телефон
        key_SN_1_2[numberSN] = { phone: phone };
      } else if (deviceJSON.config[i].key.indexOf("sn2") != -1) {
        let numberSN = deviceJSON.config[i].key.substring(2); // номер
        let phone = deviceJSON.config[i].subvalues[0].value; //телефон
        key_SN_1_2[numberSN] = { phone: phone };
      }
    }
    render_searchKey_SN_1_2(); //рендер сн1_2
  }

}

function searchKey_SN_6() {
  $.show("#tab_sim_6_sms"); // на вкладке gsm отображаем настройки смс номеров
  key_SN_1_2 = {};
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("sn1") != -1) {
      let numberSN = deviceJSON.config[i].key.substring(2); // номер
      let phone = deviceJSON.config[i].subvalues[0].value; //телефон
      key_SN_1_2[numberSN] = { phone: phone };
    } else if (deviceJSON.config[i].key.indexOf("sn2") != -1) {
      let numberSN = deviceJSON.config[i].key.substring(2); // номер
      let phone = deviceJSON.config[i].subvalues[0].value; //телефон
      key_SN_1_2[numberSN] = { phone: phone };
    } else if (deviceJSON.config[i].key.indexOf("sn3") != -1) {
      let numberSN = deviceJSON.config[i].key.substring(2); // номер
      let phone = deviceJSON.config[i].subvalues[0].value; //телефон
      key_SN_1_2[numberSN] = { phone: phone };
    } else if (deviceJSON.config[i].key.indexOf("sn4") != -1) {
      let numberSN = deviceJSON.config[i].key.substring(2); // номер
      let phone = deviceJSON.config[i].subvalues[0].value; //телефон
      key_SN_1_2[numberSN] = { phone: phone };
    } else if (deviceJSON.config[i].key.indexOf("sn5") != -1) {
      let numberSN = deviceJSON.config[i].key.substring(2); // номер
      let phone = deviceJSON.config[i].subvalues[0].value; //телефон
      key_SN_1_2[numberSN] = { phone: phone };
    } else if (deviceJSON.config[i].key.indexOf("sn6") != -1) {
      let numberSN = deviceJSON.config[i].key.substring(2); // номер
      let phone = deviceJSON.config[i].subvalues[0].value; //телефон
      key_SN_1_2[numberSN] = { phone: phone };
    }
  }
  render_searchKey_SN_6(); //рендер сн1_6
}

function render_searchKey_SN_1_2() {
  // tab_sim_1_numberSms
  let idSim1 = "tab_sim_1_numberSms", idSim2 = "tab_sim_2_numberSms";
  DEVICEMODEL === "J6423" ? (idSim1 = "tab_sim_1_numberSms") : "tab_sim_1_numberSms";
  DEVICEMODEL === "J6423" ? (idSim2 = "tab_sim_2_numberSms") : "tab_sim_2_numberSms";
  DEVICEMODEL === "J6422" ? (idSim1 = "tab_sim_1_numberSms") : "tab_sim_1_numberSms";
  DEVICEMODEL === "J6422" ? (idSim2 = "tab_sim_2_numberSms") : "tab_sim_2_numberSms";

  dataDevice["sn1_1"]
    ? (listControls["sn1"] = Control.create("TEXT_SIM", "sn1", idSim1, dataDevice["sn1_1"].value, "Номер sim 1"))
    : false;
  dataDevice["sn2_1"]
    ? (listControls["sn2"] = Control.create("TEXT_SIM", "sn2", idSim2, dataDevice["sn2_1"].value, "Номер sim 2"))
    : false;
}
function render_searchKey_SN_6() {



  dataDevice["sn1_1"]
    ? (listControls["sn1"] = Control.create("TEXT_SIM", "sn1", "tab_sim_1_number", dataDevice["sn1_1"].value, "Номера для sim-карты 1"))
    : false;
  dataDevice["sn2_1"]
    ? (listControls["sn2"] = Control.create("TEXT_SIM", "sn2", "tab_sim_2_number", dataDevice["sn2_1"].value, ""))
    : false;
  dataDevice["sn3_1"]
    ? (listControls["sn3"] = Control.create("TEXT_SIM", "sn3", "tab_sim_3_number", dataDevice["sn3_1"].value, ""))
    : false;
  dataDevice["sn4_1"]
    ? (listControls["sn4"] = Control.create("TEXT_SIM", "sn4", "tab_sim_4_number", dataDevice["sn4_1"].value, "Номера для sim-карты 2"))
    : false;
  dataDevice["sn5_1"]
    ? (listControls["sn5"] = Control.create("TEXT_SIM", "sn5", "tab_sim_5_number", dataDevice["sn5_1"].value, ""))
    : false;
  dataDevice["sn6_1"]
    ? (listControls["sn6"] = Control.create("TEXT_SIM", "sn6", "tab_sim_6_number", dataDevice["sn6_1"].value, ""))
    : false;
}

let key_XO = {}; //Ключи расширителей (RL)
function searchKey_XO() {
  //флаг наличия ключей XO
  let isXoKey = false;
  //Ищем ключи XO - задержки по разделам
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("xo") != -1) {
      if (deviceJSON.config[i].subvalues[0].value != "0" && deviceJSON.config[i].subvalues[0].value != "") {
        let numberXO = deviceJSON.config[i].key.substring(2); // номер RL для создания объекта контрола
        //let type = RS485[deviceJSON.config[i].subvalues[0].value]; //Тип Расширителя
        let delay = deviceJSON.config[i].subvalues[0].value; // ВЕрсия ПО расширителя
        //let newKeyRA = "ra" + numberRl + "_0"; // СИнтезируем  название ключа RA для получения данных по шлейфам
        //let startSection = dataDevice[newKeyRA].value; // С какого шлейфа начинать
        key_XO[numberXO] = { delay: delay };
        //есть ключи XO
        isXoKey = true;
      }
    }
  }

  //Пусть тут будет так, если режет глаз, можете отрефакторить
  if (isXoKey) {
    render_searchKey_XO(); //рендер расширителей
  } else {
    //крашится при выходе из других карточек, поэтому трай-кетч
    try {
      const el = document.getElementById("new-delay-on-output");
      el.parentNode.removeChild(el);
    } catch (e) {
    }
  }
}

let key_OC = {}; //Ключи расширителей (RL)
let key_TA = {}; //Ключи расширителей (TA)
let key_TA_Rele = {};
function searchKey_OC() {
  //Ищем ключи OC - выходы ОК
  key_OC = {};
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("oo") != -1) {
      let numberOC = deviceJSON.config[i].key.substring(2); // номер RL для создания объекта контрола
      if (DEVICEINFO[DEVICEMODEL].ok >= numberOC) {
        let type = deviceJSON.config[i].subvalues[0].value; //Тип ОК
        let delay = deviceJSON.config[i].subvalues[1].value; // Задержка ОК
        let keyOr = "or" + numberOC;
        let ktc = dataDevice[keyOr] ? dataDevice[keyOr].value : errorCore(keyOr);

        let keyOb = "ob" + numberOC;
        let oppening = dataDevice[keyOb] ? dataDevice[keyOb].value : errorCore(keyOb);

        let keyOz = "oq" + numberOC;
        let sections = dataDevice[keyOz] ? dataDevice[keyOz].value : errorCore(keyOz);

        let keyOf = "of" + numberOC;
        let fire = dataDevice[keyOf] ? dataDevice[keyOf].value : errorCore(keyOf);

        let keyOt = "ot" + numberOC;
        let water = dataDevice[keyOt] ? dataDevice[keyOt].value : errorCore(keyOt);

        let keyOg = "og" + numberOC;
        let gas = dataDevice[keyOg] ? dataDevice[keyOg].value : errorCore(keyOg);

        key_OC[numberOC] = {
          delay: delay,
          type: type,
          ktc: ktc,
          oppening: oppening,
          sections: sections,
          fire: fire,
          water: water,
          gas: gas,
          extender: "0",
          numerIY: "0",
        };
      }
    }
    if (deviceJSON.config[i].key.indexOf("oe") != -1) {
      if (deviceJSON.config[i].subvalues[0].value != "0" && deviceJSON.config[i].subvalues[0].value != "") {
        let IK = deviceJSON.config[i].subvalues[1].value.split(",");
        for (let k = 0; k < IK.length; k++) {
          let keyOO_type = "oo" + IK[k] + "_0";
          let keyOO_delay = "oo" + IK[k] + "_1";
          let numberOC = IK[k];
          let type = dataDevice[keyOO_type] ? dataDevice[keyOO_type].value : null; // Тип
          let delay = dataDevice[keyOO_delay] ? dataDevice[keyOO_delay].value : null; // Задержка ОК
          let keyOr = "or" + numberOC; // ключ КТС
          let ktc = dataDevice[keyOr] ? dataDevice[keyOr].value : null;
          let keyOb = "ob" + numberOC;
          let oppening = dataDevice[keyOb] ? dataDevice[keyOb].value : null;
          let keyOq = "oq" + numberOC;
          let sections = dataDevice[keyOq] ? dataDevice[keyOq].value : null;
          let keyOf = "of" + numberOC;
          let extenderNumber = deviceJSON.config[i].key.slice(2);

          let fire = dataDevice[keyOf] ? dataDevice[keyOf].value : null;

          let keyOt = "ot" + numberOC;
          let water = dataDevice[keyOt] ? dataDevice[keyOt].value : null;

          let keyOg = "og" + numberOC;
          let gas = dataDevice[keyOg] ? dataDevice[keyOg].value : null;

          key_OC[numberOC] = {
            delay: delay,
            type: type,
            ktc: ktc,
            oppening: oppening,
            sections: sections,
            fire: fire,
            water: water,
            gas: gas,
            extender: extenderNumber,
            numerIY: k + 1,
          };
        }
      }
    }
    if (deviceJSON.config[i].key.indexOf("oh") != -1) {
      if (deviceJSON.config[i].subvalues[0].value != "0" && deviceJSON.config[i].subvalues[0].value != "") {
        let IK = deviceJSON.config[i].subvalues[1].value.split(",");
        for (let k = 0; k < IK.length; k++) {
          let keyOO_type = "oo" + IK[k] + "_0";
          let keyOO_delay = "oo" + IK[k] + "_1";
          let numberOC = IK[k];
          let type = dataDevice[keyOO_type] ? dataDevice[keyOO_type].value : null; // Тип
          let delay = dataDevice[keyOO_delay] ? dataDevice[keyOO_delay].value : null; // Задержка ОК
          let keyOr = "or" + numberOC; // ключ КТС
          let ktc = dataDevice[keyOr] ? dataDevice[keyOr].value : null;
          let keyOb = "ob" + numberOC;
          let oppening = dataDevice[keyOb] ? dataDevice[keyOb].value : null;
          let keyOq = "oq" + numberOC;
          let sections = dataDevice[keyOq] ? dataDevice[keyOq].value : null;
          let keyOf = "of" + numberOC;
          let extenderNumber = deviceJSON.config[i].key.slice(2);

          let fire = dataDevice[keyOf] ? dataDevice[keyOf].value : null;

          let keyOt = "ot" + numberOC;
          let water = dataDevice[keyOt] ? dataDevice[keyOt].value : null;

          let keyOg = "og" + numberOC;
          let gas = dataDevice[keyOg] ? dataDevice[keyOg].value : null;

          key_OC[numberOC] = {
            delay: delay,
            type: type,
            ktc: ktc,
            oppening: oppening,
            sections: sections,
            fire: fire,
            water: water,
            gas: gas,
            extender: extenderNumber,
            numerIY: k + 1,
          };
        }
      }
    }
  }

  render_searchKey_OC(); //рендер расширителей
}
function searchKey_OCv2() {
  //Ищем ключи OC - выходы ОК
  key_OC = {};
  //key_TA = {};
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("oc") != -1) {
      let numberOC = deviceJSON.config[i].key.substring(2); // номер RL для создания объекта контрола
      if (DEVICEINFO[DEVICEMODEL].ok >= numberOC) {
        let type = deviceJSON.config[i].subvalues[0].value; //Тип ОК
        let delay = deviceJSON.config[i].subvalues[1].value; // Задержка ОК
        let keyOr = "or" + numberOC;
        let ktc = dataDevice[keyOr] ? dataDevice[keyOr].value : errorCore(keyOr);

        let keyOb = "ob" + numberOC;
        let oppening = dataDevice[keyOb] ? dataDevice[keyOb].value : errorCore(keyOb);

        let keyOz = "oz" + numberOC;
        let sections = dataDevice[keyOz] ? dataDevice[keyOz].value : errorCore(keyOz);



        key_OC[numberOC] = {
          delay: delay,
          type: type,
          ktc: ktc,
          oppening: oppening,
          sections: sections,
          extender: "0",
          numerIY: "0",
        };
      }
    }
    if (deviceJSON.config[i].key.indexOf("oe") != -1) {
      if (deviceJSON.config[i].subvalues[0].value != "0" && deviceJSON.config[i].subvalues[0].value != "") {
        let IK = deviceJSON.config[i].subvalues[1].value.split(",");
        for (var k = 0; k < IK.length; k++) {
          let keyOO_type = "oo" + IK[k] + "_0";
          let keyOO_delay = "oo" + IK[k] + "_1";
          let numberOC = IK[k];
          let type = dataDevice[keyOO_type] ? dataDevice[keyOO_type].value : null; // Тип
          let delay = dataDevice[keyOO_delay] ? dataDevice[keyOO_delay].value : null; // Задержка ОК
          let keyOr = "or" + numberOC; // ключ КТС
          let ktc = dataDevice[keyOr] ? dataDevice[keyOr].value : null;
          let keyOb = "ob" + numberOC;
          let oppening = dataDevice[keyOb] ? dataDevice[keyOb].value : null;
          let keyOz = "oq" + numberOC;
          let sections = dataDevice[keyOz] ? dataDevice[keyOz].value : null;
          let keyOf = "of" + numberOC;
          let extenderNumber = deviceJSON.config[i].key.slice(2);

          let fire = dataDevice[keyOf] ? dataDevice[keyOf].value : null;

          let keyOt = "ot" + numberOC;
          let water = dataDevice[keyOt] ? dataDevice[keyOt].value : null;

          let keyOg = "og" + numberOC;
          let gas = dataDevice[keyOg] ? dataDevice[keyOg].value : null;

          key_OC[numberOC] = {
            delay: delay,
            type: type,
            ktc: ktc,
            oppening: oppening,
            sections: sections,
            fire: fire,
            water: water,
            gas: gas,
            extender: extenderNumber,
            numerIY: k + 1,
          };
        }
      }
    }
    /* if (deviceJSON.config[i].key.indexOf("ta") != -1) {
      let numberTa = deviceJSON.config[i].key.substring(2); // номер RL для создания объекта контрола
      let keyTf = "tf" + numberTa;
      let keyTz = "tz" + numberTa;
      //тип выходов ВУ
      let outputType = deviceJSON.config[i].subvalues[0].value;
      let flagMask = decObj[deviceJSON.config[i].subvalues[1].value];
      let hack = flagMask[3]
      let ktc = flagMask[2]
      let problem = flagMask[1]
      let inversion = flagMask[0]
      if (DEVICEINFO[DEVICEMODEL].ok >= numberTa) {


        let type = dataDevice[keyTf + "_0"] ? dataDevice[keyTf + "_0"].value : errorCore(keyTf);//Тип ОК
        let delay = dataDevice[keyTf + "_1"] ? dataDevice[keyTf + "_1"].value : errorCore(keyTf);// Задержка ОК
        let sections = dataDevice[keyTz] ? dataDevice[keyTz].value : errorCore(keyTf);

        key_TA[numberTa] = {
          outputType,
          type,
          sections,
          delay,
          ktc,
          problem,
          inversion,
          hack,
          extender: "0",
          numerIY: "0",
        };
      }
    } */

  }
  if (paramsReleBrTb) {
    render_searchKey_OCv2(); //рендер расширителей
  } else {
    render_searchKey_TA(); //рендер расширителей с новыми ключами (TA,TF,TZ)
  }
}
let key_RL = {}; //Ключи расширителей (RL)
let key_RL_MAX = 0; //Макс количество ШЛ.нач.
function searchKey_RL() {
  //Ищем ключи RL - расширители
  //key_RL = {};
  $.show("#telemetria_4");
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("rl") != -1) {
      if (deviceJSON.config[i].subvalues[0].value != "0" && deviceJSON.config[i].subvalues[0].value != "") {
        let numberRl = deviceJSON.config[i].key.substring(2); // номер RL для создания объекта контрола
        let type = RS485[deviceJSON.config[i].subvalues[0].value].title; //Тип Расширителя
        let version = deviceJSON.config[i].subvalues[1].value; // ВЕрсия ПО расширителя
        let newKeyRA = "ra" + numberRl + "_1"; // СИнтезируем  название ключа RA для получения данных по шлейфам
        let newKeyRAsections = "ra" + numberRl + "_0"; // СИнтезируем  название ключа RA для получения данных по шлейфам
        let startSection = dataDevice[newKeyRA] ? dataDevice[newKeyRA].value : null; // С какого шлейфа начинать
        let sumSections = dataDevice[newKeyRAsections] ? dataDevice[newKeyRAsections].value : null; // С какого шлейфа начинать
        let razdel = sumSections;
        if (startSection == "0") {
          if (dataDevice["ra" + numberRl + "_1"].value != "0") {
            razdel = dataDevice["ra" + numberRl + "_1"].value;
          } else {
            //razdel = " 123 ";
          }
        } else {
          //razdel = " 123 ";
        }

        key_RL[numberRl] = {
          indexRS: deviceJSON.config[i].subvalues[0].value,
          typeRl: type,
          versionRl: version,
          startSection: startSection,
          sections: razdel,
        };
        // key_RL_MAX = dataDevice["ra" + numberRl + "_1"].max; // записываем максимальное количество Шл.нач.
      }
    } else {
      key_RL["-1"] = { typeRl: "-1", versionRl: null, startSection: null, razdel: null };
    }
  }
  render_searchKey_RL(); //рендер расширителей
}

function searchKey_RL_281x() {
  //Ищем ключи RL - расширители
  //key_RL = {};
  $.show("#telemetria_4");
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("rl") != -1) {
      if (deviceJSON.config[i].subvalues[0].value != "0" && deviceJSON.config[i].subvalues[0].value != "") {
        let numberRl = deviceJSON.config[i].key.substring(2); // номер RL для создания объекта контрола
        let type = RS485[deviceJSON.config[i].subvalues[0].value].title; //Тип Расширителя
        let version = deviceJSON.config[i].subvalues[1].value; // ВЕрсия ПО расширителя
        let newKeyRA = "zr" + numberRl + "_1"; // СИнтезируем  название ключа RA для получения данных по шлейфам
        let newKeyRAsections = "zr" + numberRl + "_0"; // СИнтезируем  название ключа RA для получения данных по шлейфам
        let startSection = dataDevice[newKeyRA] ? dataDevice[newKeyRA].value.split(",")[0] : null; // С какого шлейфа начинать
        let sumSections = dataDevice[newKeyRAsections] ? dataDevice[newKeyRAsections].value : null; // С какого шлейфа начинать
        let razdel = sumSections;
        if (startSection == "0") {
          if (dataDevice["ra" + numberRl + "_1"].value != "0") {
            razdel = dataDevice["ra" + numberRl + "_1"].value;
          } else {
            //razdel = " 123 ";
          }
        } else {
          //razdel = " 123 ";
        }

        key_RL[numberRl] = {
          indexRS: deviceJSON.config[i].subvalues[0].value,
          typeRl: type,
          versionRl: version,
          startSection: startSection,
          sections: razdel,
        };
        // key_RL_MAX = dataDevice["ra" + numberRl + "_1"].max; // записываем максимальное количество Шл.нач.
      }
    } else {
      key_RL["-1"] = { typeRl: "-1", versionRl: null, startSection: null, razdel: null };
    }
  }
  render_searchKey_RL(); //рендер расширителей
}

function searchKey_RL_pk4() {
  //Ищем ключи RL - расширители
  //key_RL = {};
  $.show("#telemetria_4");
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("rl") != -1) {
      if (deviceJSON.config[i].subvalues[0] && deviceJSON.config[i].subvalues[0].value !== "0" && deviceJSON.config[i].subvalues[0].value !== "") {
        let numberRl = deviceJSON.config[i].key.substring(2); // номер RL для создания объекта контрола
        let type =RS485[deviceJSON.config[i].subvalues[0].value] && RS485[deviceJSON.config[i].subvalues[0].value].title || "Тип Расширителя неизвестен"; //Тип Расширителя
        let version = deviceJSON.config[i].subvalues[1] && deviceJSON.config[i].subvalues[1].value || "Версия ПО расширителя неизвестна"; // ВЕрсия ПО расширителя

        let nameKeyFromTypeDev;
        switch (deviceJSON.config[i].subvalues[0].value) {
          case "1":
          case "2":
          case "3":
            // РШ
            nameKeyFromTypeDev = "ra";
            break;
          case "4":
            // РР
            nameKeyFromTypeDev = "rb";
            break;
          case "5":
          case "6":
          case "7":
          case "8":
          case "9":
            // УВС
            nameKeyFromTypeDev = "rk";
            break;
          default:
            nameKeyFromTypeDev = null;
            break;
        }

        let newKeyRA = nameKeyFromTypeDev + numberRl + "_1"; // СИнтезируем  название ключа RA для получения данных по шлейфам
        let newKeyRAsections = nameKeyFromTypeDev + numberRl + "_0"; // СИнтезируем  название ключа RA для получения данных по шлейфам
        let startSection = dataDevice[newKeyRA] ? dataDevice[newKeyRA].value : null; // С какого шлейфа начинать
        let sumSections = dataDevice[newKeyRAsections] ? dataDevice[newKeyRAsections].value : null; // С какого шлейфа начинать
        let razdel = sumSections;
        if (startSection == "0") {
          if (dataDevice[nameKeyFromTypeDev + numberRl + "_1"].value != "0") {
            razdel = dataDevice[nameKeyFromTypeDev + numberRl + "_1"].value;
          } else {
            //razdel = " 123 ";
          }
        } else {
          //razdel = " 123 ";
        }

        key_RL[numberRl] = {
          indexRS: deviceJSON.config[i].subvalues[0].value,
          typeRl: type,
          versionRl: version,
          startSection: startSection,
          sections: razdel,
        };
        // key_RL_MAX = dataDevice["ra" + numberRl + "_1"].max; // записываем максимальное количество Шл.нач.
      }
    } else {
      key_RL["-1"] = { typeRl: "-1", versionRl: null, startSection: null, razdel: null };
    }
  }
  $.show("#tab_hw1");
  render_searchKey_RL_pk4(); //рендер расширителей
}

let key_zr = {};

function searchKey_RL_radio() {
  //Ищем ключи RL - расширители
  key_zr = {};
  $.show("#telemetria_4");
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("rl") != -1) {
      if (deviceJSON.config[i].subvalues[0].value != "0" && deviceJSON.config[i].subvalues[0].value != "") {
        let numberRl = deviceJSON.config[i].key.substring(2); // номер RL для создания объекта контрола
        let type = RS485[deviceJSON.config[i].subvalues[0].value].title; //Тип Расширителя
        let version = deviceJSON.config[i].subvalues[1].value; // ВЕрсия ПО расширителя
        let newKeyRA = "ra" + numberRl + "_1"; // СИнтезируем  название ключа RA для получения данных по шлейфам
        let newKeyRAsections = "ra" + numberRl + "_0"; // СИнтезируем  название ключа RA для получения данных по шлейфам
        let startSection = dataDevice[newKeyRA] ? dataDevice[newKeyRA].value : ""; // С какого шлейфа начинать
        let sumSections = dataDevice[newKeyRAsections] ? dataDevice[newKeyRAsections].value : ""; // С какого шлейфа начинать
        let razdel = sumSections;
        if (startSection == "0") {
          if (dataDevice["ra" + numberRl + "_1"]) {
            if (dataDevice["ra" + numberRl + "_1"].value != "0") {
              razdel = dataDevice["ra" + numberRl + "_1"].value;
            }
          }
        }

        key_RL[numberRl] = { typeRl: type, versionRl: version, startSection: startSection, sections: razdel };
        // key_RL_MAX = dataDevice["ra" + numberRl + "_1"].max; // записываем максимальное количество Шл.нач.
      }
    } else if (deviceJSON.config[i].key.indexOf("zr") != -1) {
      if (deviceJSON.config[i].subvalues[0].value != "0" && deviceJSON.config[i].subvalues[0].value != "") {
        let numberZr = deviceJSON.config[i].key.substring(2); // номер RL для создания объекта контрола
        let arrZr = deviceJSON.config[i].subvalues[1].value.split(",");
        key_zr[numberZr] = { zone: arrZr };
      }
    }
  }

  render_searchKey_RL_RADIO(); //рендер расширителей
}

let key_LM = {}; //Ключи шлейфов
let key_EXT = {}; //Ключи Ключи шлейфов расширителей
let key_RL_MIN = 0; //Мин количество ШЛ.нач.
function searchKey_LM_LR() {
  key_LM = {}; // Проверить нужно ли
  key_EXT = {}; // Проверить нужно ли
  key_ra = {}; // Проверить нужно ли
  key_RL_MIN = 0; // Отчищаем Шл. НАч.
  key_RL_MAX = 0; // Отчищаем Шл. НАч.
  //Ищем ключи RL - расширители
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("lm") != -1) {
      if (deviceJSON.config[i].subvalues[0].value != "0" && deviceJSON.config[i].subvalues[0].value != "") {
        let numberLm = deviceJSON.config[i].key.substring(2); // номер LM для создания объекта контрола
        if (numberLm > key_RL_MIN) {
          key_RL_MIN = numberLm;
        }
        if (DEVICEINFO[DEVICEMODEL].sensor >= numberLm) {
          // Проверка на кол-во шлейвов согласно таблице device.js

          let type = deviceJSON.config[i].subvalues[0].value; //Тип Шлейфа
          let delay = deviceJSON.config[i].subvalues[1].value; //Задержка Шлейфа
          // let version = deviceJSON.config[i].subvalues[1].value; // ВЕрсия ПО расширителя
          let newKeyYz = "yz" + numberLm; // СИнтезируем  название ключа YZ для получения привязки к разделу
          let newKeyLeMin = "le" + numberLm + "_0"; // СИнтезируем  название ключа LE для получения нижнего сопротивления
          let newKeyLeMax = "le" + numberLm + "_1"; // СИнтезируем  название ключа LE для получения верхнего сопротивления
          let newKeyLd = "ld" + numberLm; // СИнтезируем  название ключа LD для получения запрета постановки с открытой дверью
          let newKeyPz = "pz" + numberLm; // СИнтезируем  название ключа PZ Выделение ШС в зону периметр
          let partition = dataDevice[newKeyYz] ? dataDevice[newKeyYz].value : ""; // С какого шлейфа начинать
          let resistanceMin = dataDevice[newKeyLeMin] ? dataDevice[newKeyLeMin].value / 10 : ""; // Нижнее сопротивление
          let resistanceMax = dataDevice[newKeyLeMax] ? dataDevice[newKeyLeMax].value / 10 : ""; // верхнее сопротивление
          let openDoor = dataDevice[newKeyLd] ? dataDevice[newKeyLd].value : ""; // открытая дверь
          let perimetr = dataDevice[newKeyPz] ? dataDevice[newKeyPz].value : ""; // периметр

          key_LM[numberLm] = {
            typeLm: type,
            delay: delay,
            partition: partition,
            resistanceMin: resistanceMin,
            resistanceMax: resistanceMax,
            openDoor: openDoor,
            perimetr: perimetr,
            thisLR: false,
            lrNumber: "",
          };
        }
      }
    }
    else if (deviceJSON.config[i].key.indexOf("lr") != -1) {
      key_RL_MAX = key_RL_MAX + 1;
      if (deviceJSON.config[i].subvalues[0].value != "0" && deviceJSON.config[i].subvalues[0].value != "") {
        let numberLm = deviceJSON.config[i].key.substring(2); // номер LM для создания объекта контрола
        let type = deviceJSON.config[i].subvalues[0].value; //Тип Шлейфа
        let delay = deviceJSON.config[i].subvalues[1].value; //Задержка Шлейфа
        // let version = deviceJSON.config[i].subvalues[1].value; // ВЕрсия ПО расширителя
        let newKeyYz = "yz" + numberLm; // СИнтезируем  название ключа YZ для получения привязки к разделу
        let newKeyLeMin = "le" + numberLm + "_0"; // СИнтезируем  название ключа LE для получения нижнего сопротивления
        let newKeyLeMax = "le" + numberLm + "_1"; // СИнтезируем  название ключа LE для получения верхнего сопротивления
        let newKeyLd = "ld" + numberLm; // СИнтезируем  название ключа LD для получения запрета постановки с открытой дверью
        let newKeyPz = "pz" + numberLm; // СИнтезируем  название ключа PZ Выделение ШС в зону периметр
        let partition = dataDevice[newKeyYz] && dataDevice[newKeyYz].value; // С какого шлейфа начинать
        let openDoor = dataDevice[newKeyLd] && dataDevice[newKeyLd].value; // открытая дверь
        let perimetr = dataDevice[newKeyPz] && dataDevice[newKeyPz].value; // периметр

        /* ПРОТЕСТИРОВАТЬ */
        // key_EXT[numberLm] = {
        //   typeLm: type,
        //   delay: delay,
        //   partition: partition,
        //   resistanceMin: false,
        //   resistanceMax: false,
        //   openDoor: openDoor,
        //   perimetr: perimetr,
        //   thisLR: true,
        //   lrNumber: "",
        // };

        key_LM[numberLm] = {
          typeLm: type,
          delay: delay,
          partition: partition,
          resistanceMin: false,
          resistanceMax: false,
          openDoor: openDoor,
          perimetr: perimetr,
          thisLR: true,
          lrNumber: "",
        };
        /* ПРОТЕСТИРОВАТЬ */
      }
    } else if (deviceJSON.config[i].key.indexOf("ra") != -1) {
      if (deviceJSON.config[i].subvalues[0].value !== "0" && deviceJSON.config[i].subvalues[0].value !== "") {
        let numberRa = deviceJSON.config[i].key.substring(2);
        key_ra[numberRa] = {
          subvalues: [
            {
              type: "SINGLE_ID",
              value: deviceJSON.config[i].subvalues[0].value,
              min: 0,
              max: 16,
              index: 1,
            },
            {
              type: "SINGLE_ID",
              value: deviceJSON.config[i].subvalues[1].value,
              min: 0,
              max: 16,
              index: 2,
            },
          ],
        };
      }
    }
  }
  searchKey_RA(); // поиск шлейфов расширителей
  render_searchKey_LM_LR(); //рендер шлейфов
}

function searchKey_LM_LR_pk4() {
  key_LM = {};
  key_EXT = {};
  key_ra = {}; // Проверить нужно ли
  key_RL_MIN = 0; // Отчищаем Шл. НАч.
  key_RL_MAX = 0; // Отчищаем Шл. НАч.
  //Ищем ключи RL - расширители
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("lm") != -1) {
      if (deviceJSON.config[i].subvalues[0].value != "0" && deviceJSON.config[i].subvalues[0].value != "") {
        let numberLm = deviceJSON.config[i].key.substring(2); // номер LM для создания объекта контрола
        if (numberLm > key_RL_MIN) {
          key_RL_MIN = numberLm;
        }
        if (DEVICEINFO[DEVICEMODEL].sensor >= numberLm) {
          // Проверка на кол-во шлейвов согласно таблице device.js

          let type = deviceJSON.config[i].subvalues[0].value; //Тип Шлейфа
          let delay = deviceJSON.config[i].subvalues[1].value; //Задержка Шлейфа
          // let version = deviceJSON.config[i].subvalues[1].value; // ВЕрсия ПО расширителя
          let newKeyYz = "yz" + numberLm; // СИнтезируем  название ключа YZ для получения привязки к разделу
          let newKeyLeMin = "le" + numberLm + "_0"; // СИнтезируем  название ключа LE для получения нижнего сопротивления
          let newKeyLeMax = "le" + numberLm + "_1"; // СИнтезируем  название ключа LE для получения верхнего сопротивления
          let newKeyLd = "ld" + numberLm; // СИнтезируем  название ключа LD для получения запрета постановки с открытой дверью
          let newKeyPz = "pz" + numberLm; // СИнтезируем  название ключа PZ Выделение ШС в зону периметр
          let keyLa = "la" + numberLm;
          let partition = dataDevice[newKeyYz] ? dataDevice[newKeyYz].value : ""; // С какого шлейфа начинать
          let nameLa = dataDevice[keyLa] ? dataDevice[keyLa].value : "";
          //let resistanceMin = dataDevice[newKeyLeMin].value / 10; // Нижнее сопротивление
          //let resistanceMax = dataDevice[newKeyLeMax].value / 10; // верхнее сопротивление
          //let openDoor = dataDevice[newKeyLd].value; // открытая дверь
          //let perimetr = dataDevice[newKeyPz].value; // периметр

          key_LM[numberLm] = {
            typeLm: type,
            delay: delay,
            partition: partition,
            thisLR: false,
            lrNumber: "",
            name: nameLa,
          };
        }
      }
    } else if (deviceJSON.config[i].key.indexOf("lr") != -1) {
      key_RL_MAX = key_RL_MAX + 1;
      if (deviceJSON.config[i].subvalues[0].value != "0" && deviceJSON.config[i].subvalues[0].value != "") {
        let numberLm = deviceJSON.config[i].key.substring(2); // номер LM для создания объекта контрола
        let type = deviceJSON.config[i].subvalues[0].value; //Тип Шлейфа
        let delay = deviceJSON.config[i].subvalues[1].value; //Задержка Шлейфа
        // let version = deviceJSON.config[i].subvalues[1].value; // ВЕрсия ПО расширителя
        let newKeyYz = "yz" + numberLm; // СИнтезируем  название ключа YZ для получения привязки к разделу
        let newKeyLeMin = "le" + numberLm + "_0"; // СИнтезируем  название ключа LE для получения нижнего сопротивления
        let newKeyLeMax = "le" + numberLm + "_1"; // СИнтезируем  название ключа LE для получения верхнего сопротивления
        let newKeyLd = "ld" + numberLm; // СИнтезируем  название ключа LD для получения запрета постановки с открытой дверью
        let newKeyPz = "pz" + numberLm; // СИнтезируем  название ключа PZ Выделение ШС в зону периметр
        let partition = dataDevice[newKeyYz] && dataDevice[newKeyYz].value; // С какого шлейфа начинать
        let openDoor = dataDevice[newKeyLd] && dataDevice[newKeyLd].value; // открытая дверь
        let perimetr = dataDevice[newKeyPz] && dataDevice[newKeyPz].value; // периметр
        let keyLb = "lb" + numberLm;
        let nameLb = dataDevice[keyLb] ? dataDevice[keyLb].value : "";

        key_EXT[numberLm] = {
          typeLm: type,
          delay: delay,
          partition: partition,
          resistanceMin: false,
          resistanceMax: false,
          openDoor: openDoor,
          perimetr: perimetr,
          thisLR: true,
          lrNumber: "",
          name: nameLb,
        };
      }
    } else if (deviceJSON.config[i].key.indexOf("ra") != -1) {
      if (deviceJSON.config[i].subvalues[0].value !== "0" && deviceJSON.config[i].subvalues[0].value !== "") {
        let numberRa = deviceJSON.config[i].key.substring(2);
        key_ra[numberRa] = {
          subvalues: [
            {
              type: "SINGLE_ID",
              value: deviceJSON.config[i].subvalues[0].value,
              min: 0,
              max: 16,
              index: 1,
            },
            {
              type: "SINGLE_ID",
              value: deviceJSON.config[i].subvalues[1].value,
              min: 0,
              max: 16,
              index: 2,
            },
          ],
        };
      }
    }
  }
  searchKey_RA(); // поиск шлейфов расширителей
  render_searchKey_LM_LR_pk4(); //рендер шлейфов
}
let key_ra = {};


function searchKey_RA() {
  //key_ra = {}; // Проверить нужно ли
  let ext_sections = {};
  for (i in key_ra) {
    let sum = parseInt(key_ra[i].subvalues[0].value);
    let start = parseInt(key_ra[i].subvalues[1].value);
    let autoSumm = sum + start;
    let n_number = 1;
    for (start; start < autoSumm; start++) {
      if (key_EXT[start]) {
        if (key_EXT[start].lrNumber != "undefined") {
          key_EXT[start].lrNumber = "(" + i + "-" + n_number + ")";
          key_LM[start] = key_EXT[start];
        }
      }

      n_number++;
      //lrNumber
    }
  }
}

function render_searchKey_LM_LR() {
  //Рендер Шлейфов
  listControls["lm"] = Control.create("LM_CONTROL", "lm", "tab_sensors_list", key_LM, "rm");
}

function render_searchKey_LM_LR_pk4() {
  //Рендер Шлейфов
  listControls["lm"] = Control.create("LM_CONTROL_pk4", "lm", "tab_sensors_pk4_table", key_LM, "rm");
}

function render_searchKey_XO() {
  //Рендер задержек разделов
  if (DEVICEMODEL.indexOf("208") != -1) {
    listControls["xo"] = Control.create("XO_CONTROL", "xo", "tab_sensors_delay_208", key_XO, "xo");
  } else if (DEVICEMODEL.slice(0, 5).indexOf("202") != -1) {
    listControls["xo"] = Control.create("XO_CONTROL", "xo", "tab_sensors_delay_208", key_XO, "xo");
  } else if (DEVICEMODEL.indexOf("281") != -1) {
    listControls["xo"] = Control.create("XO_CONTROL", "xo", "tab_sensors_delay", key_XO, "xo");
  } else if (DEVICEMODEL.indexOf("S2413") != -1) {
    listControls["xo"] = Control.create("XO_CONTROL", "xo", "tab_sensors_delay", key_XO, "xo");
  } else {
    listControls["xo"] = Control.create("XO_CONTROL", "xo", "tab_sensors_delay_pk4", key_XO, "Задержка на выход для:");
  }

}

function render_searchKey_OC() {
  //Рендер задержек разделов
  listControls["oo"] = Control.create("OC_CONTROL", "oo", "tab_ok_table", key_OC, "oo");
}

function render_searchKey_OCv2() {
  //Рендер задержек разделов
  listControls["oc"] = Control.create("OC_CONTROLv2", "oc", "tab_ok_table_v3", key_OC, "oc");
}
function render_searchKey_TA() {
  //Рендер задержек разделов
  listControls["ta"] = Control.create("OC_CONTROL_TA", "ta", "tab_ok_table_v3", key_TA, "ta");
}

function render_searchKey_XXAD() {
  //Рендер устройств РК
  listControls["xxad"] = Control.create("XXAD_CONTROL", "xxad", "tab_r_device_list", key_XXAD, "xxad");
}

function render_searchKey_SECTIONS() {
  //Рендер зон в разделы
  listControls["sections"] = Control.create("SECTIONS_CONTROL", "sections", "tab_section_list", list_zone, "sections");
  renderControl();
}

function render_searchKey_XXCC() {
  //Рендер частот РК
  listControls["xxcc"] = Control.create("XXCC_CONTROL", "xxcc", "tab_r_device_config", key_XXCC, "xxcc");
}

function render_searchKey_RL() {
  //Рендер Расширителей
  listControls["rl"] = Control.create("RL_CONTROL", "rl", "tab_main_three", key_RL, "rl");
}

function render_searchKey_RL_pk4() {
  //Рендер Расширителей
  listControls["rl"] = Control.create("RL_CONTROL_PK4", "rl", "tab_hw1", key_RL, "rl");
}

function render_searchKey_RL_RADIO() {
  //Рендер Расширителей
  listControls["rl"] = Control.create("RL_CONTROL_RADIO", "rl", "tab_main_three", key_RL, "rl");
}

function render_searchKey_EXT_RADIODEV() {
  //Рендер Расширителей
  listControls["rl"] = Control.create("RL_CONTROL_208_EXT", "rl", "tab_main_three", virtualExt, "rl");
}

function render_VIRTUAL_XXAD() {
  //Рендер устройств РК
  listControls["xxad"] = Control.create("XXAD_CONTROL", "xxad", "tab_r_device_list", virtualRadio, "xxad");
  if (VIEW_TLMTR_RKPS === "table") {
    listControls["xxad_tlmtr"] = Control.create(
      "XXAD_CONTROL_TELEMETRIYA",
      "xxad",
      "t_table_rkps_pro",
      virtualRadio,
      "xxad"
    ); //Телеметрия Таблица
  } else {
    listControls["xxad_tlmtr"] = Control.create(
      "XXAD_CONTROL_TELEMETRIYA_PRO",
      "xxad",
      "t_table_rkps_pro",
      virtualRadio,
      "xxad"
    ); // Телеметрия Плашки
  }

  update_rkps();
  //setTimeout("update_rkps()", 3000);
  check_mac_radio(); // проверка блокировок настроек для РК
}

function render_searchKey_SN() {
  listControls["sn"] = Control.create("SN_CONTROL", "sn", "tab_sms_phone", key_SO, "sn");
}

function render_searchKey_SN_KTS() {
  listControls["sn"] = Control.create("SN_CONTROL_KTS", "sn", "tab_sms_phone", key_SN, "sn");
}

function render_searchKey_SU() {
  listControls["su"] = Control.create("SU_CONTROL", "su", "tab_sms_phone_k", key_SU, "su");
}

function render_searchKey_OO() {
  const copyVirtualExe = JSON.parse(JSON.stringify(virtualExe))
  listControls["oo"] = Control.create("OO_CONTROL", "su", "tab_exe_list", copyVirtualExe/* .sort(compareVirtExe) */, "oo");
}

function render_searchKey_UA_UZ() {
  listControls["ua"] = Control.create("UA_CONTROL", "ua", "tab_keys_ua", key_UA_UZ, "ua");
}

let FINALAPPKEY = {};

function releseAppKey() {
  for (i in dataDevice) {
    if (i.indexOf("gs") != -1) {
      FINALAPPKEY.gs = { type: "TABLE_IP", key: i };
    }
  }
}

let key_SU = {}; //Номера телефонов дл отправки ключей взятия/снятия

function searchKey_SU() {
  //Ищем ключи SU - снятие-взятие смс
  key_SU = {};

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("su") != -1) {
      if (deviceJSON.config[i].key.charAt(0) != "x") {
        // проверка на XXSU
        let numberSU = deviceJSON.config[i].key.substring(2); // номер RL для создания объекта контрола
        let sections = deviceJSON.config[i].subvalues[0].value; // номера кодов
        let phone = deviceJSON.config[i].subvalues[1].value; // Номер телефона

        key_SU[numberSU] = { sections: sections, phone: phone };
      }
    }
  }
  render_searchKey_SU(); //рендер номеровв телефона
}

function searchKey_OO() {
  //Ищем ключи SU - снятие-взятие смс
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("su") != -1) {
      if (deviceJSON.config[i].key.charAt(0) != "x") {
        // проверка на XXSU
      }
    }
  }
  render_searchKey_OO(); //рендер номеровв телефона
}

let key_SN = {}; //Номера телефонов дл отправки ключей
let key_SO = {}; //Номера телефонов дл отправки ключей
function searchKey_SN() {
  //Ищем ключи RL - расширители
  key_SN = {};
  key_SO = {};

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("sn") != -1) {
      let numberSN = deviceJSON.config[i].key.substring(2); // номер RL для создания объекта контрола
      let mode = deviceJSON.config[i].subvalues[0].value; // Режим использования телефона
      let phone = deviceJSON.config[i].subvalues[1].value; // Номер телефона

      key_SN[numberSN] = { mode: mode, phone: phone };
    } else if (deviceJSON.config[i].key.indexOf("so") != -1) {
      let numberSO = deviceJSON.config[i].key.substring(2); // номер SO для смс
      let sms = deviceJSON.config[i].subvalues[0].value; // испоьзуеммые типы смс для отправки смс
      let sections = deviceJSON.config[i].subvalues[1].value; // привязка разделов к отправке смс на номера

      key_SO[numberSO] = { sms: sms, sections: sections };
    }
  }
  render_searchKey_SN(); //рендер номеровв телефона
}

function searchKey_SN_KTS() {
  //Ищем ключи RL - расширители
  key_SN = {};
  key_SO = {};

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("sn") != -1) {
      let numberSN = deviceJSON.config[i].key.substring(2);
      let mode = deviceJSON.config[i].subvalues[0].value;
      let phone = deviceJSON.config[i].subvalues[1].value;

      key_SN[numberSN] = { mode: mode, phone: phone };
    }
  }
  render_searchKey_SN_KTS(); //рендер номеровв телефона
}

function searchKey_GS4() {
  // поиск UP/udp по три для кгс для каждой симкарты
  groupControl["gs1"] = dataDevice["gs1_0"]
    ? { ip: dataDevice["gs1_0"].value, udp: dataDevice["gs1_1"].value }
    : { ip: "", udp: "" };
  groupControl["gs2"] = dataDevice["gs2_0"]
    ? { ip: dataDevice["gs2_0"].value, udp: dataDevice["gs2_1"].value }
    : { ip: "", udp: "" };
  groupControl["gs3"] = dataDevice["gs3_0"]
    ? { ip: dataDevice["gs3_0"].value, udp: dataDevice["gs3_1"].value }
    : { ip: "", udp: "" };
  groupControl["gs4"] = dataDevice["gs4_0"]
    ? { ip: dataDevice["gs4_0"].value, udp: dataDevice["gs4_1"].value }
    : { ip: "", udp: "" };

  render_searchKey_GS4();
}

function render_searchKey_GS4() {
  // вычищаем из doma GS6
  document.getElementById("tab_sim_01_ipUdp1").innerHTML = "";
  document.getElementById("tab_sim_01_ipUdp2").innerHTML = "";
  document.getElementById("tab_sim_01_ipUdp3").innerHTML = "";
  document.getElementById("tab_sim_02_ipUdp4").innerHTML = "";
  document.getElementById("tab_sim_02_ipUdp5").innerHTML = "";
  document.getElementById("tab_sim_02_ipUdp6").innerHTML = "";

  for (i in groupControl) {
    if (i.indexOf("gs1") != -1) {
      listControls[i] = Control.create("GS_CONTROL", i, "tab_sim_1_ipUdp1", groupControl[i], i);
    } else if (i.indexOf("gs2") != -1) {
      listControls[i] = Control.create("GS_CONTROL", i, "tab_sim_1_ipUdp2", groupControl[i], i);
    } else if (i.indexOf("gs3") != -1) {
      listControls[i] = Control.create("GS_CONTROL", i, "tab_sim_2_ipUdp3", groupControl[i], i);
    } else if (i.indexOf("gs4") != -1) {
      listControls[i] = Control.create("GS_CONTROL", i, "tab_sim_2_ipUdp4", groupControl[i], i);
    } else {
    }
  }
}

function searchKey_GS6() {
  // поиск UP/udp по три для кгс для каждой симкарты
  dataDevice["gs1_0"] ? (groupControl["gs1"] = { ip: dataDevice["gs1_0"].value, udp: dataDevice["gs1_1"].value }) : "";
  dataDevice["gs2_0"] ? (groupControl["gs2"] = { ip: dataDevice["gs2_0"].value, udp: dataDevice["gs2_1"].value }) : "";
  dataDevice["gs3_0"] ? (groupControl["gs3"] = { ip: dataDevice["gs3_0"].value, udp: dataDevice["gs3_1"].value }) : "";
  dataDevice["gs4_0"] ? (groupControl["gs4"] = { ip: dataDevice["gs4_0"].value, udp: dataDevice["gs4_1"].value }) : "";
  dataDevice["gs5_0"] ? (groupControl["gs5"] = { ip: dataDevice["gs5_0"].value, udp: dataDevice["gs5_1"].value }) : "";
  dataDevice["gs6_0"] ? (groupControl["gs6"] = { ip: dataDevice["gs6_0"].value, udp: dataDevice["gs6_1"].value }) : "";

  render_searchKey_GS6();
}

function render_searchKey_GS6() {
  // вычищаем из doma GS4
  document.getElementById("tab_sim_1_ipUdp1").innerHTML = "";
  document.getElementById("tab_sim_1_ipUdp2").innerHTML = "";
  document.getElementById("tab_sim_2_ipUdp3").innerHTML = "";
  document.getElementById("tab_sim_2_ipUdp4").innerHTML = "";

  for (i in groupControl) {
    if (i.indexOf("gs1") != -1) {
      listControls[i] = Control.create("GS_CONTROL", i, "tab_sim_01_ipUdp1", groupControl[i], i);
    } else if (i.indexOf("gs2") != -1) {
      listControls[i] = Control.create("GS_CONTROL", i, "tab_sim_01_ipUdp2", groupControl[i], i);
    } else if (i.indexOf("gs3") != -1) {
      listControls[i] = Control.create("GS_CONTROL", i, "tab_sim_01_ipUdp3", groupControl[i], i);
    } else if (i.indexOf("gs4") != -1) {
      listControls[i] = Control.create("GS_CONTROL", i, "tab_sim_02_ipUdp4", groupControl[i], i);
    } else if (i.indexOf("gs5") != -1) {
      listControls[i] = Control.create("GS_CONTROL", i, "tab_sim_02_ipUdp5", groupControl[i], i);
    } else if (i.indexOf("gs6") != -1) {
      listControls[i] = Control.create("GS_CONTROL", i, "tab_sim_02_ipUdp6", groupControl[i], i);
    } else {
    }
  }
}

function searchKey_GPRS_pk4() {
  // поиск UP/udp по три для кгс для каждой симкарты
  groupControl["gs1"] = {
    ip: dataDevice["gs1_0"] ? dataDevice["gs1_0"].value : errorCore("gs1"),
    udp: dataDevice["gs1_1"] ? dataDevice["gs1_1"].value : errorCore("gs1"),
  };
  groupControl["gs2"] = {
    ip: dataDevice["gs2_0"] ? dataDevice["gs2_0"].value : errorCore("gs2"),
    udp: dataDevice["gs2_1"] ? dataDevice["gs2_1"].value : errorCore("gs2"),
  };
  groupControl["gs3"] = {
    ip: dataDevice["gs3_0"] ? dataDevice["gs3_0"].value : errorCore("gs3"),
    udp: dataDevice["gs3_1"] ? dataDevice["gs3_1"].value : errorCore("gs3"),
  };
  groupControl["gs4"] = {
    ip: dataDevice["gs4_0"] ? dataDevice["gs4_0"].value : errorCore("gs4"),
    udp: dataDevice["gs4_1"] ? dataDevice["gs4_1"].value : errorCore("gs4"),
  };
  groupControl["gs5"] = {
    ip: dataDevice["gs5_0"] ? dataDevice["gs5_0"].value : errorCore("gs5"),
    udp: dataDevice["gs5_1"] ? dataDevice["gs5_1"].value : errorCore("gs5"),
  };
  groupControl["gs6"] = {
    ip: dataDevice["gs6_0"] ? dataDevice["gs6_0"].value : errorCore("gs6"),
    udp: dataDevice["gs6_1"] ? dataDevice["gs6_1"].value : errorCore("gs6"),
  };

  render_searchKey_GPRS_pk4();
}

function render_searchKey_GPRS_pk4() {
  // вычищаем из doma GS4
  if (document.getElementById("tab_sim_1_ipUdp1_pk4")) document.getElementById("tab_sim_1_ipUdp1_pk4").innerHTML = "";
  if (document.getElementById("tab_sim_1_ipUdp2_pk4")) document.getElementById("tab_sim_1_ipUdp2_pk4").innerHTML = "";
  if (document.getElementById("tab_sim_1_ipUdp3_pk4")) document.getElementById("tab_sim_1_ipUdp3_pk4").innerHTML = "";
  if (document.getElementById("tab_sim_2_ipUdp4_pk4")) document.getElementById("tab_sim_2_ipUdp4_pk4").innerHTML = "";
  if (document.getElementById("tab_sim_2_ipUdp5_pk4")) document.getElementById("tab_sim_2_ipUdp5_pk4").innerHTML = "";
  if (document.getElementById("tab_sim_2_ipUdp6_pk4")) document.getElementById("tab_sim_2_ipUdp6_pk4").innerHTML = "";

  for (i in groupControl) {
    if (i.indexOf("gs1") != -1) {
      listControls[i] = Control.create("GS_CONTROL", i, "tab_sim_01_ipUdp1_pk4", groupControl[i], i);
    } else if (i.indexOf("gs2") != -1) {
      listControls[i] = Control.create("GS_CONTROL", i, "tab_sim_01_ipUdp2_pk4", groupControl[i], i);
    } else if (i.indexOf("gs3") != -1) {
      listControls[i] = Control.create("GS_CONTROL", i, "tab_sim_01_ipUdp3_pk4", groupControl[i], i);
    } else if (i.indexOf("gs4") != -1) {
      listControls[i] = Control.create("GS_CONTROL", i, "tab_sim_02_ipUdp4_pk4", groupControl[i], i);
    } else if (i.indexOf("gs5") != -1) {
      listControls[i] = Control.create("GS_CONTROL", i, "tab_sim_02_ipUdp5_pk4", groupControl[i], i);
    } else if (i.indexOf("gs6") != -1) {
      listControls[i] = Control.create("GS_CONTROL", i, "tab_sim_02_ipUdp6_pk4", groupControl[i], i);
    } else {
    }
  }
}

let key_XXAD = {}; // список радикал устройств
let list_section = {}; // список разделов для РК

function create_default_section() {
  for (var i = 1; i <= DEVICEINFO[DEVICEMODEL].sections; i++) {
    list_section[i] = { free: null, type: "", sensors: [] };
  }
}

function searchKey_XXAD() {
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("xxad") != -1) {
      if (deviceJSON.config[i].subvalues[0].value == " ") {
        deviceJSON.config[i].subvalues[0].value = "";
      }
      if (deviceJSON.config[i].subvalues[1].value == " ") {
        deviceJSON.config[i].subvalues[1].value = "";
      }
    }

    if (deviceJSON.config[i].key.indexOf("lw") != -1) {
      if (deviceJSON.config[i].subvalues[0].value == "0") {
        deviceJSON.config[i].subvalues[0].value = "";
      }
      if (deviceJSON.config[i].subvalues[1].value == "0") {
        deviceJSON.config[i].subvalues[1].value = "";
      }
      if (deviceJSON.config[i].subvalues[2].value == "0") {
        deviceJSON.config[i].subvalues[2].value = "";
      }
    }
  }
  //Ищем ключи XXAD - радиоустройства
  key_XXAD = {}; // Обнуляем список устрйоств
  list_zone = {}; // Обнуляем список зон
  list_section = {}; // Обнуляем список разделов

  create_default_section(); // запускаем генератор шаблона разделов
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("xxad") != -1) {
      if (deviceJSON.config[i].key != "xxad0") {
        let numberXXAD = deviceJSON.config[i].key.substring(4); // номер XXAD устройства
        let f1 = deviceJSON.config[i].subvalues[0].value;
        let f2 = deviceJSON.config[i].subvalues[1].value;
        let f3 = deviceJSON.config[i].subvalues[2].value;
        let display = false;
        if (f1 != "0") {
          display = true;
          if (f2 == "15231" || f2 == "15230" || f2 == "15130" || f2 == "15830") {
            // Если имя пустое то дисплей фолс
            display = true;
            zone_create_list(deviceJSON.config[i]); //Передаем данные в генератор зон
          }
        }

        key_XXAD[numberXXAD] = { type: f1, name: f2, serial: f3, display: display };
      }
    } else if (deviceJSON.config[i].key.indexOf("yz") != -1) {
      section_create_list(deviceJSON.config[i]); //Передаем данные в генератор разделов
    }
  }
  render_searchKey_XXAD(); //рендер радиоустройств
}

let key_XXCC = {};

function searchKey_XXCC() {
  //Ищем ключи XXCC - настройка рабочих радиоканалов
  key_XXCC = {};
  key_XXCC[0] = { first: null, second: null };
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("xxcc") != -1) {
      let first = deviceJSON.config[i].subvalues[0].value;
      let second = deviceJSON.config[i].subvalues[1].value;

      key_XXCC[0] = { first: first, second: second };
    }
  }
  render_searchKey_XXCC(); //рендер радиоканалов
}

function searchKey_zr() {
  //Ищем ключи XXCC - настройка рабочих радиоканалов
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("xxcc") != -1) {
      let first = deviceJSON.config[i].subvalues[0].value;
      let second = deviceJSON.config[i].subvalues[1].value;

      key_XXCC[0] = { first: first, second: second };
    }
  }
  //render_searchKey_zr(); //рендер радиоканалов
}

let virtualZone = []; // Таблица зон
let virtualRadio = []; // Таблица радиоканальных устройств
let virtualExt = []; // Таблица Расширителей
let virtualExe = []; // Таблица Исполнительных устройств
let virtualExeAll = [];

function createVirtualTable() {
  // генерация таблиц зон, радиоустройств, расширителей, выходов управления для 208х

  virtualZone = [];
  virtualRadio = [];
  virtualExt = [];
  virtualExe = [];
  virtualExeAll = [];
  key_OC = {};

  // if (DEVICEMODEL.indexOf("208") != -1) {
  //   // Встроенная виртуальная зона
  //   // virtualZone.push({
  //   //     "typeDev": "integral",
  //   //     "numberZone": '1',
  //   //     "link": 'integral_1',
  //   //     "model": 'integral_1',
  //   //     "index": "1",
  //   //     "type": dataDevice['lw1_0'] ? dataDevice['lw1_0'].value : errorCore('lw1'),
  //   //     "param": dataDevice['lw1_1'] ? dataDevice['lw1_1'].value : errorCore('lw1'),
  //   //     "delay": dataDevice['lw1_2'] ? dataDevice['lw1_2'].value : errorCore('lw1'),
  //   //     "section": dataDevice['yz1'] ? dataDevice['yz1'].value : errorCore('yz1'),
  //   //     "name": dataDevice['lb1'] ? dataDevice['lb1'].value : errorCore('lb1')
  //   // });

  //   // Встроеное исполнительное устройство
  //   for (i in deviceJSON.config) {
  //     if (deviceJSON.config[i].key.indexOf("oh") != -1) {
  //       if (deviceJSON.config[i].subvalues[0].value !== "0") {
  //         let integralExeArr = deviceJSON.config[i].subvalues[1].value
  //           ? deviceJSON.config[i].subvalues[1].value.split(",")
  //           : [];
  //         for (var z = 0; z < integralExeArr.length; z++) {
  //           virtualExe.push({
  //             typeDev: "integralExe",
  //             numberExe: integralExeArr[z],
  //             link: "integral_" + integralExeArr[z],
  //             model: "integral_" + integralExeArr[z],
  //             index: integralExeArr[z],
  //             type: dataDevice["oo" + integralExeArr[z] + "_0"] ? dataDevice["oo" + integralExeArr[z] + "_0"].value : null,
  //             delay: dataDevice["oo" + integralExeArr[z] + "_1"] ? dataDevice["oo" + integralExeArr[z] + "_1"].value : null,
  //             section: null,
  //             name: dataDevice["lb1"] ? dataDevice["lb1"].value : null,
  //             activeSections: dataDevice["oq" + integralExeArr[z] + ""] ? dataDevice["oq" + integralExeArr[z] + ""].value : null,
  //             ktc: dataDevice["or" + integralExeArr[z] + ""] ? dataDevice["or" + integralExeArr[z] + ""].value : null,
  //             oppening: dataDevice["ob" + integralExeArr[z] + ""] ? dataDevice["ob" + integralExeArr[z] + ""].value : null,
  //             gas: dataDevice["og" + integralExeArr[z] + ""] ? dataDevice["og" + integralExeArr[z] + ""].value : null,
  //             water: dataDevice["ot" + integralExeArr[z] + ""] ? dataDevice["ot" + integralExeArr[z] + ""].value : null,
  //             fire: dataDevice["of" + integralExeArr[z] + ""] ? dataDevice["of" + integralExeArr[z] + ""].value : null,
  //             notification: dataDevice["nf" + integralExeArr[z] + ""] ? dataDevice["nf" + integralExeArr[z] + ""].value : null,
  //           });
  //         }

  //       }
  //     }
  //   }
  // }
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("xxdr") != -1) {
      // РК
      let numberZone;
      if (deviceJSON.config[i].subvalues[0].value !== "0" && deviceJSON.config[i].subvalues[0].value != "") {
        numberZone = deviceJSON.config[i].subvalues[0].value;
        virtualZone.push({
          typeDev: "rad",
          numberZone: numberZone,
          link: deviceJSON.config[i].key,
          model: dataDevice["xxad" + deviceJSON.config[i].key.slice(4) + "_1"].value,
          index: "1",
          type: dataDevice["lw" + numberZone + "_0"].value,
          param: dataDevice["lw" + numberZone + "_1"].value,
          delay: dataDevice["lw" + numberZone + "_2"]
            ? searchDelayExit(dataDevice["lw" + numberZone + "_2"], "entry")
            : null,
          delayExit: dataDevice["lw" + numberZone + "_2"]
            ? searchDelayExit(dataDevice["lw" + numberZone + "_2"], "exit")
            : null,

          section: dataDevice["yz" + numberZone].value,
          name: dataDevice["lb" + numberZone] ? dataDevice["lb" + numberZone].value : "",
        });
      }

      if (deviceJSON.config[i].subvalues[1].value !== "0") {
        numberZone = deviceJSON.config[i].subvalues[1].value;
        virtualZone.push({
          typeDev: "rad",
          numberZone: numberZone,
          link: deviceJSON.config[i].key,
          model: dataDevice["xxad" + deviceJSON.config[i].key.slice(4) + "_1"].value,
          index: "2",
          type: dataDevice["lw" + numberZone + "_0"].value,
          param: dataDevice["lw" + numberZone + "_1"].value,
          delay: dataDevice["lw" + numberZone + "_2"]
            ? searchDelayExit(dataDevice["lw" + numberZone + "_2"], "entry")
            : null,
          delayExit: dataDevice["lw" + numberZone + "_2"]
            ? searchDelayExit(dataDevice["lw" + numberZone + "_2"], "exit")
            : null,
          section: dataDevice["yz" + numberZone].value,
          name: dataDevice["lb" + numberZone] ? dataDevice["lb" + numberZone].value : "",
        });
      }
    }
    else if (deviceJSON.config[i].key.indexOf("zs") != -1) {
      // Пушим ввстроеные зоны прибора
      if (deviceJSON.config[i].subvalues[0].value != "0" && deviceJSON.config[i].subvalues[0].value != "") {
        let integralZoneArr = deviceJSON.config[i].subvalues[1].value
          ? deviceJSON.config[i].subvalues[1].value.split(",")
          : [];
        for (var z = 0; z < integralZoneArr.length; z++) {
          virtualZone.push({
            typeDev: "integral",
            numberZone: integralZoneArr[z],
            link: "integral_" + integralZoneArr[z],
            model: "integral_" + integralZoneArr[z],
            index: integralZoneArr[z],
            type: dataDevice["lw" + integralZoneArr[z] + "_0"]
              ? dataDevice["lw" + integralZoneArr[z] + "_0"].value
              : errorCore("lw" + integralZoneArr[z]),
            param: dataDevice["lw" + integralZoneArr[z] + "_1"]
              ? dataDevice["lw" + integralZoneArr[z] + "_1"].value
              : errorCore("lw" + integralZoneArr[z]),
            delay: dataDevice["lw" + integralZoneArr[z] + "_2"]
              ? searchDelayExit(dataDevice["lw" + integralZoneArr[z] + "_2"], "entry")
              : errorCore("lw" + integralZoneArr[z]),
            section: dataDevice["yz" + integralZoneArr[z]] ? dataDevice["yz" + integralZoneArr[z]].value : '1'/* dataDevice["yz" + integralZoneArr[z]] //изменил на 1, что бы встроенная зона всегда отображалась в Разделах, даже при 0 зоне.
              ? dataDevice["yz" + integralZoneArr[z]].value
              : errorCore("yz" + integralZoneArr[z]) */,
            name: dataDevice["lb" + integralZoneArr[z]]
              ? dataDevice["lb" + integralZoneArr[z]].value
              : errorCore("lb" + integralZoneArr[z]),
            delayExit: dataDevice["lw" + integralZoneArr[z] + "_2"]
              ? searchDelayExit(dataDevice["lw" + integralZoneArr[z] + "_2"], "exit")
              : errorCore("lw" + integralZoneArr[z]),
          });
        }
      }
    }
    else if (deviceJSON.config[i].key.indexOf("zr") != -1) {
      // РШ
      let numberKey = deviceJSON.config[i].key.slice(2);
      let numberArrZone = [];
      if (deviceJSON.config[i].subvalues[0].value !== "0" && deviceJSON.config[i].subvalues[0].value != "") {
        numberArrZone = deviceJSON.config[i].subvalues[1].value.split(",");

        for (var k = 0; k < numberArrZone.length; k++) {
          let index = k + 1 + "";
          numberZone = numberArrZone[k];


          virtualZone.push({
            typeDev: "ext",
            numberZone: numberZone,
            link: deviceJSON.config[i].key,
            model: dataDevice["rl" + numberKey + "_0"].value,
            index: index,
            type: dataDevice["lw" + numberZone + "_0"] && dataDevice["lw" + numberZone + "_0"].value, //?
            param: dataDevice["lw" + numberZone + "_1"] && dataDevice["lw" + numberZone + "_1"].value,//?
            delay: dataDevice["lw" + numberZone + "_2"] && dataDevice["lw" + numberZone + "_2"].value//?
              ? searchDelayExit(dataDevice["lw" + numberZone + "_2"], "entry")
              : '',
            delayExit: numberZone === '0' ? '' : dataDevice["lw" + numberZone + "_2"] && dataDevice["lw" + numberZone + "_2"].value
              ? searchDelayExit(dataDevice["lw" + numberZone + "_2"], "exit")
              : '',
            section: numberZone === '0' ? null : dataDevice["yz" + numberZone] && dataDevice["yz" + numberZone].value,
            // name: numberZone === '0' ? 'Отключен' : dataDevice["lb" + numberZone].value
            name: dataDevice["lb" + numberZone] ? dataDevice["lb" + numberZone].value : ""
          });
        }
      }
      // else if (deviceJSON.config[i].subvalues[0].value === 0) {
      //   virtualZone.push({
      //     typeDev: "ext",
      //     numberZone: numberZone,
      //     link: deviceJSON.config[i].key,
      //     model: dataDevice["rl" + numberKey + "_0"].value,
      //     index: index,
      //     type: null,
      //     param: null,
      //     delay: null,
      //     delayExit: null,
      //     section: null,
      //     name: null,
      //   });
      // }
    } else if (deviceJSON.config[i].key.indexOf("xxad") != -1) {
      if (deviceJSON.config[i].key !== "xxad0") {
        let numberRadio = deviceJSON.config[i].key.slice(4);
        let nameLink = "xxdr" + numberRadio;
        let xxss = "xxss" + numberRadio;

        if (deviceJSON.config[i].subvalues[1].value !== "" && deviceJSON.config[i].subvalues[1].value !== "0") {
          virtualRadio.push({
            status: dataDevice["xxpg" + numberRadio] && dataDevice["xxpg" + numberRadio].value,
            type: deviceJSON.config[i].subvalues[0].value,
            numberRadio: numberRadio,
            name: deviceJSON.config[i].subvalues[1].value,
            serial: deviceJSON.config[i].subvalues[2].value,
            address: deviceJSON.config[i].subvalues[3].value,
            link: nameLink,
            zone_1: dataDevice[nameLink + "_0"].value,
            zone_2: dataDevice[nameLink + "_1"].value,
            SS: dataDevice[xxss].value,
            activeSections: dataDevice["xxkb" + numberRadio[i]]
              ? dataDevice["xxkb" + numberRadio[i]].value
              : errorCore("xxkb" + numberRadio[i]),
            PV: deviceJSON.config[i].subvalues[0].value === "70" ? search_PV(numberRadio) : false,
            RV: deviceJSON.config[i].subvalues[0].value === "70" ? search_RV(numberRadio) : false,
          });

          rkps_device[numberRadio] = {
            type: deviceJSON.config[i].subvalues[0].value,
            numberRadio: numberRadio,
            name: deviceJSON.config[i].subvalues[1].value,
            serial: deviceJSON.config[i].subvalues[2].value,
            link: nameLink,
            zone_1: dataDevice[nameLink + "_0"].value,
            zone_2: dataDevice[nameLink + "_1"].value,
            SS: dataDevice[xxss].value,
            PV: false,
            RV: false,
          };
        }
      }
    }
    else if (deviceJSON.config[i].key.indexOf("rl") != -1) {
      if (deviceJSON.config[i].subvalues[0].value !== "0" && deviceJSON.config[i].subvalues[0].value != "") {
        let nameExt = deviceJSON.config[i].key.slice(2);
        let ext = {};

        if (deviceJSON.config[i].subvalues[0].value == "4") {
          let listOe = [];
          listOe = dataDevice["oe" + nameExt + "_1"] ? dataDevice["oe" + nameExt + "_1"].value.split(",") : []; // debug ??
          ext = {
            number: nameExt,
            //"type": RS485_RADIO[deviceJSON.config[i].subvalues[0].value],
            type: RS485[deviceJSON.config[i].subvalues[0].value].title,
            soft: deviceJSON.config[i].subvalues[1].value,
            sections: dataDevice["zr" + nameExt + "_0"] ? dataDevice["zr" + nameExt + "_0"].value : null,
            link: "zr" + nameExt,
            model: RS485_LIST[deviceJSON.config[i].subvalues[0].value],
            indexRS: deviceJSON.config[i].subvalues[0].value,
            exe: [],
          };
          for (var k = 0; k < listOe.length; k++) {
            let exeDev = {
              typeDev: "cabel",
              numberExe: listOe[k],
              parentExeNumber: nameExt,
              numberIndexExe: k + 1,
              link: deviceJSON.config[i].key.slice(2),
              model: null,
              index: listOe[k],
              type: dataDevice["oo" + listOe[k] + "_0"] ? dataDevice["oo" + listOe[k] + "_0"].value : null,
              delay: dataDevice["oo" + listOe[k] + "_1"] ? dataDevice["oo" + listOe[k] + "_1"].value : null,
              section: null,
              name: dataDevice["lb1"] ? dataDevice["lb1"].value : null,
              activeSections: dataDevice["oq" + listOe[k] + ""] ? dataDevice["oq" + listOe[k] + ""].value : null,
              ktc: dataDevice["or" + listOe[k] + ""] ? dataDevice["or" + listOe[k] + ""].value : null,
              oppening: dataDevice["ob" + listOe[k] + ""] ? dataDevice["ob" + listOe[k] + ""].value : null,
              gas: dataDevice["og" + listOe[k] + ""] ? dataDevice["og" + listOe[k] + ""].value : null,
              water: dataDevice["ot" + listOe[k] + ""] ? dataDevice["ot" + listOe[k] + ""].value : null,
              fire: dataDevice["of" + listOe[k] + ""] ? dataDevice["of" + listOe[k] + ""].value : null,
              notification: dataDevice["nf" + listOe[k] + ""] ? dataDevice["nf" + listOe[k] + ""].value : null,
            };

            ext.exe.push(exeDev); // Пушим Исполнительные устройства Расширителей в
            virtualExe.push(exeDev); // Пушим Исполнительные устройства Расширителей в ИСПОЛНИТЕЛЬНЫЕ УСТРОЙСТВА
          }
        } else {
          ext = {
            number: nameExt,
            //"type": RS485_RADIO[deviceJSON.config[i].subvalues[0].value],
            type: RS485[deviceJSON.config[i].subvalues[0].value].title,
            soft: deviceJSON.config[i].subvalues[1].value,
            sections: dataDevice["zr" + nameExt + "_0"].value,
            link: "zr" + nameExt,
            model: RS485_LIST[deviceJSON.config[i].subvalues[0].value],
            indexRS: deviceJSON.config[i].subvalues[0].value,
            exe: [],
            startSection: dataDevice["rk" + nameExt + "_0"] ? dataDevice["rk" + nameExt + "_0"].value : "",
          };
        }
        virtualExt.push(ext);
      }
    }
    else if (deviceJSON.config[i].key.indexOf("oo") != -1) {
      // Создаем таблицу с максимальным кол-вом доступных ВУ
      let oo_exe = { numberExe: deviceJSON.config[i].key.slice(2), numberDeviceExe: "", type: "", temp: false };
      virtualExeAll.push(oo_exe);
    }
    else if (deviceJSON.config[i].key.indexOf("oh") != -1) {
      if (deviceJSON.config[i].subvalues[0].value !== "0" && deviceJSON.config[i].subvalues[0].value != "") {
        let integralExeArr = deviceJSON.config[i].subvalues[1].value
          ? deviceJSON.config[i].subvalues[1].value.split(",")
          : [];
        for (var z = 0; z < integralExeArr.length; z++) {
          virtualExe.push({
            typeDev: "integralExe",
            numberExe: integralExeArr[z],
            link: "integral_" + integralExeArr[z],
            model: "integral_" + integralExeArr[z],
            index:  z ,
            type: dataDevice["oo" + integralExeArr[z] + "_0"] ? dataDevice["oo" + integralExeArr[z] + "_0"].value : null,
            delay: dataDevice["oo" + integralExeArr[z] + "_1"] ? dataDevice["oo" + integralExeArr[z] + "_1"].value : null,
            section: null,
            name: dataDevice["lb1"] ? dataDevice["lb1"].value : null,
            activeSections: dataDevice["oq" + integralExeArr[z] + ""] ? dataDevice["oq" + integralExeArr[z] + ""].value : null,
            ktc: dataDevice["or" + integralExeArr[z] + ""] ? dataDevice["or" + integralExeArr[z] + ""].value : null,
            oppening: dataDevice["ob" + integralExeArr[z] + ""] ? dataDevice["ob" + integralExeArr[z] + ""].value : null,
            gas: dataDevice["og" + integralExeArr[z] + ""] ? dataDevice["og" + integralExeArr[z] + ""].value : null,
            water: dataDevice["ot" + integralExeArr[z] + ""] ? dataDevice["ot" + integralExeArr[z] + ""].value : null,
            fire: dataDevice["of" + integralExeArr[z] + ""] ? dataDevice["of" + integralExeArr[z] + ""].value : null,
            notification: dataDevice["nf" + integralExeArr[z] + ""] ? dataDevice["nf" + integralExeArr[z] + ""].value : null,
          });
        }

      }
    }
  }

  // Заполняем таблицу с ВУ



  for (var k = 0; k < virtualExeAll.length; k++) {
    for (var i = 0; i < virtualRadio.length; i++) {
      // Радиорканальные ВУ
      if (virtualRadio[i].PV[0] == virtualExeAll[k].numberExe || virtualRadio[i].RV[0] == virtualExeAll[k].numberExe) {
        virtualExeAll[k].numberDeviceExe = virtualRadio[i].numberRadio;
        virtualExeAll[k].type = "radio";
        break;
      }
    }
    for (var i = 0; i < virtualExt.length; i++) {
      // Проводные ВУ
      for (var z = 0; z < virtualExt[i].exe.length; z++) {
        if (virtualExt[i].exe[z].numberExe == virtualExeAll[k].numberExe) {
          virtualExeAll[k].numberDeviceExe = virtualExt[i].exe[z].parentExeNumber;
          virtualExeAll[k].type = "cabel";
        }
      }
    }

    if (dataDevice["oh_1"]) {
      if (dataDevice["oh_1"].value == virtualExeAll[k].numberExe) {
        virtualExeAll[k].numberDeviceExe = "1";
        virtualExeAll[k].type = "integralExe";
      }
    }
  }


  render_searchKey_EXT_RADIODEV();
  createVirtualSection(); // создание структуры разделов
}

function searchDelayExit(data, delay) {
  // Определяем задержку на вход/выход

  if (data.value.indexOf(",") != -1) {
    let delayEntry = data.value.split(",")[0];
    let delayExit = data.value.split(",")[1];
    switch (delay) {
      case "entry":
        return delayEntry;
        break;
      case "exit":
        return delayExit;
        break;

      default:
        console.log("Не задан тип задержки зоны");
        break;
    }
  } else {

    console.log("Прошивка прибора не поддерживает задержку зон на выход");
    return null;
  }
}

function search_PV(index) {
  // Потенциальные выходы РИУ
  let key = "xxnu" + index + "_1";
  let howPV = dataDevice["xxnu" + index + "_0"] ? dataDevice["xxnu" + index + "_0"].value : "";
  let numberPV = dataDevice["xxnu" + index + "_1"] ? dataDevice["xxnu" + index + "_1"].value.split(",") : "";
  let max;

  for (var i = 0; i < numberPV.length; i++) {
    // Таблица ВУ
    virtualExe.push({
      typeDev: "radio",
      numberExe: numberPV[i],
      link: index,
      model: "7620",
      index: "1",
      type: dataDevice["oo" + numberPV[i] + "_0"]
        ? dataDevice["oo" + numberPV[i] + "_0"].value
        : errorCore("oo" + numberPV[i]),
      delay: dataDevice["oo" + numberPV[i] + "_1"]
        ? dataDevice["oo" + numberPV[i] + "_1"].value
        : errorCore("oo" + numberPV[i]),
      section: dataDevice["yz1"] ? dataDevice["yz1"].value : errorCore("yz1"),
      name: "",
      activeSections: dataDevice["oq" + numberPV[i]]
        ? dataDevice["oq" + numberPV[i]].value
        : errorCore("oq" + numberPV[i]),
      ktc: dataDevice["or" + numberPV[i]] ? dataDevice["or" + numberPV[i]].value : errorCore("or" + numberPV[i]),
      oppening: dataDevice["ob" + numberPV[i]] ? dataDevice["ob" + numberPV[i]].value : errorCore("ob" + numberPV[i]),
      gas: dataDevice["og" + numberPV[i]] ? dataDevice["og" + numberPV[i]].value : errorCore("og" + numberPV[i]),
      water: dataDevice["ot" + numberPV[i]] ? dataDevice["ot" + numberPV[i]].value : errorCore("ot" + numberPV[i]),
      fire: dataDevice["of" + numberPV[i]] ? dataDevice["of" + numberPV[i]].value : errorCore("of" + numberPV[i]),
      parentExeNumber: index,
      numberIndexExe: "ПВ",
      notification: dataDevice["nf" + numberPV[i]]
        ? dataDevice["nf" + numberPV[i]].value
        : errorCore("nf" + numberPV[i]),
    });
  }

  return numberPV;
}

function search_RV(index) {
  // Выход реле РИУ

  let key = "xxnr" + index + "_1";
  let howPV = dataDevice["xxnr" + index + "_0"] ? dataDevice["xxnr" + index + "_0"].value : "";
  let numberRV = dataDevice["xxnr" + index + "_1"] ? dataDevice["xxnr" + index + "_1"].value.split(",") : "";
  let max;

  for (var i = 0; i < numberRV.length; i++) {
    // Таблица ВУ
    virtualExe.push({
      typeDev: "radio",
      numberExe: numberRV[i],
      link: index,
      model: "7620",
      index: "1",
      type: dataDevice["oo" + numberRV[i] + "_0"]
        ? dataDevice["oo" + numberRV[i] + "_0"].value
        : errorCore("oo" + numberRV[i]),
      delay: dataDevice["oo" + numberRV[i] + "_1"]
        ? dataDevice["oo" + numberRV[i] + "_1"].value
        : errorCore("oo" + numberRV[i]),
      section: dataDevice["yz1"] ? dataDevice["yz1"].value : errorCore("yz1"),
      name: "",
      activeSections: dataDevice["oq" + numberRV[i]]
        ? dataDevice["oq" + numberRV[i]].value
        : errorCore("oq" + numberRV[i]),
      ktc: dataDevice["or" + numberRV[i]] ? dataDevice["or" + numberRV[i]].value : errorCore("or" + numberRV[i]),
      oppening: dataDevice["ob" + numberRV[i]] ? dataDevice["ob" + numberRV[i]].value : errorCore("ob" + numberRV[i]),
      gas: dataDevice["og" + numberRV[i]] ? dataDevice["og" + numberRV[i]].value : errorCore("og" + numberRV[i]),
      water: dataDevice["ot" + numberRV[i]] ? dataDevice["ot" + numberRV[i]].value : errorCore("ot" + numberRV[i]),
      fire: dataDevice["of" + numberRV[i]] ? dataDevice["of" + numberRV[i]].value : errorCore("of" + numberRV[i]),
      parentExeNumber: index,
      numberIndexExe: "РВ",
      notification: dataDevice["nf" + numberRV[i]]
        ? dataDevice["nf" + numberRV[i]].value
        : errorCore("nf" + numberRV[i]),
    });
  }

  return numberRV;
}

let searchVirtSect = [];
let virtualSection = [];
let MAXSECTION = 0; // СТарший раздел в РУ
let newSection;

function createVirtualSection() {
  searchVirtSect = []; // массив разделов
  MAXSECTION = 0; // сбрасываем старший раздел

  for (var i = 0; i < virtualZone.length; i++) {
    if (+virtualZone[i].section > MAXSECTION) {
      MAXSECTION = +virtualZone[i].section;
    }
  }

  virtualSection = new Array(MAXSECTION);
  for (var i = 0; i < virtualSection.length; i++) {
    virtualSection[i] = { number: i + 1, zone: [] };
  }
  let countLog = 0
  for (var i = 0; i < virtualZone.length; i++) {
    if (virtualZone[i].section !== "") {
      let count = 0

      for (var k = 0; k < virtualSection.length; k++) {
        if (virtualSection[k].number === +virtualZone[i].section) {

          // if (virtualZone[i].typeDev == 'integral') {
          //   count++
          // }
          // if (count <= 1) {
          let numberS = virtualZone[i].section;
          virtualSection[k].zone.push(virtualZone[i]);
          // } else {
          //   count--
          // }

        }
      }
    }
  }

  // for (var i = 0; i < searchVirtSect.length; i++) {
  //   if (searchVirtSect[i].virtualZone > MAXSECTION) {
  //     MAXSECTION = searchVirtSect[i].virtualZone
  //   }
  // }
  // searchVirtSect = searchVirtSect.filter(function (elem, index, self) {

  //   return index === self.findIndex(function (e) {
  //     return e.virtualZone === elem.virtualZone;
  //   });
  // });

  // searchVirtSect.sort(compareSecton); //сортировка масива
  //MAXSECTION = Math.max.apply(null, searchVirtSect); // вычисляем старший раздел

  // newSection = new Array( +MAXSECTION);

  // for(var i = 0; i < newSection.length; i++){
  //   newSection[i] = {'ппп':123};
  // }

  for (var k = 0; k < searchVirtSect.length; k++) {
    for (var i = 0; i < virtualZone.length; i++) {
      if (virtualZone[i].section === searchVirtSect[k]) {
        let nbr = searchVirtSect[k];
        virtualSection.push({
          virtualZone: virtualZone[i],
        });
      }
    }
  }
  // RENDER_VirtualSection(); //Рендер разделов

}

function RENDER_VirtualSection() {
  // Вывод таблицы разделов
  let str = "";
  for (var i = 0; i < virtualSection.length; i++) {
    if (virtualSection[i].zone.length) {
      str +=
        '<div id="blk_sec_n_' +
        virtualSection[i].number +
        '" class="w3-code border_blue" style="min-height:60px">' +
        '<b style="color:#2196f3; font-size:26px;">Раздел №' +
        virtualSection[i].number +
        "</b>" +
        '<div style="float:right; padding-bottom:10px">' +
        '<label style="float:left">' +
        '<button class=" w3-btn w3-blue w3-border w3-border-blue" onclick="open_modal_Rdevice(\'-1\',' +
        virtualSection[i].number +
        ')">+ Добавить устройство</button>' +
        "</div>";
    }
    virtualSection[i].zone.sort(compareVirtSectZon);
    if (virtualSection[i].zone.length > 0) {
      str += '<table class="w3-table w3-table-all table-fixed hoverTable">';
      str += "<thead>";
      str += "<tr style='background-color:#2196F3'>";
      str += "<th id='sl'>№ Зоны</th>";
      str += "<th>Тип</th>";
      str += "<th>Псевдоним</th>";
      str += "<th title='Формировать сообщение востановление (Газ, Вода)'>Восст.</th>";
      str += "<th>Задержка(вход)</th>";
      str += "<th>Задержка(выход)</th>";
      str += "<th>Раздел</th>";
      str += "<th>Устройство</th>";
      str += "</thead>";
      str += "</tr>";
      str += "<tbody>";
      for (var k = 0; k < virtualSection[i].zone.length; k++) {
        str += "<tr>";
        str += "<td>" + virtualSection[i].zone[k].numberZone + "</td>";
        str +=
          "<td>" +
          selectedTypeGuardZone(
            virtualSection[i].zone[k].model,
            virtualSection[i].zone[k].type,
            virtualSection[i].zone[k].param,
            virtualSection[i].zone[k].numberZone,
            virtualSection[i].zone[k].delay,
            "sections",
            virtualSection[i].zone[k].index
          ) +
          "</td>";
        //let nameZone = virtualSection[i].zone[k].numberZone
        str +=
          "<td><input value='" +
          virtualSection[i].zone[k].name +
          "' onchange='setNameZone(this)' name='lb" +
          virtualSection[i].zone[k].numberZone +
          "' style='width:110px'>" +
          "</td>";
        str +=
          '<td><input onchange="recoverTypeZone(this)" type="checkbox" class="w3-check" id="recoveryLw_Tabl_' +
          virtualSection[i].zone[k].numberZone +
          '" ';
        if (checkRecoverZone(virtualSection[i].zone[k].type, virtualSection[i].zone[k].param)) {
          str += " checked ";
        }

        if (+virtualSection[i].zone[k].type !== 2) {
          str += " disabled ";
        }
        str += "></td>";
        // Задержка на вход
        str += "<td><input min='0' max='255'";
        let delayStatus = delaySection_DISABLED(virtualSection[i].zone[k].type, virtualSection[i].zone[k].param);

        if (delayStatus.yes) {
          // if (virtualSection[i].zone[k].delay != '90') {
          if (virtualSection[i].zone[k].delay == 0) {
            str += " disabled ";
          }
          else {
            delayStatus.time = virtualSection[i].zone[k].delay;
          }
        } else {
          delayStatus.time = virtualSection[i].zone[k].delay;
        }

        str +=
          " style='width:50px' onchange='swapSectionDelay(this, \"entry\")' id='delay_S_" +
          virtualSection[i].zone[k].numberZone +
          "' type='text' value='" +
          delayStatus.time +
          "'> сек.</td>";
        // ...Задержка на вход
        // Задержка на вЫход
        str += "<td><input min='0' max='255'";
        delayStatus = delaySection_DISABLED(virtualSection[i].zone[k].type, virtualSection[i].zone[k].param);

        if (delayStatus.yes) {
          // if (virtualSection[i].zone[k].delay != '90') {
          if (virtualSection[i].zone[k].delayExit == 0) {
            str += " disabled ";
          } else {
            delayStatus.time = virtualSection[i].zone[k].delayExit;
          }
        } else {
          delayStatus.time = virtualSection[i].zone[k].delayExit;
        }

        str +=
          " style='width:50px' onchange='swapSectionDelay(this, \"exit\")' id='delay_S_EXIT_" +
          virtualSection[i].zone[k].numberZone +
          "' type='text' value='" +
          delayStatus.time +
          "'> сек.</td>";
        // ...Задержка на вЫход

        str +=
          "<td>" + sectionZoneList(virtualSection[i].zone[k].numberZone, virtualSection[i].zone[k].section) + "</td>";


        str += "<td>";
        if (virtualSection[i].zone[k].typeDev === "rad") {
          str +=
            "<button onclick='open_modal_Rdevice(this.name)' name='" +
            virtualSection[i].zone[k].link.slice(4) +
            "'class=' w3-btn w3-medium w3-white w3-border w3-border-blue btnRkpsedit btnRkpsedit" +
            virtualSection[i].zone[k].link.slice(4) +
            "' style='cursor:pointer; border-radius:4px; background:none;'>";

          let modelName = +virtualSection[i].zone[k].model;
          str += R_DEVICE_NAME[modelName].name + " (№" + virtualSection[i].zone[k].link.slice(4) + ")</button>";
        } else if (virtualSection[i].zone[k].typeDev === "ext") {
          str +=
            "<button onclick='ext_open_modal_card(this.name)' name='" +
            virtualSection[i].zone[k].link.slice(2) +
            "'class=' w3-btn w3-medium w3-white w3-border w3-border-blue btnExtedit btnExtedit" +
            virtualSection[i].zone[k].link.slice(2) +
            "' style='cursor:pointer; border-radius:4px; background:none;'>";
          let modelName = +virtualSection[i].zone[k].model;
          //str += RS485_RADIO[modelName] + ' (№' + virtualSection[i].zone[k].link.slice(2) + ')</button>';
          str += RS485[modelName].title + " (№" + virtualSection[i].zone[k].link.slice(2) + ")</button>";
        } else if (virtualSection[i].zone[k].typeDev === "integral") {
          str +=
            "<button onclick='open_modal_thisDevice(this.name)'  name='" +
            virtualSection[i].zone[k].link.slice(9) +
            "' title='Встроенная зона устройства' class=' w3-btn w3-medium w3-white w3-border w3-border-blue' style='border-radius:4px; background:none;'>" +
            DEVICEINFO[DEVICEMODEL].model +
            "</button>";
        } else {
          console.log("Некорректный тип устройства у данной зоны");
        }

        str += "</td>";
        str += "</tr>";
      }

      str += "</tbody></table>";
    }
    str += "</div>";
  }

  document.getElementById("tab_section_list").innerHTML = str;

  let colExtBtn = document.getElementsByClassName("btnExtedit");
  for (var i = 0; i < colExtBtn.length; i++) {
    colExtBtn[i].addEventListener("mouseover", function (event) {
      let nameClassList = "btnExtedit" + event.target.name;
      let colExtBtnCss = document.getElementsByClassName(nameClassList);
      for (var k = 0; k < colExtBtnCss.length; k++) {
        //colExtBtnCss[k].style.background = 'red';
        colExtBtnCss[k].classList.add("w3-vibration");
        colExtBtnCss[k].classList.remove("w3-white");
      }
    });
    colExtBtn[i].addEventListener("mouseout", function (event) {
      let nameClassList = "btnExtedit" + event.target.name;
      let colExtBtnCss = document.getElementsByClassName(nameClassList);
      for (var k = 0; k < colExtBtnCss.length; k++) {
        colExtBtnCss[k].classList.add("w3-white");
        colExtBtnCss[k].classList.remove("w3-vibration");
      }
    });
  }

  let colRkpsBtn = document.getElementsByClassName("btnRkpsedit");
  for (var i = 0; i < colRkpsBtn.length; i++) {
    colRkpsBtn[i].addEventListener("mouseover", function (event) {
      let nameClassList = "btnRkpsedit" + event.target.name;
      let colExtBtnCss = document.getElementsByClassName(nameClassList);
      for (var k = 0; k < colExtBtnCss.length; k++) {
        //colExtBtnCss[k].style.background = 'red';
        colExtBtnCss[k].classList.add("w3-vibration");
        colExtBtnCss[k].classList.remove("w3-white");
      }
    });
    colRkpsBtn[i].addEventListener("mouseout", function (event) {
      let nameClassList = "btnRkpsedit" + event.target.name;
      let colExtBtnCss = document.getElementsByClassName(nameClassList);
      for (var k = 0; k < colExtBtnCss.length; k++) {
        colExtBtnCss[k].classList.add("w3-white");
        colExtBtnCss[k].classList.remove("w3-vibration");
      }
    });
  }
}

function compareSecton(A, B) {
  return A.virtualZone - B.virtualZone;
}

function compareSect(A, B) {
  return A.number - B.number;
}

function compareRadio(A, B) {
  return A.numberRadio - B.numberRadio;
}
function compareVirtSectZon(A, B) {
  return A.numberZone - B.numberZone;
}
function compareVirtExe(A, B) {
  return A.numberExe - B.numberExe;
}

function searchMaxOO() {
  let max = 0;
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("oo") != -1) {
      let keyValue = deviceJSON.config[i].key;
      try {
        let number = parseInt(keyValue.replace("oo", ""));
        if (number > max) {
          max = number;
        }
      } catch (ex) {
        console.log(ex);
      }
    }
  }
  return max;
}
