let list_zone = {};

function modal_r_device_new() {
  // Добавление новго Радиоканального устрйоства и сохранения в конфигурацию
  let nameDevice = document.getElementById("modal_r_device_name").value;

  pick_new_XXAD(); // поиск свободного XXAD и его запись

  $.hide("#modal_r_device");

  createVirtualTable();
  render_VIRTUAL_XXAD();

  //searchKey_XXAD(); // Обновляем таблицу устройств
  //render_searchKey_ZONE(); // Поиск и рендер зон на одноименной закладке
  renderControl(); // Рендерим контролы
}

function pick_new_XXAD() {
  let nameNewDevice = document.getElementById("modal_r_device_name").value;
  let zoneNumbers = 0; // количество зон датчика

  if (nameNewDevice == "15130") {
    zoneNumbers = 2;
  } else if (nameNewDevice == "16270" || nameNewDevice == "16370") {
    zoneNumbers = 0;
  } else {
    zoneNumbers = 1;
  }

  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("xxad") != -1) {
      if (deviceJSON.config[i].key != "xxad0") {
        if (deviceJSON.config[i].subvalues[1].value == "" || deviceJSON.config[i].subvalues[1].value == " ") {
          deviceJSON.config[i].subvalues[0].value = R_DEVICE_NAME[nameNewDevice].type; // Тип устройства
          deviceJSON.config[i].subvalues[1].value = nameNewDevice; // Название устройства
          deviceJSON.config[i].subvalues[2].value = "0"; // Серийный номер
          saveConfig(deviceJSON.config[i]);
          pick_new_XXDR(deviceJSON.config[i].key, zoneNumbers); // Записываем ключ в XXDR
          break;
        }
      }
    }
  }
}

function pick_new_XXDR(key, zone) {
  let nameKeyXXDR = "xxdr" + key.slice(4);
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf(nameKeyXXDR) != -1) {
      let nameDevice = document.getElementById("modal_r_device_name").value;
      if (nameDevice === "15130") {
        deviceJSON.config[i].subvalues[0].value = document.getElementById("adresZone_1").value; // Привязка к 1 разделу
        deviceJSON.config[i].subvalues[1].value = document.getElementById("adresZone_2").value; // Привязка ко 2 разделу
        pick_new_LW(deviceJSON.config[i]); //записываем настройки ЗОНЫ
      } else if (nameDevice === "15230") {
        deviceJSON.config[i].subvalues[0].value = document.getElementById("adresZone_1").value; // Привязка к 1 разделу
        deviceJSON.config[i].subvalues[1].value = ""; // Привязка ко 2 разделу
      }
      saveConfig(deviceJSON.config[i]);
      break;
    }
  }
}

function pick_new_LW(key) {
  let key1 = key.subvalues[0].value;
  let key2 = key.subvalues[1].value;

  for (var i = 0; i < key.subvalues.length; i++) {
    if (key.subvalues[i].value !== "") {
      let nameKey = "lw" + key.subvalues[i].value;
      for (k in deviceJSON.config) {
        if (deviceJSON.config[k].key === nameKey) {
          let idInptType = "modal_r_device_zone_type_" + (i + 1);
          let idInptDelay = "modal_r_device_zone_delay_" + (i + 1);
          deviceJSON.config[k].subvalues[0].value = "5";
          deviceJSON.config[k].subvalues[1].value = document.getElementById(idInptType).value;
          deviceJSON.config[k].subvalues[2].value = document.getElementById(idInptDelay).value;
          saveConfig(deviceJSON.config[k]);
        }
      }
    }
  }
}

function modal_r_device_new_LW(yz) {
  for (var k = 0; k < yz.length; k++) {
    let LW_NAME = "lw" + yz[k].slice(2);
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == LW_NAME) {
        let delayId = "modal_r_device_zone_delay_" + (parseInt(k) + parseInt(1));
        let typeId = "modal_r_device_zone_type_" + (parseInt(k) + parseInt(1));
        let typeZone = document.getElementById(typeId).value;
        typeZone = typeZone.replace("D", "");
        let delay = document.getElementById(delayId).value;

        deviceJSON.config[i].subvalues[0].value = "5";
        deviceJSON.config[i].subvalues[1].value = typeZone;
        deviceJSON.config[i].subvalues[2].value = delay;
        saveConfig(deviceJSON.config[i]);
      }
    }
  }
}

function modal_r_device_new_XXDR(yzArr, xxaad) {
  if (yzArr == null) {
    let XXDR_NAME = "xxdr" + xxaad.slice(4);
    //let YZ_NAME = yzArr.slice(2);
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key.indexOf(XXDR_NAME) != -1) {
        deviceJSON.config[i].subvalues[0].value = ""; // номер первого зоны
        deviceJSON.config[i].subvalues[1].value = ""; // номер второй зоны
        saveConfig(deviceJSON.config[i]);
      }
    }
  } else if (yzArr.length == 1) {
    let XXDR_NAME = "xxdr" + xxaad.slice(4);
    let YZ_NAME1 = yzArr[0].slice(2);
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key.indexOf(XXDR_NAME) != -1) {
        deviceJSON.config[i].subvalues[0].value = YZ_NAME1; // номер первого зоны
        deviceJSON.config[i].subvalues[1].value = ""; // номер второй зоны
        saveConfig(deviceJSON.config[i]);
        break;
      }
    }
  } else if (yzArr.length == 2) {
    let XXDR_NAME = "xxdr" + xxaad.slice(4);
    let YZ_NAME1 = yzArr[0].slice(2);
    let YZ_NAME2 = yzArr[1].slice(2);
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == XXDR_NAME) {
        deviceJSON.config[i].subvalues[0].value = YZ_NAME1; // номер первого зоны
        deviceJSON.config[i].subvalues[1].value = YZ_NAME2; // номер второй зоны
        saveConfig(deviceJSON.config[i]);
        break;
      }
    }
  }
}
function zoneEqualityCheck(thisDeviceSize, CARD_DEVICE) {
  if (thisDeviceSize !== 1) {
    if ((CARD_DEVICE[0].numberZone_1 === CARD_DEVICE[1].numberZone_1) && CARD_DEVICE[0].numberZone_1 !== '0') {
      return true
    }
  }
  return false

}
function saveModalIntegrationZone() {
  //Сохранение встроенной зоны
  const thisDeviceSize = CACHE_EDIT_INTEGRATION_ZONE.length
  const CARD_DEVICE = []
  for (let i = 0; i < thisDeviceSize; i++) {
     
    let CARD_DEVICE_1 = {
      numberZone_1: null, //Номер зоны 1
      typeZone_1: null, //Тип зоны 1
      delayZone_1: null, // Задержка зоны 1
      delayZone_Exit_1: null, // Задержка зоны 1
      sectionZone_1: null, // Раздел зоны 1
    };
    CARD_DEVICE.push(CARD_DEVICE_1)
  }

  
  for (let i = 0; i < CARD_DEVICE.length; i++) {
    let index = i + 1
    CARD_DEVICE[i].numberZone_1 = document.getElementById(`adresZone_${index}`)
      ? document.getElementById(`adresZone_${index}`).value
      : null;
    CARD_DEVICE[i].typeZone_1 = document.getElementById(`modal_r_device_zone_type_${index}`)
      ? document.getElementById(`modal_r_device_zone_type_${index}`).value
      : null;
    CARD_DEVICE[i].delayZone_1 = document.getElementById(`modal_r_device_zone_delay_${index}`)
      ? document.getElementById(`modal_r_device_zone_delay_${index}`).value
      : null;
    CARD_DEVICE[i].delayZone_Exit_1 = document.getElementById(`modal_r_device_zone_delay_EXIT_${index}`)
      ? document.getElementById(`modal_r_device_zone_delay_EXIT_${index}`).value
      : null;
    CARD_DEVICE[i].sectionZone_1 = document.getElementById(`nomberZone_Section_${index}`)
      ? document.getElementById(`nomberZone_Section_${index}`).value
      : null;
  }
  if (zoneEqualityCheck(thisDeviceSize, CARD_DEVICE)) {
    document.getElementById("modal_r_device_error").innerHTML =
      '<span style="position:inherit; float:right;" onclick=\'$.hide("#modal_r_device_error")\' class="w3-button">×</span>' +
      "Ошибка при сохранении </br>Номера зон не должны повторяться"
    $.show("#modal_r_device_error");
    return;
  } else {
    applySaveIntegrationZone(CARD_DEVICE);
  }

  //let CACHE_EDIT_INTEGRATION_ZONE; // открытая дляредактирования встроенная зона
}

function applySaveIntegrationZone(CARD_DEVICE) {
  // ОТПРАВЛЯЕМ ДАННЫЕ ИЗ КАРТОЧКИ ВСТРОЕННОЙ ЗОНЫ
  let clearOldKey = false; // нужно отчищать старые ключи
  let focusID = false;
  for (let j = 0; j < CARD_DEVICE.length; j++) {
    if (CARD_DEVICE[j].numberZone_1 < 0 || CARD_DEVICE[j].numberZone_1 > 193 || CARD_DEVICE[j].numberZone_1 == '') {
      document.getElementById("modal_r_device_error").innerHTML =
        '<span style="position:inherit; float:right;" onclick=\'$.hide("#modal_r_device_error")\' class="w3-button">×</span>' +
        '<b> &#9888; Ошибка при сохранении:</b> <ul class="w3-ul">' +
        "</br> <li>Номер зоны недопустим, введите число от 1 до 193</li> "
      $.show("#modal_r_device_error");
      return;

    }
    let keyLw1 = "lw" + CARD_DEVICE[j].numberZone_1; // Ключ номера зоны 1
    let keyYz1 = "yz" + CARD_DEVICE[j].numberZone_1; // Ключ номера раздела 1
    let oldLw = "lw" + CACHE_EDIT_INTEGRATION_ZONE[j]; // Старый Ключ номера зоны 1


    if (CARD_DEVICE[j].typeZone_1 !== null) {
      CARD_DEVICE[j].typeZone_1 = CARD_DEVICE[j].typeZone_1.replace("D", ""); // Убираем из Охр. с фикс. зад. D
      CARD_DEVICE[j].typeZone_1 = CARD_DEVICE[j].typeZone_1.replace("noused", "1"); // Заменяем неиспользуемое на 0
    }

    if (CACHE_EDIT_INTEGRATION_ZONE[j] !== CARD_DEVICE[j].numberZone_1) {
      clearOldKey = true;
      if (CARD_DEVICE[j].numberZone_1 != 0) {
        for (var k = 0; k < virtualZone.length; k++) {
          if (virtualZone[k].numberZone === CARD_DEVICE[j].numberZone_1) {

            if (virtualZone[k].numberZone !== CACHE_EDIT_INTEGRATION_ZONE[j]) {
              console.log("Зона " + virtualZone[k].numberZone + " занята устройством " + virtualZone[k].link.slice(4));
              document.getElementById("modal_r_device_error").innerHTML =
                '<span style="position:inherit; float:right;" onclick=\'$.hide("#modal_r_device_error")\' class="w3-button">×</span>' +
                "Ошибка при сохранении </br> Зона " +
                virtualZone[k].numberZone +
                " занята устройством " +
                virtualZone[k].link.slice(4);
              $.show("#modal_r_device_error");
              return;
            }
          }
        }
      }

    }

    if (!false) {
      for (i in deviceJSON.config) {
        if (clearOldKey) {
          if (deviceJSON.config[i].key === oldLw) {
            deviceJSON.config[i].subvalues[0].value = "0"; // Тип устройства согласно ЕСОП
            deviceJSON.config[i].subvalues[1].value = "0"; // Модель устройства
            deviceJSON.config[i].subvalues[2].value = "0,0"; // Задержка устройства
          }
          if (deviceJSON.config[i].key === "zs") {
            let arrZone = deviceJSON.config[i].subvalues[1].value.split(",");
            for (var l = 0; l < arrZone.length; l++) {

              arrZone[l] = CARD_DEVICE[l].numberZone_1;

            }
            deviceJSON.config[i].subvalues[1].value = arrZone.join(",");
            saveConfig(deviceJSON.config[i]);
          }
        }

        if (deviceJSON.config[i].key === keyLw1) {
          if (keyLw1 !== "lw") {
            //проверяем что ключ зоны корректен
            deviceJSON.config[i].subvalues[0].value = CARD_DEVICE[j].typeZone_1.charAt(0);
            if (document.getElementById("modal_r_device_zone_type_1").value === "noused") {
              deviceJSON.config[i].subvalues[1].value = "0";
              // если зона не Используется
            } else {
              deviceJSON.config[i].subvalues[1].value = CARD_DEVICE[j].typeZone_1.slice(2);
            }

            if (CARD_DEVICE[j].delayZone_1 === "" || CARD_DEVICE[j].delayZone_1 === null) {
              deviceJSON.config[i].subvalues[2].value = "0,0"; // Если задержка пустая шлем 0
            } else {
              deviceJSON.config[i].subvalues[2].value = CARD_DEVICE[j].delayZone_1 + "," + CARD_DEVICE[j].delayZone_Exit_1;
            }
          }
          saveConfig(deviceJSON.config[i]);
        }

        if (deviceJSON.config[i].key === keyYz1) {
          deviceJSON.config[i].subvalues[0].value = CARD_DEVICE[j].sectionZone_1;
          saveConfig(deviceJSON.config[i]);
        }
      }
    }
  }


  clearExpiredKey();

  parseAppKey("update_notabs");
  closeModalR_dev(); // Чистим кэш и закрывем карточку
  if (focusID) {
    document.getElementById(focusID).scrollIntoView();
  }
}

function generateXxssValues(typeDevice) {
  // Вычисляем значение ключа XXSS
  let value = 0;
  switch (typeDevice) {
    case "15130":
      if (document.getElementById("sensor_sabotaje")) {
        if (document.getElementById("sensor_sabotaje").checked) {
          value |= 0x1;
        }
      } else {
        console.error("Не найден sensor_sabotaje");
      }

      if (document.getElementById("XXSS_tamper_control")) {
        if (document.getElementById("XXSS_tamper_control").checked) {
          value |= 0x20;
        }
      } else {
        console.error("Не найден XXSS_tamper_control");
      }
      if (document.getElementById("XXSS_main_battery_type_CR2")) {
        if (document.getElementById("XXSS_main_battery_type_CR2").checked) {
          value |= 0x40;
        }
      } else {
        console.error("Не найден XXSS_main_battery_type_CR2");
      }
      break;
    case "15230":
      if (document.getElementById("range_less_10")) {
        if (document.getElementById("range_less_10").checked) {
          value |= 0x1;
        }
      } else {
        console.error("Не найден range_less_10");
      }

      if (document.getElementById("XXSS_tamper_control")) {
        if (document.getElementById("XXSS_tamper_control").checked) {
          value |= 0x20;
        }
      } else {
        console.error("Не найден XXSS_tamper_control");
      }
      if (document.getElementById("XXSS_main_battery_type_CR2")) {
        if (document.getElementById("XXSS_main_battery_type_CR2").checked) {
          value |= 0x40;
        }
      } else {
        console.error("Не найден XXSS_main_battery_type_CR2");
      }
      break;
    case "15231":
      if (document.getElementById("animal_on")) {
        if (document.getElementById("animal_on").checked) {
          value |= 0x1;
        }
      } else {
        console.error("Не найден animal_on");
      }
      if (document.getElementById("XXSS_tamper_control")) {
        if (document.getElementById("XXSS_tamper_control").checked) {
          value |= 0x20;
        }
      } else {
        console.error("Не найден XXSS_tamper_control");
      }
      if (document.getElementById("XXSS_main_battery_type_CR2")) {
        if (document.getElementById("XXSS_main_battery_type_CR2").checked) {
          value |= 0x40;
        }
      } else {
        console.error("Не найден XXSS_main_battery_type_CR2");
      }
      break;
    case "15830":
      if (document.getElementById("range_less_4")) {
        if (document.getElementById("range_less_4").checked) {
          value |= 0x1;
        }
      } else {
        console.error("Не найден range_less_4");
      }
      if (document.getElementById("glass_2")) {
        if (document.getElementById("glass_2").checked) {
          value |= 0x2;
        }
      } else {
        console.error("Не найден glass_2");
      }
      if (document.getElementById("glass_crash")) {
        if (document.getElementById("glass_crash").checked) {
          value |= 0x4;
        }
      } else {
        console.error("Не найден glass_2");
      }
      if (document.getElementById("XXSS_tamper_control")) {
        if (document.getElementById("XXSS_tamper_control").checked) {
          value |= 0x20;
        }
      } else {
        console.error("Не найден XXSS_tamper_control");
      }
      if (document.getElementById("XXSS_main_battery_type_CR2")) {
        if (document.getElementById("XXSS_main_battery_type_CR2").checked) {
          value |= 0x40;
        }
      } else {
        console.error("Не найден XXSS_main_battery_type_CR2");
      }
      break;
    case "15930":
      if (document.getElementById("range_less_4")) {
        if (document.getElementById("range_less_4").checked) {
          value |= 0x1;
        }
      } else {
        console.error("Не найден range_less_4");
      }
      if (document.getElementById("glass_2")) {
        if (document.getElementById("glass_2").checked) {
          value |= 0x2;
        }
      } else {
        console.error("Не найден glass_2");
      }
      if (document.getElementById("glass_crash")) {
        if (document.getElementById("glass_crash").checked) {
          value |= 0x4;
        }
      } else {
        console.error("Не найден glass_2");
      }
      if (document.getElementById("XXSS_tamper_control")) {
        if (document.getElementById("XXSS_tamper_control").checked) {
          value |= 0x20;
        }
      } else {
        console.error("Не найден XXSS_tamper_control");
      }
      break;
    case "17620": // отключен для данного типа устройства
      if (document.getElementById("XXSS_tamper_control")) {
        if (document.getElementById("XXSS_tamper_control").checked) {
          value |= 0x20;
        }
      } else {
        //console.error("Не найден XXSS_tamper_control");
      }

      if (document.getElementById("XXSS_power_24")) {
        if (document.getElementById("XXSS_power_24").checked) {
          value |= 0x1;
        }
      } else {
        console.error("Не найден XXSS_power_12");
      }

      if (document.getElementById("XXSS_break_true")) {
        if (document.getElementById("XXSS_break_true").checked) {
          value |= 0x2;
        }
      } else {
        console.error("Не найден XXSS_break_true");
      }
      if (document.getElementById("XXSS_main_battery_type_CR2")) {
        if (document.getElementById("XXSS_main_battery_type_CR2").checked) {
          value |= 0x40;
        }
      } else {
        console.error("Не найден XXSS_main_battery_type_CR2");
      }
      break;
    case "16270": // отключен для данного типа устройства
      if (document.getElementById("XXSS_tamper_control")) {
        if (document.getElementById("XXSS_tamper_control") && document.getElementById("XXSS_tamper_control").checked) {
          value |= 0x20;
        }
      } else {
        //console.error("Не найден XXSS_tamper_control, либо он отключен для данного типа устройства");
      }
      if (document.getElementById("XXSS_main_battery_type_CR2")) {
        if (document.getElementById("XXSS_main_battery_type_CR2").checked) {
          value |= 0x40;
        }
      } else {
        console.error("Не найден XXSS_main_battery_type_CR2");
      }
      break;
    case "13431":
    case "13438":
    case "13439":
      //if (document.getElementById("XXSS_rank_control")) {
      // if (document.getElementById("XXSS_rank_control").checked) {
      console.log("НАШЁЛ, ЧТО ТАМПЕР КОНТРОЛИРУЕТСЯ")
      if (document.getElementById("trinket_click_usr_1")) {
        console.log("НАШЁЛ, ВЫБИРАЛКУ РАНГА")
        const valXX = +document.getElementById("trinket_click_usr_1").value
        switch (valXX) {
          case 1:
            console.log("НАШЁЛ, РАНГ 1")
            value = 5;
            // value |= 0x01;
            break;
          case 2:
            console.log("НАШЁЛ, РАНГ 2")
            value = 6;
            // value |= 0x02;
            break;
          case 3:
            console.log("НАШЁЛ, РАНГ 3")
            value = 7;
            // value |= 0x03;
            break;
          default:
            break;
        }
        break;


      } else {
        console.error("Не найден XXSS_tamper_control");
      }



      break;
    default:
      break;
  }

  return value + "";
}

function checkingFreeZoneNumber(checkNumber, n, freeZone1) {

  const tmpArr = pickUpYzLw("lw", "2")
  const tmpFindArr = tmpArr.filter(item => Number(item) > Number(checkNumber))
  let findNumber = checkNumber
  for (var i = 0; i < virtualZone.length; i++) {
    // ▼ Проверка на занятость зоны другим усттройством ▼
    if (virtualZone[i].typeDev != null && virtualZone[i].numberZone !== '0') {
      if (virtualZone[i].numberZone === checkNumber) {
        if (freeZone1 !== tmpFindArr[0]) {
          findNumber = tmpFindArr[0]
        }
        else {
          findNumber = tmpFindArr[n]
        }
      }
    }

  }
  if (!findNumber) {
    findNumber = 0
  }
  return String(findNumber)
}


function saveModalRadio_NEW(typeDevice = null, mixAll = false) {
  // ДОБАВЛЕНИЕ НОВОГО УСТРОЙСТВА КРОМЕ ИСПОЛНИТЕЛЬНОГО 7620
  /* ===========  Сбор данных из карточки устройства  =========================================================================================== */

  let CARD_DEVICE = {
    id: null, //Номер XXAD
    typeDevice: null, //Тип устройства
    numberZone_1: null, //Номер зоны 1
    numberZone_2: null, //Номер зоны 2
    typeZone_1: null, //Тип зоны 1
    typeZone_2: null, //Тип зоны 2
    delayZone_1: null, // Задержка зоны 1
    delayZone_2: null, // Задержка зоны 1
    delayZone_Exit_1: null, // Задержка зоны 1
    delayZone_Exit_2: null, // Задержка зоны 2
    sectionZone_1: null, // Раздел зоны 1
    sectionZone_2: null, // Раздел зоны 2
    typeESOP: null,
    PARAM_XXSS: null,
    PARAM_XXNB: null,
  };
  // Выбор номера РУ пользоватетем
  let xxadUserChoice = null

  xxadUserChoice = document.getElementById('numberSelectionDevice_id').value
  localStorage.setItem('xxadUserChoice', xxadUserChoice);


  // ▼ Поиск свободной XXAD ▼

  if (CACHE_EDIT_R_DEVICE.id === "-1" || mixAll === 'cardDevice' || mixAll === 'AllDevice') {
    // Если добавляем новое усройство
    let createNewId = false; // проверка подбора xxad
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key.indexOf("xxad") != -1) {
        if (deviceJSON.config[i].key != "xxad0" && deviceJSON.config[i].key.slice(4) >= Number(xxadUserChoice)) {
          if (
            deviceJSON.config[i].subvalues[1].value == "" ||
            deviceJSON.config[i].subvalues[1].value == " " ||
            deviceJSON.config[i].subvalues[1].value == "0"
          ) {

            CARD_DEVICE.id = mixAll ? deviceJSON.config[i].key : "xxad" + xxadUserChoice;
            createNewId = true; //подобрали новый XXAD
            break;
          }
        }
      }
    }
    if (!createNewId) {
      // проверка подбора xxad
      alertbox.show("Свободные зоны закончились");
    }
  } else if (CACHE_EDIT_R_DEVICE.id === "thisDevice") {
    // если редактируем встроенную зону
    return;
  } else {
    // Если редактируем устройство
    CARD_DEVICE.id = "xxad" + CACHE_EDIT_R_DEVICE.id;
  }

  // ▼ Тип устройства ▼
  const checkNumber1 = document.getElementById("adresZone_1") && document.getElementById("adresZone_1").value
  const checkNumber2 = document.getElementById("adresZone_2") && document.getElementById("adresZone_2").value
  if (typeDevice) {
    CARD_DEVICE.typeDevice = typeDevice
  } else {
    CARD_DEVICE.typeDevice = document.getElementById("modal_r_device_name").value;
  }
  if (mixAll === 'cardDevice' && document.getElementById("adresZone_1")) {
    // ▼ Номер зоны 1 ▼

    const freeZone1 = checkingFreeZoneNumber(checkNumber1, 0)

    CARD_DEVICE.numberZone_1 = document.getElementById("adresZone_1")
      ? freeZone1
      : null;
    // ▼ Номер зоны 2 ▼
    if (document.getElementById("adresZone_2")) {

      CARD_DEVICE.numberZone_2 = document.getElementById("adresZone_2")
        ? checkingFreeZoneNumber(checkNumber2, 1, freeZone1)
        : null;
    } else {
      CARD_DEVICE.numberZone_2 = document.getElementById("adresZone_2")
        ? document.getElementById("adresZone_2").value
        : null;
    }


  }
  else {
    // ▼ Номер зоны 1 ▼
    CARD_DEVICE.numberZone_1 = document.getElementById("adresZone_1")
      ? document.getElementById("adresZone_1").value
      : null;
    // ▼ Номер зоны 2 ▼
    CARD_DEVICE.numberZone_2 = document.getElementById("adresZone_2")
      ? document.getElementById("adresZone_2").value
      : null;
  }

  // ▼ Тип зоны 1 ▼
  CARD_DEVICE.typeZone_1 = document.getElementById("modal_r_device_zone_type_1")
    ? document.getElementById("modal_r_device_zone_type_1").value
    : null;
  // ▼ Тип зоны 2 ▼
  CARD_DEVICE.typeZone_2 = document.getElementById("modal_r_device_zone_type_2")
    ? document.getElementById("modal_r_device_zone_type_2").value
    : null;
  // ▼ Задержка зоны 1 НА ВХОД▼
  CARD_DEVICE.delayZone_1 = document.getElementById("modal_r_device_zone_delay_1")
    ? document.getElementById("modal_r_device_zone_delay_1").value
    : null;
  // ▼ Задержка зоны 1 НА ВЫХОД▼
  CARD_DEVICE.delayZone_Exit_1 = document.getElementById("modal_r_device_zone_delay_EXIT_1")
    ? document.getElementById("modal_r_device_zone_delay_EXIT_1").value
    : null;
  // ▼ Задержка зоны 2 НА ВХОД▼
  CARD_DEVICE.delayZone_2 = document.getElementById("modal_r_device_zone_delay_2")
    ? document.getElementById("modal_r_device_zone_delay_2").value
    : null;
  // ▼ Задержка зоны 2 НА ВЫХОД▼
  CARD_DEVICE.delayZone_Exit_2 = document.getElementById("modal_r_device_zone_delay_EXIT_2")
    ? document.getElementById("modal_r_device_zone_delay_EXIT_2").value
    : null;
  // ▼ Раздел зоны 1 ▼
  CARD_DEVICE.sectionZone_1 = document.getElementById("nomberZone_Section_1")
    ? document.getElementById("nomberZone_Section_1").value
    : null;
  // ▼ Раздел зоны 2 ▼
  CARD_DEVICE.sectionZone_2 = document.getElementById("nomberZone_Section_2")
    ? document.getElementById("nomberZone_Section_2").value
    : null;

  // ▼ ТИП УСТРОЙСТВА СОГЛАСНО ЕСОП ▼
  if (CARD_DEVICE.typeDevice === "15130") {
    CARD_DEVICE.typeESOP = "2";
    // if (document.getElementById("sensor_sabotaje").checked) {
    //   CARD_DEVICE.PARAM_XXSS = "1";
    // } else {
    //   CARD_DEVICE.PARAM_XXSS = "0";
    // }
  } else if (CARD_DEVICE.typeDevice === "15230") {
    CARD_DEVICE.typeESOP = "21";
    // if (document.getElementById("range_less_10").checked) {
    //   CARD_DEVICE.PARAM_XXSS = "1";
    // } else {
    //   CARD_DEVICE.PARAM_XXSS = "0";
    // }
  } else if (CARD_DEVICE.typeDevice === "15231") {
    CARD_DEVICE.typeESOP = "21";
    // if (document.getElementById("animal_on").checked) {
    //   CARD_DEVICE.PARAM_XXSS = "1";
    // } else {
    //   CARD_DEVICE.PARAM_XXSS = "0";
    // }
  } else if (CARD_DEVICE.typeDevice === "15830") {
    CARD_DEVICE.typeESOP = "29";
    // let bit_0 = document.getElementById("range_less_4").checked;
    // let bit_1 = document.getElementById("glass_2").checked;
    // let bit_2 = document.getElementById("glass_crash").checked;
    // CARD_DEVICE.PARAM_XXSS = transformParamSensor(bit_0, bit_1, bit_2);
  } else if (CARD_DEVICE.typeDevice === "16270") {
    CARD_DEVICE.typeESOP = "80";

    let bintohex = ''

    const sectionsArr = keyboardSectionUpdate("inputSections6270")
    //Переводим bin в hex
    const bin = sectionsArr.join('')
    const objvalue = Object.values(hexObj)
    const objkey = Object.keys(hexObj)
    const binArr = []
    for (let i = 0; i < bin.length / 4; i++) {
      offset = (((i + 1) % 2) + (i & 0xFFFFFFFE)) * 4
      binSub = bin.substring(offset, offset + 4)
      binArr.push(binSub)

    }
    for (let i = 0; i < binArr.length; i++) {
      for (let j = 0; j < objvalue.length; j++) {
        if (binArr[i] === objvalue[j]) {
          bintohex += objkey[j]
        }

      }

    }


    //добавляем во все 6270 одинаковый список разделов //Записываем hex в прибор
    let xxnu = 'xxkb' + parseInt(CARD_DEVICE.id.match(/\d+/))
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == xxnu) {
        deviceJSON.config[i].subvalues[0].value = bintohex || '';
       
          saveConfigAll(deviceJSON.config[i]);
         

      }
    }

  } else if (CARD_DEVICE.typeDevice === "16370") {
    CARD_DEVICE.typeESOP = "26";

    CARD_DEVICE.PARAM_XXNB =
      "" +
      document.getElementById("trinket_fn_clck_0").value +
      "," +
      document.getElementById("trinket_clc_usr_0").value +
      "," +
      document.getElementById("trinket_fn_long_clck_0").value +
      "," +
      document.getElementById("trinket_long_usr_0").value +
      ";" +
      document.getElementById("trinket_fn_clck_1").value +
      "," +
      document.getElementById("trinket_clc_usr_1").value +
      "," +
      document.getElementById("trinket_fn_long_clck_1").value +
      "," +
      document.getElementById("trinket_long_usr_1").value +
      ";" +
      document.getElementById("trinket_fn_clck_2").value +
      "," +
      document.getElementById("trinket_clc_usr_2").value +
      "," +
      document.getElementById("trinket_fn_long_clck_2").value +
      "," +
      document.getElementById("trinket_long_usr_2").value +
      ";" +
      document.getElementById("trinket_fn_clck_3").value +
      "," +
      document.getElementById("trinket_clc_usr_3").value +
      "," +
      document.getElementById("trinket_fn_long_clck_3").value +
      "," +
      document.getElementById("trinket_long_usr_3").value +
      ";";


  } else if (CARD_DEVICE.typeDevice.indexOf("1343") != -1) {
    CARD_DEVICE.typeESOP = "91";
    // так же для 3438, 3439 ЕСОП - 91
  } else if (CARD_DEVICE.typeDevice === "17620") {
    CARD_DEVICE.typeESOP = "70";
    // так же для 3438, 3439 ЕСОП - 91
  } else {
    CARD_DEVICE.typeESOP = 0;
  }

  //let xxssValue = generateXxssValues(CARD_DEVICE.typeDevice); // Генерация значения ключа XXSS

  CARD_DEVICE.PARAM_XXSS = generateXxssValues(CARD_DEVICE.typeDevice);

  // Генерация значения ключа XXSS
  /* ======================================================================================================================================== */

  let error = checkNewRadio(CARD_DEVICE, mixAll); // Проверяем корректность данных
  //let error7620 = checkNew7620(CARD_DEVICE)
  if (!error.error) {
    // Данные валидны
    $.hide("#modal_r_device_error"); // Скрываем область ошибок

    //console.log('CARD_DEVICE', CARD_DEVICE);
    // console.log('error.error', error.error);

    applyNewRadio(CARD_DEVICE, mixAll); // Отправляем в ядро
    if(!mixAll){
      liveSaveInterface();
    }  
  } else {
    // Выводим ошибку
    let txtError =
      '<span style="position:inherit; float:right;" onclick=\'$.hide("#modal_r_device_error")\' class="w3-button">×</span>';
    txtError += '<b> &#9888; Ошибка при сохранении:</b> <ul class="w3-ul">';
    for (var i = 0; i < error.listError.length; i++) {
      txtError += "<li>" + error.listError[i].description + "</li>";
    }
    txtError += "</ul>";
    document.getElementById("modal_r_device_error").innerHTML = txtError;

    $.show("#modal_r_device_error"); // отображаем ошибки
    if (document.getElementById("detailsCard")) {
      document.getElementById("detailsCard").open = false; // сворачиваем Описание
    }



  }
  

  if (mixAll === 'AllDevice') {
    set_r_device_name("1");
    document.getElementById("modal_r_device_name").value = "1";
  }
}

function checkingFreeExeNumber(checkNumber, n, freeExe1) {
  const tmpArr = pickUpOeOhNrNu()
  const tmpFindArr = tmpArr.filter(item => Number(item) > Number(checkNumber))
  let findNumber = checkNumber
  for (var i = 0; i < virtualExe.length; i++) {
    // ▼ Проверка на занятость зоны другим усттройством ▼
    if (virtualExe[i].numberExe != null && virtualExe[i].numberExe !== '0') {
      if (virtualExe[i].numberExe === findNumber) {
        if (freeExe1 != tmpFindArr[0]) {
          findNumber = tmpFindArr[0]
        }
        else {
          findNumber = tmpFindArr[n]
        }
      }
    }

  }
  if (!findNumber) {
    findNumber = 0
  }
  return String(findNumber)
}




function saveModalRadioEXT_NEW(typeDevice = null, mixAll = false) {
  // ДОБАВЛЕНИЕ НОВОГО ИСПОЛНИТЕЛЬНОГО РАДИОКАНАЛЬНОГО УСТРОТВА 7620

  let CARD_DEVICE = {
    id: null, //Номер XXAD
    xxIndex: null,
    typeDevice: null,
    numberPV: null,
    numberRV: null,
    typeActionPV: null,
    typeActionRV: null,
    delayPV: null,
    delayRV: null,
    triggerPV: [],
    triggerRV: [],
    sectionRV: [],
    sectionPV: [],
    typeESOP: null,
    PARAM_XXSS: null,
    PARAM_XXNB: null,
    notificationPV: null,
    notificationRV: null,
  };

  CARD_DEVICE.notificationPV = document.getElementById("section_PV_notification").checked ? "1" : "0";
  CARD_DEVICE.notificationRV = document.getElementById("section_RV_notification").checked ? "1" : "0";
  // Выбор номера РУ пользоватетем
  let xxadUserChoice = null
  xxadUserChoice = document.getElementById('numberSelectionDevice_id').value
  localStorage.setItem('xxadUserChoice', xxadUserChoice);
  // ▼ Поиск свободной XXAD ▼
  if (CACHE_EDIT_R_DEVICE.id === "-1" || mixAll === 'cardDevice' || mixAll === 'AllDevice') {
    // Если добавляем новое усройство
    let createNewId = false; // проверка подбора xxad
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key.indexOf("xxad") != -1) {
        if (deviceJSON.config[i].key != "xxad0" && deviceJSON.config[i].key.slice(4) >= Number(xxadUserChoice)) {
          if (
            deviceJSON.config[i].subvalues[1].value == "" ||
            deviceJSON.config[i].subvalues[1].value == " " ||
            deviceJSON.config[i].subvalues[1].value == "0"
          ) {
            CARD_DEVICE.id = mixAll ? deviceJSON.config[i].key : "xxad" + xxadUserChoice;
            CARD_DEVICE.xxIndex = mixAll ? deviceJSON.config[i].key.slice(4) : xxadUserChoice;
            createNewId = true; //подобрали новый XXAD
            break;
          }
        }
      }
    }
    if (!createNewId) {
      // проверка подбора xxad
      alertbox.show("Свободные зоны закончились");
    }
  } else {
    // Если редактируем устройство
    CARD_DEVICE.id = "xxad" + CACHE_EDIT_R_DEVICE.id;
    CARD_DEVICE.xxIndex = CACHE_EDIT_R_DEVICE.id;
  }
  // ▼ Тип устройства ▼
  if (mixAll === 'AllDevice') {
    CARD_DEVICE.typeDevice = typeDevice
  } else {
    CARD_DEVICE.typeDevice = document.getElementById("modal_r_device_name").value;
  }
  const checkNumber1 = document.getElementById("number_PV") ? document.getElementById("number_PV").value : null
  const checkNumber2 = document.getElementById("number_RV") ? document.getElementById("number_RV").value : null



  // ▼ Номер ПВ  ▼
  if (mixAll === 'cardDevice') {
    const freeExe1 = checkingFreeExeNumber(checkNumber1, 0)

    CARD_DEVICE.numberPV = freeExe1 // номер
    CARD_DEVICE.numberRV = checkingFreeExeNumber(checkNumber2, 1, freeExe1)// номер
  } else {
    document.getElementById("pv_triger_mod").value
    CARD_DEVICE.numberPV = document.getElementById("number_PV").value; // номер
    CARD_DEVICE.numberRV = document.getElementById("number_RV").value; // номер
  }
  CARD_DEVICE.typeActionPV = document.getElementById("pv_triger_mod").value; // Режим работы ПВ
  CARD_DEVICE.typeActionRV = document.getElementById("rv_triger_mod").value; // Режим работы РВ

  CARD_DEVICE.delayPV = document.getElementById("pv_delay").value; // Время работы ПВ
  CARD_DEVICE.delayRV = document.getElementById("rv_delay").value; // Время работы РВ

  // let bit_0 = document.getElementById("XXSS_power_12").checked;
  // let bit_1 = document.getElementById("XXSS_break_true").checked;

  // let valueXXSS = "";
  // if (bit_0 && bit_1) {
  //   valueXXSS = "2";
  // } else if (bit_0 == false && bit_1 == false) {
  //   valueXXSS = "1";
  // } else if (bit_0 == true && bit_1 == false) {
  //   valueXXSS = "0";
  // } else if (bit_0 == false && bit_1 == true) {
  //   valueXXSS = "3";
  // }
  //CARD_DEVICE.PARAM_XXSS = valueXXSS;
  CARD_DEVICE.PARAM_XXSS = generateXxssValues(CARD_DEVICE.typeDevice);

  let event_PV = document.getElementById("event_PV").childNodes;
  for (var i = 0; i < event_PV.length; i++) {
    CARD_DEVICE.triggerPV.push({
      name: event_PV[i].childNodes[0].childNodes[0].name + CARD_DEVICE.numberPV,
      value: event_PV[i].childNodes[0].childNodes[0].checked,
    });
  }

  let event_RV = document.getElementById("event_RV").childNodes;
  for (var i = 0; i < event_PV.length; i++) {
    CARD_DEVICE.triggerRV.push({
      name: event_RV[i].childNodes[0].childNodes[0].name + CARD_DEVICE.numberRV,
      value: event_RV[i].childNodes[0].childNodes[0].checked,
    });
  }

  let section_PV = document.getElementById("section_PV").childNodes;
  for (var i = 0; i < section_PV.length; i++) {
    if (section_PV[i].childNodes[0].childNodes[0].checked) {
      CARD_DEVICE.sectionPV.push(section_PV[i].childNodes[0].childNodes[0].name);
    }
  }

  let section_RV = document.getElementById("section_RV").childNodes;
  for (var i = 0; i < section_RV.length; i++) {
    if (section_RV[i].childNodes[0].childNodes[0].checked) {
      CARD_DEVICE.sectionRV.push(section_RV[i].childNodes[0].childNodes[0].name);
    }
  }

  //console.log('CARD_DEVICE', CARD_DEVICE); // ▼ ТИП УСТРОЙСТВА СОГЛАСНО ЕСОП ▼

  if (CARD_DEVICE.typeDevice === "17620") {
    CARD_DEVICE.typeESOP = "70";
    // так же для 3438, 3439 ЕСОП - 91
  } else {
    CARD_DEVICE.typeESOP = 0;
  }

  let keyForClear = [];
  let ooPVdel = null,
    oqPVdel = null,
    ooRVdel = null,
    oqRVdel = null;
  if (CACHE_EDIT_R_DEVICE.id === "-1") {
    for (var i = 0; i < virtualRadio.length; i++) {
      if (virtualRadio[i].numberRadio === CACHE_EDIT_R_DEVICE.id) {
        if (virtualRadio[i].PV[0] !== CARD_DEVICE.numberPV) {
          ooPVdel = "oo" + virtualRadio[i].PV[0];
          oqPVdel = "oq" + virtualRadio[i].PV[0];
        }
        if (virtualRadio[i].RV[0] !== CARD_DEVICE.numberRV) {
          ooRVdel = "oo" + virtualRadio[i].PV[0];
          oqRVdel = "oq" + virtualRadio[i].PV[0];
        }
      }
    }
  }

  let keyForClearPv = {};
  let keyForClearRv = {};
  /* ОЧИСТКА СТАРЫХ КЛЮЧЕЙ ЕСЛИ ПВ НЕ ИСПОЛЬЗУЕТСЯ -----*/
  if (CARD_DEVICE.numberPV == "0") {
    let idDev = CACHE_EDIT_R_DEVICE.id;
    for (var i = 0; i < virtualRadio.length; i++) {
      if (virtualRadio[i].numberRadio == idDev) {
        keyForClearPv["xxnu" + idDev] = [
          {
            value: "0",
            index: 1,
          },
          {
            value: "0",
            index: 2,
          },
        ];
        keyForClearPv["oo" + virtualRadio[i].PV[0]] = [
          {
            value: "0",
            index: 1,
          },
          {
            value: "0",
            index: 2,
          },
        ];
        keyForClearPv["oq" + virtualRadio[i].PV[0]] = [
          {
            value: "0",
            index: 1,
          },
        ];
        keyForClearPv["or" + virtualRadio[i].PV[0]] = [
          {
            value: "0",
            index: 1,
          },
        ];
        keyForClearPv["ob" + virtualRadio[i].PV[0]] = [
          {
            value: "0",
            index: 1,
          },
        ];
        keyForClearPv["og" + virtualRadio[i].PV[0]] = [
          {
            value: "0",
            index: 1,
          },
        ];
        keyForClearPv["ot" + virtualRadio[i].PV[0]] = [
          {
            value: "0",
            index: 1,
          },
        ];
        keyForClearPv["of" + virtualRadio[i].PV[0]] = [
          {
            value: "0",
            index: 1,
          },
        ];
        break;
      }
    }
  }
  /* ----ОЧИСТКА СТАРЫХ КЛЮЧЕЙ ЕСЛИ ПВ НЕ ИСПОЛЬЗУЕТСЯ */

  /* ОЧИСТКА СТАРЫХ КЛЮЧЕЙ ЕСЛИ РВ НЕ ИСПОЛЬЗУЕТСЯ ----- */
  if (CARD_DEVICE.numberRV == "0") {
    let idDev = CACHE_EDIT_R_DEVICE.id;
    for (var i = 0; i < virtualRadio.length; i++) {
      if (virtualRadio[i].numberRadio == idDev) {
        keyForClearRv["xxnr" + idDev] = [
          {
            value: "0",
            index: 1,
          },
          {
            value: "0",
            index: 2,
          },
        ];
        keyForClearRv["oo" + virtualRadio[i].RV[0]] = [
          {
            value: "0",
            index: 1,
          },
          {
            value: "0",
            index: 2,
          },
        ];

        keyForClearRv["oq" + virtualRadio[i].RV[0]] = [
          {
            value: "0",
            index: 1,
          },
        ];
        keyForClearRv["or" + virtualRadio[i].RV[0]] = [
          {
            value: "0",
            index: 1,
          },
        ];
        keyForClearRv["ob" + virtualRadio[i].RV[0]] = [
          {
            value: "0",
            index: 1,
          },
        ];
        keyForClearRv["og" + virtualRadio[i].RV[0]] = [
          {
            value: "0",
            index: 1,
          },
        ];
        keyForClearRv["ot" + virtualRadio[i].RV[0]] = [
          {
            value: "0",
            index: 1,
          },
        ];
        keyForClearRv["of" + virtualRadio[i].RV[0]] = [
          {
            value: "0",
            index: 1,
          },
        ];
        break;
      }
    }
  }
  /* ----- ОЧИСТКА СТАРЫХ КЛЮЧЕЙ ЕСЛИ РВ НЕ ИСПОЛЬЗУЕТСЯ */

  //console.log(keyForClearRkps);

  // СОХРАНЯЕМ
  for (i in deviceJSON.config) {
    if (keyForClearPv[deviceJSON.config[i].key]) {
      // Удаляем конфиг ПВ если не используется
      deviceJSON.config[i].subvalues = keyForClearPv[deviceJSON.config[i].key];

    }
    if (keyForClearRv[deviceJSON.config[i].key]) {
      // Удаляем конфиг РВ если не используется
      deviceJSON.config[i].subvalues = keyForClearRv[deviceJSON.config[i].key];

    }
  }


  //let error = checkNewRadio(CARD_DEVICE); // Проверяем корректность данных
  let error7620 = checkNew7620(CARD_DEVICE, mixAll)

  // console.log('error7620', error7620);


  if (!error7620.error) {
    // Данные валидны
    $.hide("#modal_r_device_error"); // Скрываем область ошибок
    //   console.log('error7620.error', error7620.error);
    applyNew7620(CARD_DEVICE, mixAll); // Отправляем в ядро
    if(!mixAll){
      liveSaveInterface();
    } 
    if (mixAll !== 'AllDevice') {
      closeModalR_dev(); // Чистим кэш и закрывем карточку
    }

  } else {
    // Выводим ошибку
    let txtError =
      '<span style="position:inherit; float:right;" onclick=\'$.hide("#modal_r_device_error")\' class="w3-button">×</span>';
    txtError += '<b> &#9888; Ошибка при сохранении:</b> <ul class="w3-ul">';
    for (var i = 0; i < error7620.listError.length; i++) {
      txtError += "<li>" + error7620.listError[i].description + "</li>";
    }
    txtError += "</ul>";
    document.getElementById("modal_r_device_error").innerHTML = txtError;
    $.show("#modal_r_device_error"); // отображаем ошибки
    document.getElementById("detailsCard").open = false; // сворачиваем Описание
  }
  if (mixAll === 'AllDevice') {
    set_r_device_name("1");
    document.getElementById("modal_r_device_name").value = "1";
  }
  
}

function checkNewRadio(CARD_DEVICE, mixAll) {
  // ПРОВЕРКА КОРРЕКТНОСТИ ДАННЫХ ИЗ КАРТОЧКИ УСТРОЙСТВА
  let RESULT_ERROR = {
    error: false,
    listError: [],
  };
  let description = "";

  // ▼ Проверка названия устройства
  if (CARD_DEVICE.typeESOP === 0) {
    description = "- Не выбран тип устройства";
    RESULT_ERROR.error = true;
    RESULT_ERROR["listError"].push({
      nameKey: null,
      description: description,
    });
  }

  /* =====ПРОВЕРЯЕМ НОМЕРА ЗОН====================================== */

  // ▼ Проверка на совпадение номера Основной и Доп зоны ▼
  if (mixAll === 'no') {
    for (var i = 0; i < virtualExe.length; i++) {
      // ▼ Проверка на занятость зоны другим усттройством ▼
      if (virtualExe[i].numberExe != null && virtualExe[i].numberExe !== '0') {
        if (virtualExe[i].numberExe === checkNumber1) {
          // Проверить CARD_DEVICE.id или id
          if (virtualExe[i].link !== CARD_DEVICE.id.slice(4)) {
            description =
              "<b><i>- Выход №" +
              checkNumber1 +
              '</b></i> уже используется другим <span style="cursor:help" title="';
            if (virtualExe[i].typeDev === "radio") {
              description += "Радиоканальное устройство №";
            } else if (virtualExe[i].typeDev === "cabel") {
              description += "Расширитель №";
            } else {
              description += "Устройство №";
            }
            description +=
              virtualExe[i].link +
              '"><b><i>устройством(?)</i></b></span>, измените номер выхода';
            RESULT_ERROR.error = true;
            RESULT_ERROR["listError"].push({
              nameKey: null,
              description: description,
            });
          }
        } else if (
          virtualExe[i].numberExe === checkNumber2 &&
          virtualExe[i].link !== CARD_DEVICE.id.slice(4) /* && 
                virtualZone[i].typeDev === "rad" */
        ) {
          description =
            "<b><i>- Выход №" +
            checkNumber2 +
            '</b></i> уже используется другим <span style="cursor:help" title="';
          if (virtualExe[i].typeDev === "radio") {
            description += "Радиоканальное устройство №";
          } else if (virtualExe[i].typeDev === "cabel") {
            description += "Расширитель №";
          } else {
            description += "Устройство №";
          }
          description +=
            virtualExe[i].link +
            '"><b><i>устройством(?)</i></b><span>, измените номер выхода';
          RESULT_ERROR.error = true;
          RESULT_ERROR["listError"].push({
            nameKey: null,
            description: description,
          });
        }




      }
    }
    if (
      checkNumber1 === checkNumber2 &&
      checkNumber1 != "0" &&
      checkNumber2 != "0"
    ) {
      if (checkNumber1 !== null && checkNumber2 !== null) {
        description = "- Основной и дополнительный выход должны иметь разные номера";
        RESULT_ERROR.error = true;
        RESULT_ERROR["listError"].push({
          nameKey: null,
          description: description,
        });
      }
    }


  } else {
    if (
      CARD_DEVICE.numberZone_1 === CARD_DEVICE.numberZone_2 &&
      CARD_DEVICE.numberZone_1 != "0" &&
      CARD_DEVICE.numberZone_2 != "0"
    ) {
      if (CARD_DEVICE.numberZone_1 !== null && CARD_DEVICE.numberZone_2 !== null) {
        description = "- Основная и дополнительная зона должны иметь разные номера";
        RESULT_ERROR.error = true;
        RESULT_ERROR["listError"].push({
          nameKey: null,
          description: description,
        });
      }
    }

    // ▼ Проверка зоны 1 на допустимое значение ▼
    //if (+CARD_DEVICE.numberZone_1 > 192 || +CARD_DEVICE.numberZone_1 < 0 || +CARD_DEVICE.numberZone_1 === 0) {
    if (+CARD_DEVICE.numberZone_1 > 193 || +CARD_DEVICE.numberZone_1 < 0 || CARD_DEVICE.numberZone_1 == '') {
      if (CARD_DEVICE.numberZone_1 !== null) {
        description = "- Номер зоны " + CARD_DEVICE.numberZone_1 + " недопустим, введите число от 1 до 193";
        RESULT_ERROR.error = true;
        RESULT_ERROR["listError"].push({
          nameKey: null,
          description: description,
        });
      }
    }

    // ▼ Проверка зоны 2 на допустимое значение ▼
    // if (+CARD_DEVICE.numberZone_2 > 192 || +CARD_DEVICE.numberZone_2 < 0 || +CARD_DEVICE.numberZone_2 === 0) { БЫЛО ТАК ПОКА НЕ УБРАЛИ ПРОВЕРКУ НА 0 ЗОНУ
    if (+CARD_DEVICE.numberZone_2 > 193 || +CARD_DEVICE.numberZone_2 < 0 || CARD_DEVICE.numberZone_2 == '') {
      if (CARD_DEVICE.numberZone_2 !== null) {
        description = "- Номер зоны " + CARD_DEVICE.numberZone_2 + " недопустим, введите число от 1 до 193";
        RESULT_ERROR.error = true;
        RESULT_ERROR["listError"].push({
          nameKey: null,
          description: description,
        });
      }
    }

    let errorClassSection_1 = false; // Проверка дубль тип/раздел 1
    let errorClassSection_2 = false; // Проверка дубль тип/раздел 1
    let errorDelayZone_1 = false; // Проверка дубль задержка 1
    let errorDelayZone_2 = false; // Проверка дубль задержка 1
    for (var i = 0; i < virtualZone.length; i++) {
      // ▼ Проверка на занятость зоны другим усттройством ▼
      if (virtualZone[i].typeDev != null && virtualZone[i].numberZone !== '0') {
        if (virtualZone[i].numberZone === CARD_DEVICE.numberZone_1) {
          // Проверить CARD_DEVICE.id или id
          if (virtualZone[i].link.slice(4) !== CARD_DEVICE.id.slice(4)) {
            description =
              "<b><i>- Зона №" +
              CARD_DEVICE.numberZone_1 +
              '</b></i> уже используется другим <span style="cursor:help" title="';
            if (virtualZone[i].typeDev === "rad") {
              description += "Радиоканальное устройство №";
            } else if (virtualZone[i].typeDev === "ext") {
              description += "Расширитель №";
            } else {
              description += "Устройство №";
            }
            description +=
              virtualZone[i].link[virtualZone[i].link.length - 1] +
              '"><b><i>устройством(?)</i></b></span>, измените номер зоны';
            RESULT_ERROR.error = true;
            RESULT_ERROR["listError"].push({
              nameKey: null,
              description: description,
            });
          }
        } else if (
          virtualZone[i].numberZone === CARD_DEVICE.numberZone_2 &&
          virtualZone[i].link.slice(4) !== CARD_DEVICE.id.slice(4) /* && 
          virtualZone[i].typeDev === "rad" */
        ) {
          description =
            "<b><i>- Зона №" +
            CARD_DEVICE.numberZone_2 +
            '</b></i> уже используется другим <span style="cursor:help" title="';
          if (virtualZone[i].typeDev === "rad") {
            description += "Радиоканальное устройство №";
          } else if (virtualZone[i].typeDev === "ext") {
            description += "Расширитель №";
          } else {
            description += "Устройство №";
          }
          description +=
            virtualZone[i].link[virtualZone[i].link.length - 1] +
            '"><b><i>устройством(?)</i></b><span>, измените номер зоны';
          RESULT_ERROR.error = true;
          RESULT_ERROR["listError"].push({
            nameKey: null,
            description: description,
          });
        }
  

        // ▼ Проверка задержки 1 на допустимое значение ▼
        if (+CARD_DEVICE.delayZone_1 < 0 || +CARD_DEVICE.delayZone_1 > 180) {
          if (CARD_DEVICE.delayZone_1 !== null) {
            if (!errorDelayZone_1) {
              errorDelayZone_1 = true; //проверка на дубль
              description = "- Задержка для зоны " + CARD_DEVICE.numberZone_1 + " недопустима, введите число от 0 до 180";
              RESULT_ERROR.error = true;
              RESULT_ERROR["listError"].push({
                nameKey: null,
                description: description,
              });
            }
          }
        }

        // ▼ Проверка задержки 2 на допустимое значение ▼
        if (+CARD_DEVICE.delayZone_2 < 0 || +CARD_DEVICE.delayZone_2 > 180) {
          if (CARD_DEVICE.delayZone_2 !== null) {
            if (!errorDelayZone_2) {
              errorDelayZone_2 = true; //проверка на дубль
              description = "- Задержка для зоны " + CARD_DEVICE.numberZone_2 + " недопустима, введите число от 0 до 180";
              RESULT_ERROR.error = true;
              RESULT_ERROR["listError"].push({
                nameKey: null,
                description: description,
              });
            }
          }
        }
      }

    }
  }


  return RESULT_ERROR;
}
function checkNew7620(CARD_DEVICE, mixAll) {
  // ПРОВЕРКА КОРРЕКТНОСТИ ДАННЫХ ИЗ КАРТОЧКИ УСТРОЙСТВА
  let RESULT_ERROR = {
    error: false,
    listError: [],
  };
  let description = "";

  // ▼ Проверка названия устройства
  if (CARD_DEVICE.typeESOP === 0) {
    description = "- Не выбран тип устройства";
    RESULT_ERROR.error = true;
    RESULT_ERROR["listError"].push({
      nameKey: null,
      description: description,
    });
  }
  if (mixAll === 'no') {
    for (var i = 0; i < virtualExe.length; i++) {
      // ▼ Проверка на занятость зоны другим усттройством ▼
      if (virtualExe[i].numberExe != null && virtualExe[i].numberExe !== '0') {
        if (virtualExe[i].numberExe === checkNumber1) {
          // Проверить CARD_DEVICE.id или id
          if (virtualExe[i].link !== CARD_DEVICE.id.slice(4)) {
            description =
              "<b><i>- Выход №" +
              checkNumber1 +
              '</b></i> уже используется другим <span style="cursor:help" title="';
            if (virtualExe[i].typeDev === "radio") {
              description += "Радиоканальное устройство №";
            } else if (virtualExe[i].typeDev === "cabel") {
              description += "Расширитель №";
            } else {
              description += "Устройство №";
            }
            description +=
              virtualExe[i].link +
              '"><b><i>устройством(?)</i></b></span>, измените номер выхода';
            RESULT_ERROR.error = true;
            RESULT_ERROR["listError"].push({
              nameKey: null,
              description: description,
            });
          }
        } else if (
          virtualExe[i].numberExe === checkNumber2 &&
          virtualExe[i].link !== CARD_DEVICE.id.slice(4) /* && 
                virtualZone[i].typeDev === "rad" */
        ) {
          description =
            "<b><i>- Выход №" +
            checkNumber2 +
            '</b></i> уже используется другим <span style="cursor:help" title="';
          if (virtualExe[i].typeDev === "radio") {
            description += "Радиоканальное устройство №";
          } else if (virtualExe[i].typeDev === "cabel") {
            description += "Расширитель №";
          } else {
            description += "Устройство №";
          }
          description +=
            virtualExe[i].link +
            '"><b><i>устройством(?)</i></b><span>, измените номер выхода';
          RESULT_ERROR.error = true;
          RESULT_ERROR["listError"].push({
            nameKey: null,
            description: description,
          });
        }




      }
    }
    if (
      checkNumber1 === checkNumber2 &&
      checkNumber1 != "0" &&
      checkNumber2 != "0"
    ) {
      if (checkNumber1 !== null && checkNumber2 !== null) {
        description = "- Основной и дополнительный выход должны иметь разные номера";
        RESULT_ERROR.error = true;
        RESULT_ERROR["listError"].push({
          nameKey: null,
          description: description,
        });
      }
    }


  }
  else {
    /* =====ПРОВЕРЯЕМ НОМЕРА ВЫХОДА====================================== */

    // ▼ Проверка на совпадение номера Основной и Доп выхода ▼
    if (
      CARD_DEVICE.numberPV === CARD_DEVICE.numberRV &&
      CARD_DEVICE.numberPV != "0" &&
      CARD_DEVICE.numberRV != "0"
    ) {
      if (CARD_DEVICE.numberPV !== null && CARD_DEVICE.numberRV !== null) {
        description = "- Основной и дополнительный выход должны иметь разные номера";
        RESULT_ERROR.error = true;
        RESULT_ERROR["listError"].push({
          nameKey: null,
          description: description,
        });
      }
    }

    // ▼ Проверка выхода 1 на допустимое значение ▼
    //if (+CARD_DEVICE.numberZone_1 > 192 || +CARD_DEVICE.numberZone_1 < 0 || +CARD_DEVICE.numberZone_1 === 0) {
    if (+CARD_DEVICE.numberPV > 129 || +CARD_DEVICE.numberPV < 0) {
      if (CARD_DEVICE.numberPV !== null) {
        description = "- Номер выхода " + CARD_DEVICE.numberPV + " недопустим, введите число от 1 до 129";
        RESULT_ERROR.error = true;
        RESULT_ERROR["listError"].push({
          nameKey: null,
          description: description,
        });
      }
    }

    // ▼ Проверка выхода 2 на допустимое значение ▼
    // if (+CARD_DEVICE.numberZone_2 > 192 || +CARD_DEVICE.numberZone_2 < 0 || +CARD_DEVICE.numberZone_2 === 0) { БЫЛО ТАК ПОКА НЕ УБРАЛИ ПРОВЕРКУ НА 0 ЗОНУ
    if (+CARD_DEVICE.numberRV > 129 || +CARD_DEVICE.numberRV < 0) {
      if (CARD_DEVICE.numberRV !== null) {
        description = "- Номер выхода " + CARD_DEVICE.numberRV + " недопустим, введите число от 1 до 129";
        RESULT_ERROR.error = true;
        RESULT_ERROR["listError"].push({
          nameKey: null,
          description: description,
        });
      }
    }

    let errorClassSection_1 = false; // Проверка дубль тип/раздел 1
    let errorClassSection_2 = false; // Проверка дубль тип/раздел 1
    let errorDelayPV = false; // Проверка дубль задержка 1
    let errorDelayRV = false; // Проверка дубль задержка 1
    for (var i = 0; i < virtualExe.length; i++) {
      // ▼ Проверка на занятость зоны другим усттройством ▼
      if (virtualExe[i].numberExe != null && virtualExe[i].numberExe !== '0') {
        if (virtualExe[i].numberExe === CARD_DEVICE.numberPV) {
          // Проверить CARD_DEVICE.id или id
          if (virtualExe[i].link !== CARD_DEVICE.id.slice(4)) {
            description =
              "<b><i>- Выход №" +
              CARD_DEVICE.numberPV +
              '</b></i> уже используется другим <span style="cursor:help" title="';
            if (virtualExe[i].typeDev === "radio") {
              description += "Радиоканальное устройство №";
            } else if (virtualExe[i].typeDev === "cabel") {
              description += "Расширитель №";
            } else {
              description += "Устройство №";
            }
            description +=
              virtualExe[i].link +
              '"><b><i>устройством(?)</i></b></span>, измените номер выхода';
            RESULT_ERROR.error = true;
            RESULT_ERROR["listError"].push({
              nameKey: null,
              description: description,
            });
          }
        } else if (
          virtualExe[i].numberExe === CARD_DEVICE.numberRV &&
          virtualExe[i].link !== CARD_DEVICE.id.slice(4) /* && 
            virtualZone[i].typeDev === "rad" */
        ) {
          description =
            "<b><i>- Выход №" +
            CARD_DEVICE.numberRV +
            '</b></i> уже используется другим <span style="cursor:help" title="';
          if (virtualExe[i].typeDev === "radio") {
            description += "Радиоканальное устройство №";
          } else if (virtualExe[i].typeDev === "cabel") {
            description += "Расширитель №";
          } else {
            description += "Устройство №";
          }
          description +=
            virtualExe[i].link +
            '"><b><i>устройством(?)</i></b><span>, измените номер выхода';
          RESULT_ERROR.error = true;
          RESULT_ERROR["listError"].push({
            nameKey: null,
            description: description,
          });
        }


        // ▼ Проверка задержки 1 на допустимое значение ▼
        if (+CARD_DEVICE.delayPV < 0 || +CARD_DEVICE.delayPV > 999) {
          if (CARD_DEVICE.delayPV !== null) {
            if (!errorDelayPV) {
              errorDelayPV = true; //проверка на дубль
              description = "- Задержка для зоны " + CARD_DEVICE.numberPV + " недопустима, введите число от 0 до 999";
              RESULT_ERROR.error = true;
              RESULT_ERROR["listError"].push({
                nameKey: null,
                description: description,
              });
            }
          }
        }

        // ▼ Проверка задержки 2 на допустимое значение ▼
        if (+CARD_DEVICE.delayRV < 0 || +CARD_DEVICE.delayRV > 999) {
          if (CARD_DEVICE.delayRV !== null) {
            if (!errorDelayRV) {
              errorDelayRV = true; //проверка на дубль
              description = "- Задержка для зоны " + CARD_DEVICE.numberRV + " недопустима, введите число от 0 до 999";
              RESULT_ERROR.error = true;
              RESULT_ERROR["listError"].push({
                nameKey: null,
                description: description,
              });
            }
          }
        }
      }
    }
  }


  return RESULT_ERROR;
}


function applyNewRadio(CARD_DEVICE, mixAll) {
  // ОТПРАВЛЯЕМ ДАННЫЕ ИЗ КАРТОЧКИ УСТРОЙСТВА В ЯДРО И ЗАПУСКАЕМ ПОИСК И РЕНДЕР ВСЕХ КЛЮЧЕЙ
  let keyXXDR = "xxdr" + CARD_DEVICE.id.slice(4);
  let keyXXSS = "xxss" + CARD_DEVICE.id.slice(4);
  let keyXXNB = "xxnb" + CARD_DEVICE.id.slice(4);
  let keyLw1 = "lw" + CARD_DEVICE.numberZone_1; // Ключ номера зоны 1
  let keyLw2 = "lw" + CARD_DEVICE.numberZone_2; // Ключ номера зоны 2
  let keyYz1 = "yz" + CARD_DEVICE.numberZone_1; // Ключ номера раздела 1
  let keyYz2 = "yz" + CARD_DEVICE.numberZone_2; // Ключ номера раздела 2
  let focusID = false;
  //console.log('CARD_DEVICEapplyNewRadio', CARD_DEVICE);
  if (CARD_DEVICE.sectionZone_1 !== "" && CARD_DEVICE.sectionZone_1 !== null) {
    focusID = "blk_sec_n_" + CARD_DEVICE.sectionZone_1;
  } else if (CARD_DEVICE.sectionZone_2 !== "" && CARD_DEVICE.sectionZone_2 !== null) {
    focusID = "blk_sec_n_" + CARD_DEVICE.sectionZone_2;
  } else {
    focusID = false;
  }

  if (CARD_DEVICE.typeZone_1 !== null) {
    CARD_DEVICE.typeZone_1 = CARD_DEVICE.typeZone_1.replace("D", ""); // Убираем из Охр. с фикс. зад. D
    CARD_DEVICE.typeZone_1 = CARD_DEVICE.typeZone_1.replace("noused", "1"); // Заменяем неиспользуемое на 0
  }
  if (CARD_DEVICE.typeZone_2 !== null) {
    CARD_DEVICE.typeZone_2 = CARD_DEVICE.typeZone_2.replace("D", ""); // Убираем из Охр. с фикс. зад. D
    CARD_DEVICE.typeZone_2 = CARD_DEVICE.typeZone_2.replace("noused", "1"); // Заменяем неиспользуемое на 0
  }

  if (!false) {
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key === CARD_DEVICE.id) {
        // XXAD
        let serialRadio = "0";
        for (j in virtualRadio) {
          if (virtualRadio[j].link.slice(4) === CARD_DEVICE.id.slice(4)) {
            serialRadio = virtualRadio[j].serial;
          }
        }
        deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.typeESOP; // Тип устройства согласно ЕСОП
        deviceJSON.config[i].subvalues[1].value = CARD_DEVICE.typeDevice; // Модель устройства
        deviceJSON.config[i].subvalues[2].value = serialRadio; // Serial устройства
        
          saveConfigAll(deviceJSON.config[i]);
        
      }

      if (deviceJSON.config[i].key === keyXXSS) {
        //XXSS
        if (CARD_DEVICE.PARAM_XXSS != null) {
          deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.PARAM_XXSS + "";
          saveConfigAll(deviceJSON.config[i]);
        }
      }

      if (CARD_DEVICE.PARAM_XXNB !== null) {
        if (deviceJSON.config[i].key === keyXXNB) {
          //XXNB
          deviceJSON.config[i].subvalues[0].value = "4";
          deviceJSON.config[i].subvalues[1].value = CARD_DEVICE.PARAM_XXNB + "";
          saveConfigAll(deviceJSON.config[i]);
        }
      }

      if (deviceJSON.config[i].key === keyXXDR) {
        if (
          deviceJSON.config[i].subvalues[0].value !== CARD_DEVICE.numberZone_1 &&
          deviceJSON.config[i].subvalues[0].value !== "0" &&
          deviceJSON.config[i].subvalues[0].value !== CARD_DEVICE.numberZone_2
        ) {
          let lwDelete = "lw" + deviceJSON.config[i].subvalues[0].value;
          let yzDelete = "yz" + deviceJSON.config[i].subvalues[0].value;
          keyForDelete.push(lwDelete, yzDelete);
        }

        if (
          deviceJSON.config[i].subvalues[1].value !== CARD_DEVICE.numberZone_2 &&
          deviceJSON.config[i].subvalues[1].value !== "0" &&
          deviceJSON.config[i].subvalues[0].value !== CARD_DEVICE.numberZone_1
        ) {
          let lwDelete = "lw" + deviceJSON.config[i].subvalues[1].value;
          let yzDelete = "yz" + deviceJSON.config[i].subvalues[1].value;
          keyForDelete.push(lwDelete, yzDelete);
        }

        // XXDR
        if (CARD_DEVICE.numberZone_1 !== null) {
          deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.numberZone_1; // номер зоны 1
        }

        if (CARD_DEVICE.numberZone_2 !== null) {
          deviceJSON.config[i].subvalues[1].value = CARD_DEVICE.numberZone_2; // номер зоны 2
        }
        saveConfigAll(deviceJSON.config[i]);
      }

      if (deviceJSON.config[i].key === keyLw1) {
        if (keyLw1 !== "lw") {
          //проверяем что ключ зоны корректен
          deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.typeZone_1.charAt(0);
          if (document.getElementById("modal_r_device_zone_type_1").value === "noused") {
            deviceJSON.config[i].subvalues[1].value = "0";
            // если зона не Используется
          } else {
            deviceJSON.config[i].subvalues[1].value = CARD_DEVICE.typeZone_1.slice(2);
          }

          if (
            (CARD_DEVICE.delayZone_1 === "" || CARD_DEVICE.delayZone_1 === null) &&
            (CARD_DEVICE.delayZone_Exit_1 === "" || CARD_DEVICE.delayZone_Exit_1 === null)
          ) {
            deviceJSON.config[i].subvalues[2].value = "0,0"; // Если задержка пустая шлем 0
          } else {
            deviceJSON.config[i].subvalues[2].value = CARD_DEVICE.delayZone_1 + "," + CARD_DEVICE.delayZone_Exit_1;
          }
        }
        saveConfigAll(deviceJSON.config[i]);
      }

      if (deviceJSON.config[i].key === keyLw2) {
        if (keyLw2 !== "lw") {
          //проверяем что ключ зоны корректен
          deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.typeZone_2.charAt(0);

          if (document.getElementById("modal_r_device_zone_type_2").value === "noused") {
            deviceJSON.config[i].subvalues[1].value = "0";
          } else {
            // если зона не Используется
            deviceJSON.config[i].subvalues[1].value = CARD_DEVICE.typeZone_2.slice(2);
          }

          if (
            (CARD_DEVICE.delayZone_2 === "" || CARD_DEVICE.delayZone_2 === null) &&
            (CARD_DEVICE.delayZone_Exit_2 === "" || CARD_DEVICE.delayZone_Exit_2 === null)
          ) {
            deviceJSON.config[i].subvalues[2].value = "0,0"; // Если задержка пустая шлем 0
          } else {
            deviceJSON.config[i].subvalues[2].value = CARD_DEVICE.delayZone_2 + "," + CARD_DEVICE.delayZone_Exit_2;
          }
        }
        saveConfigAll(deviceJSON.config[i]);
      }

      if (deviceJSON.config[i].key === keyYz1) {
        deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.sectionZone_1;
        saveConfigAll(deviceJSON.config[i]);
      }

      if (deviceJSON.config[i].key === keyYz2) {
        deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.sectionZone_2;
        saveConfigAll(deviceJSON.config[i]);
      }
    }
  }


  if (mixAll !== 'AllDevice') {
    closeModalR_dev();
    clearExpiredKey();
    displayTabs()
    if (!mixAll) {
      parseAppKey("update_notabs");
    }

  }
  // Чистим кэш и закрывем карточку
  if (document.getElementById(focusID)) {
    document.getElementById(focusID).scrollIntoView();
  }
}
function applyNew7620(CARD_DEVICE, mixAll) {
  //console.log('ОТПРАВЛЯЕМ ДАННЫЕ ИЗ КАРТОЧКИ УСТРОЙСТВА В ЯДРО И ЗАПУСКАЕМ ПОИСК И РЕНДЕР ВСЕХ КЛЮЧЕЙ');
  //console.log('CARD_DEVICEapplyNew7620', CARD_DEVICE);
  // СОХРАНЯЕМ
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == CARD_DEVICE.id) {
      deviceJSON.config[i].subvalues[0].value = "70";
      deviceJSON.config[i].subvalues[1].value = "17620";
      // deviceJSON.config[i].subvalues[2].value = "0";
      // deviceJSON.config[i].subvalues[3].value = "0";
      saveConfigAll(deviceJSON.config[i]);
    } else if (deviceJSON.config[i].key == CARD_DEVICE.xxdr) {
      deviceJSON.config[i].subvalues[0].value = "0";
      deviceJSON.config[i].subvalues[1].value = "0";
      saveConfigAll(deviceJSON.config[i]);
    } else if (deviceJSON.config[i].key === "xxss" + CARD_DEVICE.xxIndex) {
      deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.PARAM_XXSS;
      saveConfigAll(deviceJSON.config[i]);
    } else if (deviceJSON.config[i].key === "xxnu" + CARD_DEVICE.xxIndex) {
      deviceJSON.config[i].subvalues[0].value = "1";
      deviceJSON.config[i].subvalues[1].value = CARD_DEVICE.numberPV;
      saveConfigAll(deviceJSON.config[i]);
    } else if (deviceJSON.config[i].key === "xxnr" + CARD_DEVICE.xxIndex) {
      deviceJSON.config[i].subvalues[0].value = "1";
      deviceJSON.config[i].subvalues[1].value = CARD_DEVICE.numberRV;
      saveConfigAll(deviceJSON.config[i]);
    } else if (deviceJSON.config[i].key === "nf" + CARD_DEVICE.numberPV) {
      deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.notificationPV;
      saveConfigAll(deviceJSON.config[i]);
    } else if (deviceJSON.config[i].key === "nf" + CARD_DEVICE.numberRV) {
      deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.notificationRV;
      saveConfigAll(deviceJSON.config[i]);
    } else if (deviceJSON.config[i].key === "oo" + CARD_DEVICE.numberPV) {
      // ПВ режим/время
      deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.typeActionPV;
      deviceJSON.config[i].subvalues[1].value = CARD_DEVICE.delayPV || '1';
      saveConfigAll(deviceJSON.config[i]);
    } else if (deviceJSON.config[i].key === "oo" + CARD_DEVICE.numberRV) {
      // РВ режим/время
      deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.typeActionRV;
      deviceJSON.config[i].subvalues[1].value = CARD_DEVICE.delayRV || '0';
      saveConfigAll(deviceJSON.config[i]);
    } else if (deviceJSON.config[i].key === "oq" + CARD_DEVICE.numberPV) {
      // РВ режим/время
      deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.sectionPV.toString();
      saveConfigAll(deviceJSON.config[i]);
    } else if (deviceJSON.config[i].key === "oq" + CARD_DEVICE.numberRV) {
      // РВ режим/время
      deviceJSON.config[i].subvalues[0].value = CARD_DEVICE.sectionRV.toString();
      saveConfigAll(deviceJSON.config[i]);
    }
    // else if (deviceJSON.config[i].key === ooPVdel || deviceJSON.config[i].key === ooRVdel) {
    //   deviceJSON.config[i].subvalues[0].value = "0";
    //   deviceJSON.config[i].subvalues[1].value = "0";
    // } else if (deviceJSON.config[i].key === oqPVdel || deviceJSON.config[i].key === oqRVdel) {
    //   deviceJSON.config[i].subvalues[0].value = "0";
    // }
  }

  for (var k = 0; k < CARD_DEVICE.triggerPV.length; k++) {
    // Сохраняем сработки ПВ
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == CARD_DEVICE.triggerPV[k].name) {
        if (CARD_DEVICE.triggerPV[k].value) {
          deviceJSON.config[i].subvalues[0].value = "1";
          saveConfigAll(deviceJSON.config[i]);
          break;
        } else {
          deviceJSON.config[i].subvalues[0].value = "0";
          saveConfigAll(deviceJSON.config[i]);
          break;
        }
      }
    }
  }

  for (var k = 0; k < CARD_DEVICE.triggerRV.length; k++) {
    // Сохраняем сработки РВ
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == CARD_DEVICE.triggerRV[k].name) {
        if (CARD_DEVICE.triggerRV[k].value) {
          deviceJSON.config[i].subvalues[0].value = "1";
          saveConfigAll(deviceJSON.config[i]);
          break;
        } else {
          deviceJSON.config[i].subvalues[0].value = "0";
          saveConfigAll(deviceJSON.config[i]);
          break;
        }
      }
    }
  }


  if (mixAll !== 'AllDevice') {
    closeModalR_dev();
    clearExpiredKey();
    displayTabs()
    if (!mixAll) {
      parseAppKey("update_notabs");
    } // Чистим кэш и закрывем карточку
  }

}
function clearExpiredKey() {
  let error;
  for (var k = 0; k < keyForDelete.length; k++) {
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key === keyForDelete[k]) {
        if (keyForDelete[k].indexOf("lw") != -1) {
          console.log("Отчистка ключа " + keyForDelete[k]);
          deviceJSON.config[i].subvalues[0].value = "0";
          deviceJSON.config[i].subvalues[1].value = "0";
          deviceJSON.config[i].subvalues[2].value = "0,0";
          saveConfig(deviceJSON.config[i]);
        } else if (keyForDelete[k].indexOf("yz") != -1) {
          console.log("Отчистка ключа " + keyForDelete[k]);
          deviceJSON.config[i].subvalues[0].value = "1";
          saveConfig(deviceJSON.config[i]);
        } else {
          console.log("Функция отчистки ключа " + keyForDelete[k] + " не описана!!!!!!!!!!");
        }
      }
    }
  }
  keyForDelete = [];
}

function transformParamSensor(param0, param1, param2) {
  if (param2 && param1 && param0) {
    return 7;
  } else if (param2 && param1 && !param0) {
    return 6;
  } else if (param2 && !param1 && !param0) {
    return 4;
  } else if (!param2 && !param1 && !param0) {
    return 0;
  } else if (!param2 && !param1 && param0) {
    return 1;
  } else if (param2 && !param1 && param0) {
    return 5;
  } else if (!param2 && param1 && param0) {
    return 3;
  } else if (!param2 && param1 && !param0) {
    return 2;
  } else {
    return 7;
  }
}
