function zone_create_list(data) {
  let nameDevice = data.subvalues[1].value;
  let numberDevice = data.key.substring(4); // номер устройства
  let firstZone, secondZone;

  let number_1_Cannel = "xxdr" + numberDevice + "_0"; //Название первой зоны
  let number_2_Cannel = "xxdr" + numberDevice + "_1"; // название второй зоны
  let LW_YZ_1 = dataDevice[number_1_Cannel].value; // номер ключа LW и YZ для основного
  let LW_YZ_2 = dataDevice[number_2_Cannel].value; // номер ключа LW и YZ для дополительного

  let configLW_1 = {};
  let configYZ_1 = {};

  let configLW_2 = {};
  let configYZ_2 = {};

  if (LW_YZ_1 != "") {
    let nameYZ1 = "yz" + LW_YZ_1;
    let nameLW1 = "lw" + LW_YZ_1;
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == nameYZ1) {
        configYZ_1 = deviceJSON.config[i];
      }
      if (deviceJSON.config[i].key == nameLW1) {
        configLW_1 = deviceJSON.config[i];
      }
    }
  }

  if (LW_YZ_2 != "") {
    let nameYZ2 = "yz" + LW_YZ_2;
    let nameLW2 = "lw" + LW_YZ_2;

    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == nameYZ2) {
        configYZ_2 = deviceJSON.config[i];
      }
      if (deviceJSON.config[i].key == nameLW2) {
        configLW_2 = deviceJSON.config[i];
      }
    }
  }

  if (LW_YZ_2 !== 0 && LW_YZ_1 !== 0 && LW_YZ_2 !== "" && LW_YZ_1 !== "") {
    switch (nameDevice) {
      case "15231":
        firstZone = numberDevice + "_0";
        list_zone[firstZone] = {
          numberDevice: numberDevice,
          nameDevice: nameDevice,
          thisSecond: false,
          thisDom: false,
          type: "guard_radio",
          lw: configLW_1,
          section: configYZ_1,
          numberZone: configLW_1.key.slice(2),
        };

        break;
      case "15230":
        firstZone = numberDevice + "_0";
        list_zone[firstZone] = {
          numberDevice: numberDevice,
          nameDevice: nameDevice,
          thisSecond: false,
          thisDom: false,
          type: "guard_radio",
          lw: configLW_1,
          section: configYZ_1,
          numberZone: configLW_1.key.slice(2),
        };
        break;

      case "15130":
        firstZone = numberDevice + "_0";
        secondZone = numberDevice + "_1";
        list_zone[firstZone] = {
          numberDevice: numberDevice,
          nameDevice: nameDevice,
          thisSecond: false,
          thisDom: false,
          type: "guard_radio",
          lw: configLW_1,
          section: configYZ_1,
          numberZone: configLW_1.key.slice(2),
        };
        list_zone[secondZone] = {
          numberDevice: numberDevice,
          nameDevice: nameDevice,
          thisSecond: true,
          thisDom: false,
          type: "guard_radio",
          lw: configLW_2,
          section: configYZ_2,
          numberZone: configLW_2.key.slice(2),
        };

        break;
      case "15830":
        firstZone = numberDevice + "_0";
        list_zone[firstZone] = {
          numberDevice: numberDevice,
          nameDevice: nameDevice,
          thisSecond: false,
          thisDom: false,
          type: "guard_radio",
          lw: configLW_1,
          section: configYZ_1,
          numberZone: configLW_1.key.slice(2),
        };
        break;

      case "16270":
        // клавиатура
        break;
      case "16370":
        // брелок
        break;

      default:
        console.log("я таких устройст не знаю");
    }
  }
}

function section_list_new(data) {
  // Генерация интерфейса при клике по кнопке
  let maxNumberSec = 0;
  for (var i = 0; i < virtualSection.length; i++) {
    if (+virtualSection[i].number >= maxNumberSec) {
      maxNumberSec = +virtualSection[i].number;
    }
  }

  if (maxNumberSec < +DEVICEINFO[DEVICEMODEL].sections) {
    ++maxNumberSec;
    virtualSection.push({ number: maxNumberSec, zone: [] });

    let div = document.createElement("div");
    div.innerHTML = "<b style='color:#2196f3; font-size:26px;'>Раздел №" + maxNumberSec + "</b>";
    div.innerHTML +=
      '<div style="float:right; padding-bottom:10px"><label style="float:left"><button class=" w3-btn w3-blue w3-border w3-border-blue" onclick="open_modal_Rdevice(\'-1\',' +
      maxNumberSec +
      ')">+ Добавить устройство</button></label></div>';
    div.classList.add("w3-code", "w3-border-blue");
    document.getElementById("tab_section_list").appendChild(div);
  } else {
    document.getElementById("btn_section_list_new").innerHTML = "<span>Превышен лимит разделов</span>";
  }

  //scroll down page
  var scrollingElement = document.scrollingElement || document.body;
  scrollingElement.scrollTop = scrollingElement.scrollHeight;
}

function compareZone(zoneA, zoneB) {
  return +zoneA.numberZone - +zoneB.numberZone;
}


function numberZoneArr() {
  const arrayNumberZone = []
  for (var i = 0; i < virtualZone.length; i++) {
    if (virtualZone[i].typeDev === 'integral') {

      arrayNumberZone.push(virtualZone[i].numberZone)
    }
  }
  return arrayNumberZone
}
function numberExeArr() {
  const arrayNumberZone = []
  for (var i = 0; i < virtualExe.length; i++) {
    if (virtualExe[i].typeDev === 'integralExe') {

      arrayNumberZone.push(virtualExe[i].numberExe)
    }
  }
  return arrayNumberZone
}

function open_modal_thisDevice(numberZoneEdit) {
  // Редакор встроенной зоны

  $.show("#modal_r_device_save");
  $.hide("#modal_r_exe_save");
  $.hide("#modal_integral_save");
  CACHE_EDIT_INTEGRATION_ZONE = numberZoneArr();
  document.getElementById("modal_r_device_title").innerHTML = "Настройка встроенной зоны устройства";
  let modelDevice = 'integral_1'     // "15130";
  CACHE_EDIT_R_DEVICE = {
    id: "thisDevice", // ИД редактируемого датчика
    section: numberZoneEdit, //Номер раздела откуда вызвали карточку
  };
  let str = "";

  str += "<div class='w3-card' style='margin:15px 10px 15px 4px; padding:5px;' id='modal_r_device_zone'>";
  str += '<div id="open_modal_Rdevice_confZone">';



  str += '<table class="w3-table w3-table-all"><tbody>';
  str += "<tr>";
  str += "<td>№ Зоны</td>";
  str += "<td>Тип</td>";
  str += "<td>Псевдоним</td>";
  str += "<td title='Формировать сообщение востановление (Газ, Вода)'>Восст.</td>";
  str += "<td>Задержка(вход)</td>";
  str += "<td>Задержка(выход)</td>";
  str += "<td>Раздел</td>";
  str += "</tr>";
  // Основная зона устрйоства
  let count = 1
  for (var i = 0; i < virtualZone.length; i++) {
    if (virtualZone[i].typeDev === 'integral') {

      numberZoneEdit = virtualZone[i].numberZone
      str += "<tr>";
      str += "<td><input ";
      if (modelDevice == "-1") {
        str += "  "; // здесь можно поставить disable
      }
      str += ` onchange='' min='0' max='193' type='number' id='adresZone_${count}' style='width:60px' value='`
      if (numberZoneEdit == undefined) {
        // str += pickUpYzLw("lw", "2")[0]; АВТОМАТИЧЕСКИЙ ПОДБОР ЗОНЫ ПРИ СОЗДАНИИ КАРТОЧКИ
        str += 0;
        // генерируем новые свободные адреса
      } else {
        str += numberZoneEdit;
        // тянем адреса из конфига
      }
      //str += "' defaultValue='" + numberZoneEdit; //правка 22,07
      str += "'></td>";
      str +=
        "<td>" +
        selectedTypeGuardZone(
          modelDevice,
          virtualZone[i].type,
          virtualZone[i].param,
          count,
          virtualZone[i].delay,
          "modal",
          "1"
        ) +
        "</td>";
      //let nameZone = virtualSection[i].zone[k].numberZone
      str +=
        "<td><input value='" +
        virtualZone[i].name +
        "' onchange='setNameZone(this)' name='lb" +
        virtualZone[i].numberZone +
        "' style='width:110px'>" +
        "</td>";
      str +=
        '<td><input onchange="recoverTypeZone(this)" type="checkbox" class="w3-check" id="recoveryLw_Cart_' +
        virtualZone[i].numberZone +
        '" ';
      if (checkRecoverZone(virtualZone[i].type, virtualZone[i].param)) {
        str += " checked ";
      }

      if (+virtualZone[i].type !== 2) {
        str += " disabled ";
      }
      str += "></td>";

      // Задержка на вход
      str += "<td><input";
      let disablDelay = delaySection_DISABLED(virtualZone[i].type, virtualZone[i].param);
      let valueDelay = "";
      if (disablDelay.yes) {
        if (virtualZone[i].delay == 0 || virtualZone[i].delay == "" || virtualZone[i].delay == undefined) {
          str += " disabled ";
          valueDelay = "";
        } else {
          valueDelay = virtualZone[i].delay;
        }
      } else {
        valueDelay = virtualZone[i].delay;
      }
      str += ` style='width:60px' id='modal_r_device_zone_delay_${count}' value='`;
      str += valueDelay;
      str += "' type='number'></td>";

      // ... Задержка на вход
      // Задержка на ВЫХОД
      str += "<td><input";

      let valueDelayExit = "";
      if (disablDelay.yes) {
        if (virtualZone[i].delay == 0 || virtualZone[i].delay == "" || virtualZone[i].delay == undefined) {
          str += " disabled ";
          valueDelayExit = "";
        } else {
          valueDelayExit = virtualZone[i].delayExit;
        }
      } else {
        valueDelayExit = virtualZone[i].delayExit;
      }
      str += ` style='width:60px' id='modal_r_device_zone_delay_EXIT_${count}' value='`;
      str += valueDelayExit;
      str += "' type='number'></td>";

      str += "<td>";
      // ... Задержка на ВЫХОД

      str += `<select id='nomberZone_Section_${count}'>`;
      // str += "<label><option>";
      // str += "Не выбран";
      // str += "</option></label>";

      for (var r = 1; DEVICEINFO[DEVICEMODEL].sections >= r; r++) {
        str += "<label>";
        str += "<option ";

        // Проверка на клик из блока раздела на добавление устройства
        if (+virtualZone[i].section == r) {
          str += " selected ";
        }

        str += " value='" + r + "' name='" + r + "'  ";
        str += " > Раздел " + r + "</option></label>";
      }
      str += "</select>";
      str += "</td>";
      str += "</tr>";
      count++
    }
  }


  str += "</tbody></table>";


  str += "</div>"; // Настройки зон
  str += "</div>"; // Настройки зон
  str +=
    "<div class='w3-card w3-animate-top w3-red' style='margin:15px 10px 15px 4px; padding:5px; cursor:context-menu; color:red; display:none' id='modal_r_device_error'></div>"; // Описание
  
  document.getElementById("modal_r_device_body").innerHTML = str;
  document.getElementById("modal_r_device").style.display = "block";
}
function open_modal_thisDeviceExit(numberZoneEdit) {

  // Редакор встроенной зоны
  $.hide("#modal_r_device_save");
  $.hide("#modal_r_exe_save");
  $.show("#modal_integral_save");
  CACHE_EDIT_INTEGRATION_ZONE = numberExeArr('integralExe');
  document.getElementById("modal_r_device_title").innerHTML = "Настройка встроенного выхода управления";
  let modelDevice = 'integral_2'     // "15130";
  CACHE_EDIT_R_DEVICE = {
    id: "thisDevice", // ИД редактируемого датчика
    section: numberZoneEdit, //Номер раздела откуда вызвали карточку
  };
  let str = "";
  str += '<table class="w3-table w3-table-all" style="margin-top:10px">';
  str += "<tr>";
  str += "<td>№ выхода</td>";
  str += "<td>Режим работы</td>";
  str += "<td>Время работы</td>";
  str += "<td>Сработка при</td>";
  str += "<td>Разделы</td>";
  str += "<td title='Уведоления ЛИУ при постановке/снятии'>Увед-ия</td>";
  str += "</tr>";
     for (var k = 0; k < virtualExe.length; k++) {
    if (virtualExe[k].typeDev === 'integralExe') {
      str += "<tr name='" + virtualExe[k].numberExe + "'>";
      str += '<td>OK-'+ (+virtualExe[k].index + 1)+ " " +'<input onchange="save_Modal_extendersExe(this)" name="' +
        virtualExe[k].numberExe +
        '" class="nz_extExe" id="adrZoneExt_' +
        virtualExe[k].numberExe +
        '" style="width:60px" value="' +
        virtualExe[k].numberExe +
        '"></td>';
      str += "<td>" + listTypeExe(virtualExe[k].type, virtualExe[k].numberExe, "modal", null, null, virtualExe[k].typeDev) + " </td>";
      str +=
        "<td> <input class='ooTime_ext4' style='width:50px' onchange='set_CONTROL_OO(this)' name='" +
        virtualExe[k].numberExe +
        "' value='" +
        +virtualExe[k].delay +
        "' > Сек.</td>";
      str += "<td>";
      str +=
        "<div class='w3-dropdown-hover w3-mobile'>" +
        "<button class='w3-border w3-border-blue w3-btn w3-white'>События</button>" +
        "<div class='w3-dropdown-content w3-bar-block w3-dark-grey'>";

      str +=
        "<button class='w3-bar-item w3-button'><label><input class='w3-check' onchange='setOC_CONTROL_KTCchange(this)' name='ob' type='checkbox' ";
      if (virtualExe[k].ktc == "1") {
        str += " checked ";
      }
      str += " > Нар. КТС </label></button>";

      str +=
        "<button class='w3-bar-item w3-button'><label><input class='w3-check' onchange='setOC_CONTROL_DEVICEchange(this)' name='ob' type='checkbox' ";
      if (virtualExe[k].oppening == "1") {
        str += " checked ";
      }
      str += " > Вскрытии </label></button>";

      str +=
        "<button class='w3-bar-item w3-button'><label><input class='w3-check' onchange='setOC_CONTROL_GASchange(this)' name='og' type='checkbox' ";
      if (virtualExe[k].gas == "1") {
        str += " checked ";
      }
      str += " > Газ </label></button>";

      str +=
        "<button class='w3-bar-item w3-button'><label><input class='w3-check' onchange='setOC_CONTROL_WATERchange(this)' name='ot' type='checkbox' ";
      if (virtualExe[k].water == "1") {
        str += " checked ";
      }
      str += " > Потоп </label></button>";

      str +=
        "<button class='w3-bar-item w3-button'><label><input class='w3-check' onchange='setOC_CONTROL_FIREchange(this)' name='of' type='checkbox' ";
      if (virtualExe[k].fire == "1") {
        str += " checked ";
      }
      str += " > Пожар </label></button>";

      str += "</div>" + "</div>";
      str += "</td>";
      str += "<td>";
      str +=
        "<div class='w3-dropdown-hover w3-mobile'>" +
        "<button class='w3-border w3-border-red w3-btn w3-white'>Разделы</button>" +
        "<div class='w3-dropdown-content w3-bar-block w3-border w3-border-red' style='width:300px'>";

      for (var r = 1; DEVICEINFO[DEVICEMODEL].sections >= r; r++) {
        str +=
          "<label class='w3-button' style='width:70px'><label class='" +
          virtualExe[k].numberExe +
          "'><input class='w3-check' onchange='setOO_CONTROL_SECTIONSchange(this, true)' name='" +
          r +
          "' type='checkbox' ";
        if (virtualExe[k].activeSections !== null) {
          if (virtualExe[k].activeSections.split(',').includes(r + "")) {
            str += " checked ";
          }
        }
        str += " > " + r + " </label></label>";
      }
      str += "</div>" + "</div>";
      str += "</td>";
      str += "<td style='text-align:center'>";
      str +=
        "<input name='" +
        virtualExe[k].numberExe +
        "' onchange='setFN_notofication(this, true)' type='checkbox' class='w3-check' ";
      if (virtualExe[k].notification == "1") {
        str += " checked ";
      }
      str += ">";
      str += "</td>";

      str += "</tr>";
    }

  }
  str += "</table>";

  str += "<div class='w3-card' style='margin:15px 10px 15px 4px; padding:5px;' id='modal_r_device_zone'>";
  str += '<div id="open_modal_Rdevice_confZone">';


  str += "</div>"; // Настройки зон
  str += "</div>"; // Настройки зон
  str +=
    "<div class='w3-card w3-animate-top w3-red' style='margin:15px 10px 15px 4px; padding:5px; cursor:context-menu; color:red; display:none' id='modal_device_error'></div>"; // Описание
  //str += "<div class='w3-card' style='margin:15px 10px 15px 4px; padding:5px; cursor:context-menu;' id='modal_r_device_description'></div>"; // Описание
  //str += "<div class='w3-card w3-animate-top w3-red' style='margin:15px 10px 15px 4px; padding:5px; cursor:context-menu; color:red; display:none' id='modal_r_device_error'></div>"; // Описание
  document.getElementById("modal_r_device_body").innerHTML = str;
  document.getElementById("modal_r_device").style.display = "block";

  let btn = "";
  btn += '<div style="float:right">            ';
  btn +=
    '<button id="modal_ext_delete" type="button" class="w3-bar-item w3-button w3-red w3-round" onclick="remove_Modal_extenders(' +
    /* id */ +
    ')">&#9851; Удалить</button>';
  btn +=
    '<button style="margin: 0 8px 0 8px" type="button" class="w3-bar-item w3-button w3-orange w3-round" onclick="close_Modal_extenders(' +
    /* id */ +
    ')">&#10008; Закрыть</button>';
  btn +=
    '<button id="modal_extenders_save" onclick="close_Modal_extenders(' +
    /* id */ +
    ')" class="w3-bar-item w3-button w3-teal w3-round">&#10004; Сохранить</button> <br />';
  btn += "</div >";
  document.getElementById("modal_extenders_footer").innerHTML = btn;
  $.show("#modal_extenders_footer");

}

let CACHE_EDIT_R_DEVICE = {
  id: null, // ID Радио датчика
  numberSection: null,
};

function open_modal_Rdevice(id, section) {
  $.show("#modal_r_device_save");
  $.hide("#modal_r_exe_save");
  $.hide("#modal_integral_save");
  if (id == "-1") {
    open_modal_RdeviceRun(id, section);
   /*  if (!ckeckChannelTransmitter("new")) {
    } */
  } else {
    open_modal_RdeviceRun(id, section);
  }
}

function searchSerialNumber(id) {
  for (i in rkps_device) {
    if (rkps_device[i].numberRadio == id) {
      if (rkps_device[i].serial !== undefined) {
        return rkps_device[i].serial;
      } else {
        return "";
      }
    }
  }
}

function open_modal_RdeviceRun(id, section) {
  CACHE_EDIT_R_DEVICE = {
    id: id, // ИД редактируемого датчика
    section: section, //Номер раздела откуда вызвали карточку
    serial: searchSerialNumber(id),
  };
  let str = "<table>";
  let serialNumber = searchSerialNumber(id) ? searchSerialNumber(id) : "";
  str +=
    "<tr>" +
    "<td style='width:300px'><b>Тип устройства</b></br>" +
    modal_name_Rdevice(section) +
    "</td><td><b>Серийный номер</b><br><input disabled value='" +
    serialNumber +
    "'></td><td style='width:10px'></td><td style='width:60px'><div style='display:none'>Адрес </br><input disabled style='width:100%'></div><td style='width:10px'></td>";
  str += "<td id='modal_RadioD' style='width:300px; display:none;'> " +
    modal_numberSelectionDevice(modelDevice = R_DEVICE_NAME) +
    "</td>"
  str += "<td id='modal_allMix' style='width:300px; display:none;'><b>Кол-во устройств</b></br>" +
    modal_MixDevice(modelDevice = R_DEVICE_NAME) +
    "</td>"
  str += "</tr>";
  str += "</table>";

  str += "<div class='w3-card' style='margin:15px 10px 15px 4px; padding:5px;' id='modal_r_device_zone'>";
  str += '<div id="open_modal_Rdevice_confZone">';
  str += "</div>"; // Настройки зон
  str += "</div>"; // Настройки зон
  str +=
    "<div class='w3-card' style='margin:15px 10px 15px 4px; padding:5px; cursor:context-menu;' id='modal_r_device_description'></div>"; // Описание
  str +=
    "<div class='w3-card w3-animate-top w3-red error7620' style='margin:15px 10px 15px 4px; padding:5px; cursor:context-menu; color:red; display:none' id='modal_r_device_error'></div>"; // Описание
  document.getElementById("modal_r_device_body").innerHTML = str;
  document.getElementById("modal_r_device").style.display = "block";

  if (id == "-1") {
    // Добавление нового устроства
    document.getElementById("modal_r_device_title").innerText = "Добавление нового устройства";
    $.hide("#modal_r_device_delete"); // кнопка удаления
    document.getElementById("modal_r_device_name").disabled = false; //Блокировка смены модели
    set_r_device_name("0", null, null, section); // стартуем по дефолту
  } else {
    $.show("#modal_r_device_delete"); // кнопка удаления
    document.getElementById("modal_r_device_name").disabled = true; //Блокировка смены модели
    document.getElementById("modal_allMix").style.opacity = '0'; //скрываем кол-во устройств
    document.getElementById("modal_RadioD").style.opacity = '0'; //скрываем № РУ

    document.getElementById("modal_r_device_title").innerText = "Настройка устройства №" + id;
    for (var i = 0; i < virtualRadio.length; i++) {
      if (virtualRadio[i].numberRadio == id) {
        document.getElementById("modal_r_device_name").value = virtualRadio[i].name; // Задаем тип устройства
        set_r_device_name(virtualRadio[i].name, virtualRadio[i].zone_1, virtualRadio[i].zone_2, section); // стартуем с моделькой
        break;
      }
    }
  }
}

function open_modal_Rdevice_configZone(data) { }

function card_Jupiter7620(modelDevice, zone_1, zone_2, sections) {
  let THIS_EXT = {};
  let ext = {
    name: "",
    soft: "",
    model: "",
    zone: [],
  };

  for (i in virtualRadio) {
    if (virtualRadio[i].number === CACHE_EDIT_R_DEVICE.id) {
      ext.name = virtualRadio[i].type;
      ext.soft = virtualRadio[i].SS;
      ext.model = virtualRadio[i].name;
      THIS_EXT = virtualRadio[i]; // запомнили
    }
  }
  THIS_EXT.exe = [];

  for (i in virtualExe) {
    if (virtualExe[i].parentExeNumber === CACHE_EDIT_R_DEVICE.id && virtualExe[i].typeDev === "radio") {
      THIS_EXT.exe.push(virtualExe[i]);
    }
  }
  let str = "";
  str += "<b>Настройка выходов управления:</b>";
  str += '<table class="w3-table w3-table-all" style="margin-top:10px">';
  str += "<tr>";
  str += "<td></td>";
  str += "<td>№ выхода</td>";
  str += "<td>Режим работы</td>";
  str += "<td>Время работы</td>";
  str += "<td>Сработка при</td>";
  str += "<td>Разделы</td>";
  str += "<td title='Уведоления ЛИУ при постановке/снятии'>Увед-ия</td>";
  str += "</tr>";

  if (THIS_EXT.exe.length === 0) {
    // $.show("#modal_r_device_save");
    // $.hide("#modal_r_exe_save");
    THIS_EXT.exe.push(
      {
        activeSections: "",
        delay: "0",
        fire: "0",
        gas: "0",
        index: "1",
        ktc: "1",
        link: "radio",
        model: "7620",
        name: "",
        numberExe: null,
        numberIndexExe: "ПВ",
        oppening: "0",
        parentExeNumber: null,
        section: "0",
        type: "12",
        typeDev: "radio",
        water: "0",
        notification: "0",
      },
      {
        activeSections: "",
        delay: "0",
        fire: "0",
        gas: "0",
        index: "1",
        ktc: "1",
        link: "radio",
        model: "7620",
        name: "",
        numberExe: null,
        numberIndexExe: "РВ",
        oppening: "0",
        parentExeNumber: null,
        section: "0",
        type: "12",
        typeDev: "radio",
        water: "0",
        notification: "0",
      }
    );
  }

  let freePVnumber = null;
  let freeRVnumber = null;
  if (CACHE_EDIT_R_DEVICE.id === "-1") {
    // Задаем номер ПВ и РВ
    // ДОбавление нового устройства

    let virtEx = [];
    let pullRele = ["1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17"]; // Генерировать ключом OO
    let createPV = 0;
    let createRV = 0;
    for (var i = 0; i < virtualExe.length; i++) {
      virtEx.push(virtualExe[i].numberExe);
    }

    // for (i = 1; i < pullRele.length; i++) { // ГЕНЕРАЦИЯ СВОБОДНОГО НОМЕРА РЕЛЕ
    //   if (virtEx.indexOf(pullRele[i]) == -1) {
    //     createPV = pullRele[i];
    //     break;
    //   }
    // }

    if (createPV !== null) {
      virtEx.push(createPV);
    }
    // for (i = 0; i < pullRele.length; i++) { // ГЕНЕРАЦИЯ СВОБОДНОГО НОМЕРА РЕЛЕ
    //   if (virtEx.indexOf(pullRele[i]) == -1) {
    //     createRV = pullRele[i];
    //     break;
    //   }
    // }

    if (createPV !== null && createRV !== null) {
      freeRVnumber = createRV;
      freePVnumber = createPV;
    } else {
      alert("Максимальное количество выходов управления!");
      closeModalR_dev();
    }
  } else {
    // Номера ПВ и РВ
    // Редактирование Устройтва

    for (var i = 0; i < virtualRadio.length; i++) {
      if (virtualRadio[i].numberRadio === CACHE_EDIT_R_DEVICE.id) {
        freePVnumber = virtualRadio[i].PV[0];
        freeRVnumber = virtualRadio[i].RV[0];
      }
    }
  }

  //вычисление максимального значения 
  let maxValue = searchMaxOO();

  //ПВ всегда должен идти первым
  if (THIS_EXT.exe[0].numberIndexExe == "РВ") {
    THIS_EXT.exe = THIS_EXT.exe.reverse()
  }


  for (var k = 0; k < THIS_EXT.exe.length; k++) {
    if (THIS_EXT.exe[k].numberIndexExe === "ПВ") {
      str += "<tr name='" + THIS_EXT.exe[k].numberIndexExe + "'>";
      str += "<td>" + THIS_EXT.exe[k].numberIndexExe + "</td>";
      str += "<td><input value='";
    }
    if (THIS_EXT.exe[k].numberIndexExe === "РВ") {
      str += "<tr name='" + THIS_EXT.exe[k].numberIndexExe + "'>";
      str += "<td>" + THIS_EXT.exe[k].numberIndexExe + "</td>";
      str += "<td><input value='";
    }


    if (THIS_EXT.exe[k].numberIndexExe === "ПВ") {
      str += freePVnumber;
      //str += 0;
    }
    if (THIS_EXT.exe[k].numberIndexExe === "РВ") {
      str += freeRVnumber;
      //str += 0;
    }

    str += "' style='width:60px' type='number' ";
    if (THIS_EXT.exe[k].numberIndexExe === "ПВ") {
      str +=
        'id="number_PV" min="0" max="' + maxValue + '" onblur="if (1*this.value<=' + maxValue + ' && 1*this.value>=0) this.defaultValue=this.value; else this.value=this.defaultValue;"';
    }
    if (THIS_EXT.exe[k].numberIndexExe === "РВ") {
      str +=
        'id="number_RV" min="0" max="' + maxValue + '" onblur="if (1*this.value<=' + maxValue + ' && 1*this.value>=0) this.defaultValue=this.value; else this.value=this.defaultValue;"';
    }
    str += "</td>";
    str +=
      "<td>" +
      listTypeExe(THIS_EXT.exe[k].type, THIS_EXT.exe[k].numberExe, "-1", THIS_EXT.exe[k].numberIndexExe, "modal") +
      " </td>";
    str += "<td> <input";
    let defaultdelay = 1
    if (THIS_EXT.exe[k].numberIndexExe === "РВ") {
      defaultdelay = 0
      str += ' id="rv_delay" min="1" max="999" onblur="if (1*this.value<=999 && 1*this.value>=0) this.defaultValue=this.value; else this.value=this.defaultValue;"';
    } else {
      str += ' id="pv_delay" min="1" max="999" onblur="if (1*this.value<=999 && 1*this.value>=1) this.defaultValue=this.value; else this.value=this.defaultValue;"';
    }
    str += "style='width:60px' type='text' ";

    if (CACHE_EDIT_R_DEVICE.id !== "-1") {
      str += "onchange='set_CONTROL_OO(this,false)'";
    }

    str += " name='" + THIS_EXT.exe[k].numberExe + "' value='" + (THIS_EXT.exe[k].delay || defaultdelay) + "' > Сек.</td>";
    str += "<td>";
    str +=
      "<div class='w3-dropdown-hover w3-mobile'>" +
      "<button class='w3-border w3-border-blue w3-btn w3-white'>События</button>" +
      "<div";
    if (THIS_EXT.exe[k].numberIndexExe === "ПВ") {
      str += ' id="event_PV" ';
    }
    if (THIS_EXT.exe[k].numberIndexExe === "РВ") {
      str += ' id="event_RV" ';
    }

    str += " class='w3-dropdown-content w3-bar-block w3-dark-grey'>";
    str +=
      "<button disabled class='w3-bar-item w3-button'><label><input class='w3-check' onchange='setOC_CONTROL_KTCchange(this, false)' name='or' type='checkbox' ";

    str += " checked ";

    str += " > Тревоге </label></button>";
    str +=
      "<button class='w3-bar-item w3-button'><label><input class='w3-check' onchange='setOC_CONTROL_KTCchange(this, false)' name='or' type='checkbox' ";
    if (THIS_EXT.exe[k].ktc == "1") {
      str += " checked ";
    }
    str += " > Нар. КТС </label></button>";

    str +=
      "<button class='w3-bar-item w3-button'><label><input class='w3-check' onchange='setOC_CONTROL_DEVICEchange(this, false)' name='ob' type='checkbox' ";
    if (THIS_EXT.exe[k].oppening == "1") {
      str += " checked ";
    }
    str += " > Вскрытии </label></button>";

    str +=
      "<button class='w3-bar-item w3-button'><label><input class='w3-check' onchange='setOC_CONTROL_GASchange(this, false)' name='og' type='checkbox' ";
    if (THIS_EXT.exe[k].gas == "1") {
      str += " checked ";
    }
    str += " > Газ </label></button>";

    str +=
      "<button class='w3-bar-item w3-button'><label><input class='w3-check' onchange='setOC_CONTROL_WATERchange(this, false)' name='ot' type='checkbox' ";
    if (THIS_EXT.exe[k].water == "1") {
      str += " checked ";
    }
    str += " > Потоп </label></button>";

    str +=
      "<button class='w3-bar-item w3-button'><label><input class='w3-check' onchange='setOC_CONTROL_FIREchange(this, false)' name='of' type='checkbox' ";
    if (THIS_EXT.exe[k].fire == "1") {
      str += " checked ";
    }
    str += " > Пожар </label></button>";

    str += "</div>" + "</div>";
    str += "</td>";
    str += "<td>";
    str +=
      "<div class='w3-dropdown-hover w3-mobile'>" +
      "<button class='w3-border w3-border-red w3-btn w3-white'>Разделы</button>" +
      "<div";

    if (THIS_EXT.exe[k].numberIndexExe === "ПВ") {
      str += ' id="section_PV" ';
    }
    if (THIS_EXT.exe[k].numberIndexExe === "РВ") {
      str += ' id="section_RV" ';
    }

    str += " class='w3-dropdown-content w3-bar-block w3-border w3-border-red' style='width:300px'>";

    let activeArr = [];
    if (THIS_EXT.exe[k].activeSections !== null) {
      activeArr = THIS_EXT.exe[k].activeSections.split(",");
    }
    for (var r = 1; DEVICEINFO[DEVICEMODEL].sections >= r; r++) {
      str +=
        "<label class='w3-button' style='width:70px'><label class='" +
        THIS_EXT.exe[k].numberExe +
        "'><input class='w3-check' onchange='setOO_CONTROL_SECTIONSchange(this, false, -1)' name='" +
        r +
        "' type='checkbox' ";
      if (THIS_EXT.exe[k].activeSections !== null) {
        if (activeArr.includes(r + "")) {
          str += " checked ";
        }
      }
      str += " > " + r + " </label></label>";
    }
    str += "</div>" + "</div>";
    str += "</td>";
    str += "<td>";
    str += "<input ";
    THIS_EXT.exe[k].numberIndexExe == "ПВ"
      ? (str += ' id="section_PV_notification"')
      : (str += ' id="section_RV_notification"');

    str += ' class="w3-check" type="checkbox" ';
    THIS_EXT.exe[k].notification == "1" ? (str += " checked ") : "";
    str += ">";
    str += "</td>";

    str += "</tr>";
  }

  str += "</table>";

  let XXSS_power_12 = true;
  let XXSS_break_true = true;

  if (CACHE_EDIT_R_DEVICE.id !== "-1") {
    if (dataDevice["xxss" + CACHE_EDIT_R_DEVICE.id]) {
      let xxssValue = dataDevice["xxss" + CACHE_EDIT_R_DEVICE.id].value;
      if (xxssValue === "0") {
        XXSS_power_12 = true;
        XXSS_break_true = true;
      } else if (xxssValue === "1") {
        XXSS_power_12 = true;
        XXSS_break_true = false;
      } else if (xxssValue === "2") {
        XXSS_power_12 = false;
        XXSS_break_true = true;
      } else if (xxssValue === "3") {
        XXSS_power_12 = true;
        XXSS_break_true = true;
      }
    }
  }
  // настройки элементов питания
  str +=
    "<div style='display:flex'> <div style='margin-right:10px;'>" +
    'Основной элемент питания' +
    "</div><div style='display:flex'><label style='margin-right:10px;'><input title=''   class='w3-radio' name='" +
    'this.key' +
    "' type='radio' value='0' ";
  if (CACHE_EDIT_R_DEVICE.id !== "-1") {
    for (j in virtualRadio) {
      if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
        if (!(virtualRadio[j].SS & 0x40)) {
          str += " checked ";
        }
      }
    }
  } else {
    str += " checked ";
  }
  str +=
    "> ER14250(3,6 В)  </label></br><label> <input class='w3-radio' id='XXSS_main_battery_type_CR2'   name='" +
    'this.key' +
    "' type='radio' value='1'";
  if (CACHE_EDIT_R_DEVICE.id !== "-1") {
    for (j in virtualRadio) {
      if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
        if (virtualRadio[j].SS & 0x40) {
          str += " checked ";
        }
      }
    }
  } else {
    str += "";
  }
  str += "> CR2 (3,0 В)</p> </div></div>";
  let xxss = "";
  xxss += "<table>";
  xxss += "<tr>";
  xxss += "<td><b>Настройка ПВ</b><br>";
  xxss += "<label>Генерация источником питания ";
  xxss +=
    '<label><input class="w3-radio w3-radio-7620" id="XXSS_power_12" value="12_0" name="XXSS_power" type="radio"> 12В</label>';
  xxss +=
    '<label>  <input class="w3-radio w3-radio-7620" id="XXSS_power_24" value="12_1" name="XXSS_power" type="radio"> 24В</label>';
  xxss += "</label><br>";
  xxss += "<label>";
  xxss +=
    '<label>Обрыв источника напряжения <input class="w3-radio w3-radio-7620" style="margin-left:12px" id="XXSS_break_true" name="XXSS_break" type="radio"> контролировать</label>';
  xxss +=
    '<label>  <input class="w3-radio w3-radio-7620" id="XXSS_break_false" name="XXSS_break" type="radio" > не контролировать</label>';
  xxss += " </label>";
  xxss += "</td>";
  xxss += "</tr>";

  xxss += "<tr>";
  xxss += "<td>";
  // xxss +=
  //   '<label>  <input class="w3-radio w3-radio-7620" onchange="setTamperControl(this)" id="XXSS_tamper_control" name="XXSS_tamper_control" type="checkbox"> Контролировать датчик вскрытия</label>';
  // xxss += " </label>";
  xxss += "</td>";
  xxss += "</tr>";

  xxss += "</table>";

  str += xxss;


  str += "</tr></table>";
  return str;
}

function setTamperControl(data) {
  if (data.checked) {
    document.getElementById('trinket_click_usr_1') ? document.getElementById('trinket_click_usr_1').disabled = '' : null
    console.log("checked");
  } else {
    document.getElementById('trinket_click_usr_1') ? document.getElementById('trinket_click_usr_1').disabled = true : null
    console.log("unchecked");
  }
}

function validateRadioQt(type) {
  // Валидация допустимых устройств в системе
  // console.log(type);
  let error = false;
  let device = {
    extention: 0, // удлинители
    all: 0, // радио зоны
    trinked: 0, // брелки
  };
  for (var i = 0; i < virtualRadio.length; i++) {
    switch (virtualRadio[i].name) {
      case "13431":
      case "13438":
      case "13439":
        device.extention = ++device.extention;
        break;
      case "15130":
      case "15230":
      case "15231":
      case "15830":
      case "16270":
      case "17620":
        device.all = ++device.all;
        break;
      case "16370":
        device.trinked = ++device.trinked;
        break;

      default:
        break;
    }
  }

  switch (type) {
    case "13431":
    case "13438":
    case "13439":
      if (device.extention >= 3) {
        error = true;
      }
      break;
    case "15130":
    case "15230":
    case "15231":
    case "15830":
    case "16270":
    case "17620":
      if (device.all >= 64) {
        error = true;
      }
      break;
    case "16370":
      if (device.trinked >= 14) {
        error = true;
      }
      break;

    default:
      break;
  }
  // console.log(device);
  return error;
}


/////////////Добавление радио устройств списком.

// checkbox выбранных приборов
function setMixDeviceControl(data) {
  idElement = data.parentNode.childNodes[4].id
  let deviceType = data.parentNode.childNodes[4].id.slice(-5)
  if (data.checked) {
    document.getElementById(idElement) ? document.getElementById(idElement).disabled = '' : null
    //console.log("checked");
    document.getElementById('okDevice_' + deviceType) ? document.getElementById('okDevice_' + deviceType).style.opacity = '0' : null
    document.getElementById(idElement).value = '1'
    allAddDevice()
  }
  else {
    document.getElementById(idElement) ? document.getElementById(idElement).disabled = true : null
    document.getElementById(idElement) ? document.getElementById(idElement).value = '0' : null
    //console.log("unchecked");
    allAddDevice()
  }
}

// счетаем общее кол-во приборов на добавление
function allAddDevice(data) {
  let xxadUserChoice = Number(document.getElementById('numberSelectionDevice_id') && document.getElementById('numberSelectionDevice_id').value)
  let arrFreeNumbers = FreeNumber()
  let accQuantity = arrFreeNumbers.filter(el => el >= xxadUserChoice).length
  /* let accQuantity = maxValueXXAD[maxValueXXAD.length - 1] - (xxadUserChoice - 1) */

  // кол-во устройств из списка радиоканальных устройств
  const tabAllDeviceList = document.getElementById('tab_r_device_list').childNodes[0].childNodes[0].childNodes[1].childElementCount

  // ищем кол-во устройств каждого типа
  const tabDeviceList = document.getElementById('tab_r_device_list').childNodes[0].childNodes[0].childNodes[1]
  const tabDeviceListArray = []
  for (let i = 0; i < tabAllDeviceList; i++) {
    tabDeviceListArray.push(tabDeviceList.childNodes[i].childNodes[1].innerText.slice(-4))
  }
  tabDevcieObject = {}
  for (const iterator of tabDeviceListArray) {
    if (!tabDevcieObject.hasOwnProperty(iterator)) {
      tabDevcieObject[iterator] = 1
    } else {
      tabDevcieObject[iterator] += 1
    }
  }
  // Кол-во приборов уже имеющиеся в list-е
  const listRetronslitor = (tabDevcieObject['3431'] || 0) + (tabDevcieObject['3438'] || 0) + (tabDevcieObject['3439'] || 0)
  const listDevice64 = (tabDevcieObject['5130'] || 0) + (tabDevcieObject['5230'] || 0) + (tabDevcieObject['5231'] || 0) + (tabDevcieObject['5830'] || 0) + (tabDevcieObject['6270'] || 0) + (tabDevcieObject['7620'] || 0)


  //Кол-во приборов которое пытаемся добавить
  const allDevice = document.querySelectorAll('.trinket_func_select_rank')
  const sumAllDev = []
  allDevice.forEach(device => sumAllDev.push(device.value))
  // кол-во добавляемых ретронсляторов не более 3
  let addRetronslitor = 0
  for (let i = 0; i < sumAllDev.length; i++) {
    if (i <= 2) {
      addRetronslitor += Number(sumAllDev[i])

    }
  }
  const allRetronslitor = Number(sumAllDev[0]) + Number(sumAllDev[1]) + Number(sumAllDev[2])
  // кол-во добовляемых радиоприборов в кол-ве не более 64
  let addDevice64 = 0
  for (let i = 4; i < sumAllDev.length; i++) {
    if (i <= 9 && i !== 8) {
      addDevice64 += Number(sumAllDev[i])
    }
  }
  const device64 = Number(sumAllDev[3]) + Number(sumAllDev[4]) + Number(sumAllDev[5]) + Number(sumAllDev[6]) + Number(sumAllDev[7]) + Number(sumAllDev[9])

  // Так-же есть 14 пультов, но они все в одном приборе поэтому их не общитываем


  // Общее кол-во добавляемых приборов
  const sumDevice = sumAllDev.reduce((acc, dev) => Number(acc) + Number(dev), 0)

  //Итого должно быть не более 81 прибора из них макс 3 ретронслятора 14 пультов и 64 прочих радиоустройств

  if (document.getElementById('allAddDevice')) {

    if (allRetronslitor > 3 - listRetronslitor) {
      document.getElementById('allAddDevice').style.color = 'red'
      document.getElementById('allAddDevice').innerHTML = `Превышено общее количество устройств "Ретранслятор объектовый" на ${-(3 - allRetronslitor - listRetronslitor)}, макс кол-во 3.`
      document.getElementById('modal_r_mix_device_save').disabled = true
    } else if (device64 > 64 - listDevice64) {
      document.getElementById('allAddDevice').style.color = 'red'
      document.getElementById('allAddDevice').innerHTML = `Превышено количество радиоустройств на ${- (64 - device64 - listDevice64)}, макс кол-во 64.`
      document.getElementById('modal_r_mix_device_save').disabled = true
    } else if (sumDevice == 0) {
      document.getElementById('modal_r_mix_device_save').disabled = true
      document.getElementById('allAddDevice').style.color = 'black'
      document.getElementById('allAddDevice').innerHTML = sumDevice
    } else if (sumDevice > accQuantity) {
      document.getElementById('allAddDevice').style.color = 'red'
      document.getElementById('allAddDevice').innerHTML = `Что-бы добавить ${sumDevice} приборов начните с РУ № ${arrFreeNumbers[arrFreeNumbers.length - sumDevice]}`
      document.getElementById('modal_r_mix_device_save').disabled = true
    }
    else {
      document.getElementById('allAddDevice').innerHTML = sumDevice
      document.getElementById('allAddDevice').style.color = 'black'
      document.getElementById('modal_r_mix_device_save').disabled = ''
    }

  }
  else {
    if (data) {
      // этот else работает из карточки прибора
      let text = ''
      let last = data.value[data.value.length - 1]
      if (last == 1) {
        text = 'устройство'
      } else if (last > 1 && last <= 4) {
        text = 'устройства'
      } else {
        text = 'устройств'
      }
      // все кроме 17620
      document.getElementById('modal_r_device_save').innerHTML = `&#10004; Сохранить ${data.value} ${text}`
      document.getElementById('modal_r_device_save').setAttribute('onclick', 'saveModalMix(this)')
      // для 1720   
      document.getElementById('modal_r_exe_save').setAttribute('onclick', 'saveModalMix(this)')
      document.getElementById('modal_r_exe_save').innerHTML = `&#10004; Сохранить ${data.value} ${text}`
    }
    if (sumDevice > accQuantity) {
      if (sumDevice == 1) {
        text = 'устройство'
      } else if (sumDevice > 1 && sumDevice <= 4) {
        text = 'устройства'
      } else {
        text = 'устройств'
      }
      document.getElementById('errorAddDevice').style.color = 'red'
      document.getElementById('errorAddDevice').innerHTML = `Что-бы добавить ${sumDevice} ${text} начните с РУ № ${arrFreeNumbers[arrFreeNumbers.length - sumDevice]}`
      document.getElementById('modal_r_exe_save').disabled = true
      document.getElementById('modal_r_device_save').disabled = true
    } else {
      document.getElementById('modal_r_exe_save').disabled = ''
      document.getElementById('modal_r_device_save').disabled = ''
      document.getElementById('errorAddDevice').innerHTML = ''
    }
  }


  // MixDeviceValue()
  // openMixDevice()
}

// Сохраняем все выбранные приборы из карточки
function saveModalMix(data) {
  spiner_start()
  setTimeout(() => {

    let allSaveDevice = parseInt(data.innerHTML.match(/\d+/))
    const deviceType = document.getElementById('modal_r_device_name').value
    const mixAll = 'cardDevice'
    if (deviceType === '17620') {
      for (let i = 0; i < allSaveDevice; i++) {
        saveModalRadioEXT_NEW(deviceType, mixAll)

      }
    } else {
      for (let i = 0; i < allSaveDevice; i++) {
        saveModalRadio_NEW(deviceType, mixAll)

      }
    }
    //возвращаем кнопку сохранить в изначальное состояние
    document.getElementById('modal_r_device_save').innerHTML = `&#10004; Сохранить`
    document.getElementById('modal_r_device_save').setAttribute('onclick', 'saveModalRadio()')
    //отпровляем на сервер все собранные данные за один раз
    liveSaveInterface();
    clearExpiredKey();
    parseAppKey("update_notabs");

  }, 100)
  setTimeout(() => {
    spiner_stop()
  }, 200)


}



// Сохраняем все выбранные приборы из вкладки ВСЕ.
function MixDeviceValue(data) {
  const checkCall = data.id
  console.log('checkCall', checkCall);
  spiner_start()
  setTimeout(() => {
    const allDevice = document.querySelectorAll('.trinket_func_select_rank')
    allDevice.forEach(device => {
      let deviceType = device.id.slice(-5)
      const deviceNumber = device.value
      let mixAll = 'AllDevice'
      if (deviceNumber !== '0') {
        for (let i = 0; i < +deviceNumber; i++) {
          if (validateRadioQt(deviceType)) {
            alert("Превышено количество устройств данного типа");
            setTimeout(() => {
              set_r_device_name("1");
              document.getElementById("modal_r_device_name").value = "1";
            }, 3000)

            let deviceOk = document.getElementById('okDevice_' + deviceType)
            deviceOk.style.opacity = '1'
            deviceOk.style.color = 'red'
            deviceOk.innerHTML = 'X'
            return;
          }

          if (deviceType === '17620') {
            set_r_device_name(deviceType, null, null, null, checkCall)
            saveModalRadioEXT_NEW(deviceType, mixAll)

          } else {
            set_r_device_name(deviceType, null, null, null, checkCall)
            saveModalRadio_NEW(deviceType, mixAll)

          }

          document.getElementById('okDevice_' + deviceType).style.opacity = '1'
          setTimeout(() => {
            document.getElementById('okDevice_' + deviceType).style.opacity = '0'

          }, 2000)
        }


      }
    })
    //отпровляем на сервер все собранные данные за один раз
    modal_numberSelectionDevice(modelDevice, flag = true)
    liveSaveInterface();
    clearExpiredKey();
    parseAppKey("update_notabs");
  }, 100)

  setTimeout(() => {
    spiner_stop()
  }, 200)
}
function FreeNumber() {
  let firstFreeNumber = []
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key.indexOf("xxad") != -1) {
      if (deviceJSON.config[i].key != "xxad0") {
        if (
          deviceJSON.config[i].subvalues[1].value == "" ||
          deviceJSON.config[i].subvalues[1].value == " " ||
          deviceJSON.config[i].subvalues[1].value == "0"
        ) {
          firstFreeNumber.push((deviceJSON.config[i].key).slice(4));
        }
      }
    }
  }
  return firstFreeNumber
}

function modal_numberSelectionDevice(modelDevice, flag = false) {
  let firstFreeNumber = FreeNumber()
  let saveNumberDevice = localStorage.getItem('xxadUserChoice')
  let selected = Number(saveNumberDevice) + 1

  if (!firstFreeNumber.includes(String(selected)) || firstFreeNumber.includes(String(saveNumberDevice))) {
    selected = Number(firstFreeNumber[0])
  }
  let str = ''
  str += `<b>№ РУ</b></br>`
  if (firstFreeNumber.length !== 0) {
    str += `<select onchange="allAddDevice()"  class="numberSelectionDevice" float:left id="numberSelectionDevice_id">`

    for (let i = 0; i < firstFreeNumber.length; i++) {
      str += "<option";
      if (selected === Number(firstFreeNumber[i])) {
        str += " selected ";
      }
      str += ` value="${firstFreeNumber[i]}">${firstFreeNumber[i]}</option>`;

    }

    str += "</select>";
  } else {
    str += "<span style='color:red'>Свободные зоны закончились</span>"
  }
  //str += "</label>";
  str += "<br>";
  if (flag) {
    str += "</td>"
    str += "</tr>";
    document.getElementById('modal_RadioD').innerHTML = str
  }
  else {
    return str
  }

}

function modal_MixDevice(modelDevice, flag = false) {
  const busyNum = {}
  if (virtualRadio.length !== 0) {

    for (const device of virtualRadio) {
      if (!busyNum.hasOwnProperty(device.name)) {
        busyNum[device.name] = 1

      } else {
        busyNum[device.name] += 1
      }
    }

  }
  let b3 = 0
  let b14 = 0
  let b64 = 0


  for (const iter of Object.keys(busyNum)) {
    if (iter == '13431' || iter == '13438' || iter == '13439') {
      b3 += busyNum[iter]
    }
    else if (iter == '16370') {
      b14 += busyNum[iter]
    }
    else {
      b64 += busyNum[iter]
    }
  }

  //Кол-во приборов
  let selected;

  let str = ''
  if (flag) {
    str += "<td id='modal_allMix' style='width:300px; display:none;'><b>Кол-во устройств</b></br>"
  }
  str +=
    `<select onchange="allAddDevice(this)"  class="trinket_func_select_rank_test" float:left id="trinket_click_usr_${modelDevice}"`


  str += '>';


  if (modelDevice === '13431' || modelDevice === '13438' || modelDevice === '13439') {
    for (let i = 1; i <= 3 - b3; i++) {
      str += "<option";
      if (selected === i) {
        str += " selected ";
      }
      str += ` value="${i}">${i}</option>`;

    }
  } else if (modelDevice === '16370') {
    for (let i = 1; i <= 14 - b14; i++) {
      str += "<option";
      if (selected === i) {
        str += " selected ";
      }
      str += ` value="${i}">${i}</option>`;
    }
  }
  else {
    for (let i = 1; i <= 64 - b64; i++) {
      str += "<option";
      if (selected === i) {
        str += " selected ";
      }
      str += ` value="${i}">${i}</option>`;

    }
  }


  str += "</select>";
  str += "</label>";
  str += "<br>";
  if (flag) {
    str += "</td>"
    str += "</tr>";
    document.getElementById('modal_allMix').innerHTML = str
  }
  else {
    return str
  }

}


// открываем вкладку со всеми приборами
function openMixDevice(str = '', modelDevice = R_DEVICE_NAME) {

  const busyNum = {}
  if (virtualRadio.length !== 0) {

    for (const device of virtualRadio) {
      if (!busyNum.hasOwnProperty(device.name)) {
        busyNum[device.name] = 1

      } else {
        busyNum[device.name] += 1
      }
    }

  }
  let b3 = 0
  let b14 = 0
  let b64 = 0


  for (const iter of Object.keys(busyNum)) {
    if (iter == '13431' || iter == '13438' || iter == '13439') {
      b3 += busyNum[iter]
    }
    else if (iter == '16370') {
      b14 += busyNum[iter]
    }
    else {
      b64 += busyNum[iter]
    }
  }


  for (const key in modelDevice) {
    if (key !== '0' && key !== '1') {
      let rowId = '1' + modelDevice[key].name.slice(-4)



      str +=
        '<label class="allDevice"  style = "display:block; width:90%">  <input class="w3-radio w3-radio-7620" onchange="setMixDeviceControl(this)" id="XXSS_rank_control" name="XXSS_rank_control" type="checkbox"';

      str += '">' + modelDevice[key].name;
      //Кол-во приборов
      let selected;
      let disabled = true;

      str += '<label>  -----    Кол-во приборов  </label>'
      str +=
        `<select onchange="allAddDevice(this)"  class="trinket_func_select_rank" float:left id="trinket_click_usr_${rowId}"`
      if (disabled) {
        str += "disabled"
      }
      str += '>';

      if (rowId === '13431' || rowId === '13438' || rowId === '13439') {
        for (let i = 0; i <= 3 - b3; i++) {
          str += "<option";
          if (selected === i) {
            str += " selected ";
          }
          str += ` value="${i}">${i}</option>`;

        }
      } else if (rowId === '16370') {
        for (let i = 0; i <= 14 - b14; i++) {
          str += "<option";
          if (selected === i) {
            str += " selected ";
          }
          str += ` value="${i}">${i}</option>`;
        }
      }
      else {
        for (let i = 0; i <= 64 - b64; i++) {
          str += "<option";
          if (selected === i) {
            str += " selected ";
          }
          str += ` value="${i}">${i}</option>`;

        }
      }


      str += "</select>";
      str += `<i id="okDevice_${rowId}" style="opacity:0; color:green">✔</i>`
      str += `<i id="maxDevice_${rowId}" style="display:none;">         Добавлено максимальное количество устройств данного типа</i>`

      setTimeout(() => {
        if (validateRadioQt(rowId)) {
          let maxDevice = 'maxDevice_' + rowId
          document.getElementById(maxDevice).style.display = ''

        }
      }, 1000)

      str += "</label>";

      str += "<br>";

    }

  }
  str += '<button id="modal_r_mix_device_save" onclick="MixDeviceValue(this)" class="w3-bar-item w3-button w3-teal w3-round" disabled>✔ Добавить</button>'
  str += '<label>  Всего:  </label>'
  str += '<label id="allAddDevice">0</label>'
  return str
}
/////////////////////////// Конец добавление всех радио приборов списком.


function set_r_device_name(modelDevice, zone_1, zone_2, sections, checkCall) {
  // переключатель названия устройства
  //modelDevice модель устройства
  // в sections номер раздела
  if (modelDevice != "0" && CACHE_EDIT_R_DEVICE.id == "-1") {
    if (validateRadioQt(modelDevice)) {
      alert("Превышено количество устройств данного типа");
      set_r_device_name("0");
      document.getElementById("modal_r_device_name").value = "0";
      return;
    }
  }

  let flag = true
  modal_MixDevice(modelDevice, flag)
  if (+modelDevice === 0) {
    $.hide("#modal_r_device_zone");
    $.hide("#modal_r_device_description");
    document.getElementById('modal_RadioD').style.display = 'none'
  } else {
    $.show("#modal_r_device_zone");
    $.show("#modal_r_device_description");
  }
  $.hide("#modal_r_device_error"); // Скрыть блок ошибок
  $.hide("#modal_r_device_error"); // Скрыть блок ошибок
  //let summZone = R_DEVICE_NAME[modelDevice].zone; // количество зон устройства
  let str = "";


  // если выбрали пункт ВСЕ 
  if (+modelDevice === 1) {

    str += openMixDevice(str, R_DEVICE_NAME)
    document.getElementById('modal_RadioD').style.display = ''
  } else {
    document.getElementById('modal_r_device_save').setAttribute('onclick', 'saveModalRadio()')
    document.getElementById('modal_r_exe_save').setAttribute('onclick', 'saveModalRadioEXT_NEW()')

  }
  document.getElementById('modal_r_device_save').innerHTML = `&#10004; Сохранить`
  document.getElementById('modal_r_exe_save').innerHTML = `&#10004; Сохранить`

  if (+modelDevice !== 1 && +modelDevice !== 0) {
    document.getElementById('modal_allMix').style.display = ''
    document.getElementById('modal_RadioD').style.display = ''
    setTimeout(() => {
      $.show("#modal_r_device_save");
    }, 100)
  } else {
    document.getElementById('modal_allMix').style.display = 'none'

  }

  let paramZone_1 = {};
  if (zone_1 !== null) {
    for (var z = 0; z < virtualZone.length; z++) {
      if (virtualZone[z].numberZone === zone_1) {
        paramZone_1 = virtualZone[z];
      }
    }
  }
  let paramZone_2 = {};
  if (zone_2 !== null) {
    for (var z = 0; z < virtualZone.length; z++) {
      if (virtualZone[z].numberZone === zone_2) {
        paramZone_2 = virtualZone[z];
      }
    }
  }
  const paramZoneDefault_1 = paramZone_1.name ? paramZone_1.name : ''
  const paramZoneDefault_2 = paramZone_2.name ? paramZone_2.name : ''

  $.hide("#modal_r_exe_save");
  $.hide("#modal_integral_save");
  $.hide("#modal_r_device_save");
  if (modelDevice === "15130") {
    $.show("#modal_r_device_save");
    str += "<b>Настройка зон устройства:</b>";
    str += '<table class="w3-table w3-table-all"><tbody>';
    str += "<tr>";
    str += "<td>№ Зоны</td>";
    str += "<td></td>";
    str += "<td>Тип</td>";
    str += "<td>Псевдоним</td>";
    str += "<td title='Формировать сообщение востановление (Газ, Вода)'>Восст.</td>";
    str += "<td>Задержка(вход)</td>";
    str += "<td>Задержка(выход)</td>";
    str += "<td>Раздел</td>";
    str += "</tr>";
    // Основная зона устрйоства
    str += "<tr>";
    str += "<td><input ";
    if (modelDevice == "-1") {
      str += "  "; // здесь можно поставить disable
    }
    str += " onchange='' type='number' id='adresZone_1' style='width:60px' value='";

    if (zone_1 == undefined) {
      // str += pickUpYzLw("lw", "2")[0]; АВТОМАТИЧЕСКИЙ ПОДБОР ЗОНЫ ПРИ СОЗДАНИИ КАРТОЧКИ
      str += 0;
      // генерируем новые свободные адреса
    } else {
      str += zone_1;
      // тянем адреса из конфига
    }

    str += "'></td>";
    str += "<td>Основная</td>";
    str +=
      "<td>" +
      selectedTypeGuardZone(modelDevice, paramZone_1.type, paramZone_1.param, 1, paramZone_1.delay, "modal", "1") +
      "</td>";

    //Псевдоним и чекбокс

    str +=
      "<td><input value='" +
      paramZoneDefault_1 +
      "' onchange='setNameZone(this)' name='lb" +
      paramZone_1.numberZone +
      "' style='width:110px'>" +
      "</td>";
    str +=
      '<td><input onchange="recoverTypeZone(this)" type="checkbox" class="w3-check" id="recoveryLw_Cart_' +
      paramZone_1.numberZone +
      '" ';
    if (checkRecoverZone(paramZone_1.type, paramZone_1.param)) {
      str += " checked ";
    }

    if (+paramZone_1.type !== 2) {
      str += " disabled ";
    }
    str += "></td>";



    // ЗАдержка вы ВХОД
    str += "<td><input";
    let disablDelay = delaySection_DISABLED(paramZone_1.type, paramZone_1.param);
    let valueDelay = "";
    if (disablDelay.yes) {
      if (paramZone_1.delay == 0 || paramZone_1.delay == "" || paramZone_1.delay == undefined) {
        str += " disabled ";
        valueDelay = "";
      } else {
        valueDelay = paramZone_1.delay;
      }
    } else {
      valueDelay = paramZone_1.delay;
    }
    str += " style='width:60px' id='modal_r_device_zone_delay_1' value='";
    str += valueDelay;
    str += "' type='number'></td>";

    // ...ЗАдержка вы ВХОД
    // ЗАдержка вы ВЫХОД
    str += "<td><input";

    let valueDelayExit = "";
    if (disablDelay.yes) {
      if (paramZone_1.delay == 0 || paramZone_1.delay == "" || paramZone_1.delay == undefined) {
        str += " disabled ";
        valueDelayExit = "";
      } else {
        valueDelayExit = paramZone_1.delayExit;
      }
    } else {
      valueDelayExit = paramZone_1.delayExit;
    }
    str += " style='width:60px' id='modal_r_device_zone_delay_EXIT_1' value='";
    str += valueDelayExit;
    str += "' type='number'></td>";
    // ...ЗАдержка вы ВЫХОД

    str += "<td>";
    str += "<select id='nomberZone_Section_1'>";
    // str += "<label><option>";
    // str += "Не выбран";
    // str += "</option></label>";

    for (var r = 1; DEVICEINFO[DEVICEMODEL].sections >= r; r++) {
      str += "<label>";
      str += "<option ";
      if (CACHE_EDIT_R_DEVICE.section !== null && +paramZone_1.section !== r) {
        // Проверка на клик из блока раздела на добавление устройства
        if (+CACHE_EDIT_R_DEVICE.section == r) {
          str += " selected ";
        }
      } else if (+paramZone_1.section == r) {
        str += " selected ";
      } else {
      }
      str += " value='" + r + "' name='" + r + "'  ";
      str += " > Раздел " + r + "</option></label>";
    }
    str += "</select>";
    str += "</td>";
    str += "</tr>";
    // Дополнительная зона устрйоства
    str += "<tr>";
    str += "<td><input ";
    if (modelDevice == "-1") {
      str += "  "; // здесь можно поставить disable
    }
    str += " onchange='' type='number' id='adresZone_2' style='width:60px' value='";

    if (zone_2 == undefined) {
      // str += pickUpYzLw("lw", "2")[1]; АВТОМАТИЧЕСКИЙ ПОДБОР ЗОНЫ ПРИ СОЗДАНИИ КАРТОЧКИ
      str += 0;
      // генерируем новые свободные адреса
    } else {
      str += zone_2;
      // тянем адреса из конфига
    }

    str += "'></td>";
    str += "<td>Доп.</td>";
    str +=
      "<td>" +
      selectedTypeGuardZone(modelDevice, paramZone_2.type, paramZone_2.param, 2, paramZone_2.delay, "modal", "2") +
      "</td>";

    //Псевдоним и чекбокс

    str +=
      "<td><input value='" +
      paramZoneDefault_2 +
      "' onchange='setNameZone(this)' name='lb" +
      paramZone_2.numberZone +
      "' style='width:110px'>" +
      "</td>";
    str +=
      '<td><input onchange="recoverTypeZone(this)" type="checkbox" class="w3-check" id="recoveryLw_Cart_' +
      paramZone_2.numberZone +
      '" ';
    if (checkRecoverZone(paramZone_2.type, paramZone_2.param)) {
      str += " checked ";
    }

    if (+paramZone_2.type !== 2) {
      str += " disabled ";
    }
    str += "></td>";

    // Дополнительная задержка на ВХОД
    str += "<td><input";
    let disablDelay2 = delaySection_DISABLED(paramZone_2.type, paramZone_2.param);
    let valueDelay2 = "";
    if (disablDelay2.yes) {
      if (paramZone_2.delay == 0 || paramZone_2.delay == "" || paramZone_2.delay == undefined) {
        str += " disabled ";
        valueDelay2 = "";
      } else {
        valueDelay2 = paramZone_2.delay;
      }
    } else {
      valueDelay2 = paramZone_2.delay;
    }

    str += " style='width:60px' id='modal_r_device_zone_delay_2' value='";
    str += valueDelay2;
    str += "' type='number'></td>";
    // ...Дополнительная задержка на ВХОД

    // Дополнительная задержка на ВЫХОД
    str += "<td><input";

    let valueDelay2Exit = "";
    if (disablDelay2.yes) {
      if (paramZone_2.delay == 0 || paramZone_2.delay == "" || paramZone_2.delay == undefined) {
        str += " disabled ";
        valueDelay2Exit = "";
      } else {
        valueDelay2Exit = paramZone_2.delayExit;
      }
    } else {
      valueDelay2Exit = paramZone_2.delayExit;
    }

    str += " style='width:60px' id='modal_r_device_zone_delay_EXIT_2' value='";
    str += valueDelay2Exit;
    str += "' type='number'></td>";
    // ...Дополнительная задержка на ВЫХОД

    str += "<td>";
    str += "<select id='nomberZone_Section_2'>";
    // str += "<label><option>";
    // str += "Не выбран";
    // str += "</option></label>";

    for (var r = 1; DEVICEINFO[DEVICEMODEL].sections >= r; r++) {
      str += "<label>";
      str += "<option ";

      if (CACHE_EDIT_R_DEVICE.section !== null && +paramZone_2.section !== r) {
        // Проверка на клик из блока раздела на добавление устройства
        if (+CACHE_EDIT_R_DEVICE.section == r) {
          str += " selected ";
        }
      } else if (+paramZone_2.section == r) {
        str += " selected ";
      } else {
      }

      str += " value='" + r + "' name='" + r + "'  ";
      str += " > Раздел " + r + "</option></label>";
    }
    str += "</select>";
    str += "</td>";
    str += "</tr>";

    str += "</tbody></table>";

    // настройки элементов питания
    str +=
      "<div style='display:flex'> <div style='margin-right:10px;'>" +
      'Элемент питания' +
      "</div><div style='display:flex'><label style='margin-right:10px;'><input title=''   class='w3-radio' name='" +
      'this.key' +
      "' type='radio' value='0' ";
    if (CACHE_EDIT_R_DEVICE.id !== "-1") {
      for (j in virtualRadio) {
        if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
          if (!(virtualRadio[j].SS & 0x40)) {
            str += " checked ";
          }
        }
      }
    } else {
      str += " checked ";
    }
    str +=
      "> ER14250(3,6 В)  </label></br><label> <input class='w3-radio' id='XXSS_main_battery_type_CR2'   name='" +
      'this.key' +
      "' type='radio' value='1'";
    if (CACHE_EDIT_R_DEVICE.id !== "-1") {
      for (j in virtualRadio) {
        if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
          if (virtualRadio[j].SS & 0x40) {
            str += " checked ";
          }
        }
      }
    } else {
      str += "";
    }
    str += "> CR2 (3,0 В)</p> </div></div>";

    // настройки сенсоров
    str += " <b>Настройки:</b>";
    str += "<table><tr><td><label><input ";
    for (j in virtualRadio) {
      if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
        if (virtualRadio[j].SS & 1) {
          str += " checked ";
        }
      }
    }
    str += ' id="sensor_sabotaje" type="checkbox" class="w3-check"> Контролировать датчик саботажа </label>';
    str +=
      '<label>  <input class="w3-radio w3-radio-7620" onchange="setTamperControl(this)" id="XXSS_tamper_control" name="XXSS_tamper_control" type="checkbox"';
    if (CACHE_EDIT_R_DEVICE.id !== "-1") {
      for (j in virtualRadio) {
        if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
          if (virtualRadio[j].SS & 0x20) {
            str += " checked ";
          }
        }
      }
    } else {
      str += " checked ";
    }
    str += "> Контролировать датчик вскрытия</label>";
    /*  str +=
       '<label>  <input class="w3-radio w3-radio-7620" onchange="setTamperControl(this)" id="XXSS_main_battery_type_CR2" name="XXSS_tamper_control" type="checkbox"';
     if (CACHE_EDIT_R_DEVICE.id !== "-1") {
       for (j in virtualRadio) {
         if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
           if (virtualRadio[j].SS & 0x40) {
             str += " checked ";
           }
         }
       }
     } else {
       str += "";
     }
     str += "> Основной элемент питания типа CR2</label>"; */
    str += "</td>";
    //str += '<td><label><input type="checkbox" class="w3-check"> Индикация</label></td>';
    str += "</tr></table>";
  }
  else if (modelDevice === "15230") {
    $.show("#modal_r_device_save");
    str += "<b>Настройка зон устройства:</b>";
    str += '<table class="w3-table w3-table-all"><tbody>';
    str += "<tr>";
    str += "<td>№ Зоны</td>";
    str += "<td>Тип</td>";
    str += "<td>Псевдоним</td>";
    str += "<td title='Формировать сообщение востановление (Газ, Вода)'>Восст.</td>";
    str += "<td>Задержка(вход)</td>";
    str += "<td>Задержка(выход)</td>";

    str += "<td>Раздел</td>";
    str += "</tr>";
    // Основная зона устрйоства
    str += "<tr>";
    str += "<td><input ";
    if (modelDevice == "-1") {
      str += "  "; // здесь можно поставить disable
    }
    str += " onchange='' type='number' id='adresZone_1' style='width:60px' value='";
    if (zone_1 == undefined) {
      // str += pickUpYzLw("lw", "2")[0]; АВТОМАТИЧЕСКИЙ ПОДБОР ЗОНЫ ПРИ СОЗДАНИИ КАРТОЧКИ
      str += 0;
      // генерируем новые свободные адреса
    } else {
      str += zone_1;
      // тянем адреса из конфига
    }

    str += "'></td>";
    str +=
      "<td>" +
      selectedTypeGuardZone(modelDevice, paramZone_1.type, paramZone_1.param, 1, paramZone_1.delay, "modal", "1") +
      "</td>";
    //Псевдоним и чекбокс

    str +=
      "<td><input value='" +
      paramZoneDefault_1 +
      "' onchange='setNameZone(this)' name='lb" +
      paramZone_1.numberZone +
      "' style='width:110px'>" +
      "</td>";
    str +=
      '<td><input onchange="recoverTypeZone(this)" type="checkbox" class="w3-check" id="recoveryLw_Tabl_' +
      paramZone_1.numberZone +
      '" ';
    if (checkRecoverZone(paramZone_1.type, paramZone_1.param)) {
      str += " checked ";
    }

    if (+paramZone_1.type !== 2) {
      str += " disabled ";
    }
    str += "></td>";
    // Задержка на вход
    str += "<td><input";
    let disablDelay = delaySection_DISABLED(paramZone_1.type, paramZone_1.param);
    let valueDelay = "";
    if (disablDelay.yes) {
      if (paramZone_1.delay == 0 || paramZone_1.delay == "" || paramZone_1.delay == undefined) {
        str += " disabled ";
        valueDelay = "";
      } else {
        valueDelay = paramZone_1.delay;
      }
    } else {
      valueDelay = paramZone_1.delay;
    }
    str += " style='width:60px' id='modal_r_device_zone_delay_1' value='";
    str += valueDelay;
    str += "' type='number'></td>";
    // ...Задержка на вход
    // Задержка на вЫход
    str += "<td><input";

    let valueDelayExit = "";
    if (disablDelay.yes) {
      if (paramZone_1.delay == 0 || paramZone_1.delay == "" || paramZone_1.delay == undefined) {
        str += " disabled ";
        valueDelayExit = "";
      } else {
        valueDelayExit = paramZone_1.delayExit;
      }
    } else {
      valueDelayExit = paramZone_1.delayExit;
    }
    str += " style='width:60px' id='modal_r_device_zone_delay_EXIT_1' value='";
    str += valueDelay;
    str += "' type='number'></td>";
    // ...Задержка на вЫход

    str += "<td>";
    str += "<select id='nomberZone_Section_1'>";
    // str += "<label><option>";
    // str += "Не выбран";
    // str += "</option></label>";

    for (var r = 1; DEVICEINFO[DEVICEMODEL].sections >= r; r++) {
      str += "<label>";
      str += "<option ";
      if (CACHE_EDIT_R_DEVICE.section !== null && +paramZone_1.section !== r) {
        // Проверка на клик из блока раздела на добавление устройства
        if (+CACHE_EDIT_R_DEVICE.section == r) {
          str += " selected ";
        }
      } else if (+paramZone_1.section == r) {
        str += " selected ";
      } else {
      }
      str += " value='" + r + "' name='" + r + "'  ";
      str += " > Раздел " + r + "</option></label>";
    }
    str += "</select>";
    str += "</td>";

    str += "</tr>";
    str += "</tbody></table>";

    // настройки элементов питания
    str +=
      "<div style='display:flex'> <div style='margin-right:10px;'>" +
      'Элемент питания' +
      "</div><div style='display:flex'><label style='margin-right:10px;'><input title=''   class='w3-radio' name='" +
      'this.key' +
      "' type='radio' value='0' ";
    if (CACHE_EDIT_R_DEVICE.id !== "-1") {
      for (j in virtualRadio) {
        if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
          if (!(virtualRadio[j].SS & 0x40)) {
            str += " checked ";
          }
        }
      }
    } else {
      str += " checked ";
    }
    str +=
      "> ER14250(3,6 В)  </label></br><label> <input class='w3-radio' id='XXSS_main_battery_type_CR2'   name='" +
      'this.key' +
      "' type='radio' value='1'";
    if (CACHE_EDIT_R_DEVICE.id !== "-1") {
      for (j in virtualRadio) {
        if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
          if (virtualRadio[j].SS & 0x40) {
            str += " checked ";
          }
        }
      }
    } else {
      str += "";
    }
    str += "> CR2 (3,0 В)</p> </div></div>";

    str += "<b>Настройки:</b>";
    str += "<table><tr><td><label><input";
    for (j in virtualRadio) {
      if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
        if (virtualRadio[j].SS & 1) {
          str += " checked ";
        }
      }
    }
    str += ' type="checkbox" id="range_less_10" class="w3-check"> Дальность менее 10 метров </label>';
    str +=
      '<label>  <input class="w3-radio w3-radio-7620" onchange="setTamperControl(this)" id="XXSS_tamper_control" name="XXSS_tamper_control" type="checkbox"';
    if (CACHE_EDIT_R_DEVICE.id !== "-1") {
      for (j in virtualRadio) {
        if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
          if (virtualRadio[j].SS & 0x20) {
            str += " checked ";
          }
        }
      }
    } else {
      str += " checked ";
    }
    str += "> Контролировать датчик вскрытия</label>";

    str += "</tr></table>";
  }
  else if (modelDevice === "15231") {
    $.show("#modal_r_device_save");
    str += "<b>Настройка зон устройства:</b>";
    str += '<table class="w3-table w3-table-all"><tbody>';
    str += "<tr>";
    str += "<td>№ Зоны</td>";
    str += "<td>Тип</td>";
    str += "<td>Псевдоним</td>";
    str += "<td title='Формировать сообщение востановление (Газ, Вода)'>Восст.</td>";
    str += "<td>Задержка(вход)</td>";
    str += "<td>Задержка(выход)</td>";
    str += "<td>Раздел</td>";
    str += "</tr>";
    // Основная зона устрйоства
    str += "<tr>";
    str += "<td><input ";
    if (modelDevice == "-1") {
      str += "  "; // здесь можно поставить disable
    }
    str += " onchange='' type='number' id='adresZone_1' style='width:60px' value='";
    if (zone_1 == undefined) {
      // str += pickUpYzLw("lw", "2")[0]; АВТОМАТИЧЕСКИЙ ПОДБОР ЗОНЫ ПРИ СОЗДАНИИ КАРТОЧКИ
      str += 0;
      // генерируем новые свободные адреса
    } else {
      str += zone_1;
      // тянем адреса из конфига
    }

    str += "'></td>";
    str +=
      "<td>" +
      selectedTypeGuardZone(modelDevice, paramZone_1.type, paramZone_1.param, 1, paramZone_1.delay, "modal", "1") +
      "</td>";

    //Псевдоним и чекбокс

    str +=
      "<td><input value='" +
      paramZoneDefault_1 +
      "' onchange='setNameZone(this)' name='lb" +
      paramZone_1.numberZone +
      "' style='width:110px'>" +
      "</td>";
    str +=
      '<td><input onchange="recoverTypeZone(this)" type="checkbox" class="w3-check" id="recoveryLw_Tabl_' +
      paramZone_1.numberZone +
      '" ';
    if (checkRecoverZone(paramZone_1.type, paramZone_1.param)) {
      str += " checked ";
    }

    if (+paramZone_1.type !== 2) {
      str += " disabled ";
    }
    str += "></td>";
    // Задержка на вход
    str += "<td><input";
    let disablDelay = delaySection_DISABLED(paramZone_1.type, paramZone_1.param);
    let valueDelay = "";
    if (disablDelay.yes) {
      if (paramZone_1.delay == 0 || paramZone_1.delay == "" || paramZone_1.delay == undefined) {
        str += " disabled ";
        valueDelay = "";
      } else {
        valueDelay = paramZone_1.delay;
      }
    } else {
      valueDelay = paramZone_1.delay;
    }
    str += " style='width:60px' id='modal_r_device_zone_delay_1' value='";
    str += valueDelay;
    str += "' type='number'></td>";
    // ...Задержка на вход
    // Задержка на вЫход
    str += "<td><input";
    let valueDelayExit = "";
    if (disablDelay.yes) {
      if (paramZone_1.delay == 0 || paramZone_1.delay == "" || paramZone_1.delay == undefined) {
        str += " disabled ";
        valueDelayExit = "";
      } else {
        valueDelayExit = paramZone_1.delayExit;
      }
    } else {
      valueDelayExit = paramZone_1.delayExit;
    }
    str += " style='width:60px' id='modal_r_device_zone_delay_EXIT_1' value='";
    str += valueDelayExit;
    str += "' type='number'></td>";
    // ...Задержка на вЫход
    str += "<td>";
    str += "<select id='nomberZone_Section_1'>";
    // str += "<label><option>";
    // str += "Не выбран";
    // str += "</option></label>";

    for (var r = 1; DEVICEINFO[DEVICEMODEL].sections >= r; r++) {
      str += "<label>";
      str += "<option ";
      if (CACHE_EDIT_R_DEVICE.section !== null && +paramZone_1.section !== r) {
        // Проверка на клик из блока раздела на добавление устройства
        if (+CACHE_EDIT_R_DEVICE.section == r) {
          str += " selected ";
        }
      } else if (+paramZone_1.section == r) {
        str += " selected ";
      } else {
      }
      str += " value='" + r + "' name='" + r + "'  ";
      str += " > Раздел " + r + "</option></label>";
    }
    str += "</select>";
    str += "</td>";
    str += "</tr>";

    str += "</tbody></table>";
    // настройки элементов питания
    str +=
      "<div style='display:flex'> <div style='margin-right:10px;'>" +
      'Элемент питания' +
      "</div><div style='display:flex'><label style='margin-right:10px;'><input title=''   class='w3-radio' name='" +
      'this.key' +
      "' type='radio' value='0' ";
    if (CACHE_EDIT_R_DEVICE.id !== "-1") {
      for (j in virtualRadio) {
        if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
          if (!(virtualRadio[j].SS & 0x40)) {
            str += " checked ";
          }
        }
      }
    } else {
      str += " checked ";
    }
    str +=
      "> ER14250(3,6 В)  </label></br><label> <input class='w3-radio' id='XXSS_main_battery_type_CR2'   name='" +
      'this.key' +
      "' type='radio' value='1'";
    if (CACHE_EDIT_R_DEVICE.id !== "-1") {
      for (j in virtualRadio) {
        if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
          if (virtualRadio[j].SS & 0x40) {
            str += " checked ";
          }
        }
      }
    } else {
      str += "";
    }
    str += "> CR2 (3,0 В)</p> </div></div>";

    str += "<b>Настройки:</b>";
    str += "<table><tr><td><label><input";
    for (j in virtualRadio) {
      if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
        if (virtualRadio[j].SS & 1) {
          str += " checked ";
        }
      }
    }
    str += ' id="animal_on" type="checkbox" class="w3-check"> Устойчивость к животным </label>';
    str +=
      '<label>  <input class="w3-radio w3-radio-7620" onchange="setTamperControl(this)" id="XXSS_tamper_control" name="XXSS_tamper_control" type="checkbox"';
    if (CACHE_EDIT_R_DEVICE.id !== "-1") {
      for (j in virtualRadio) {
        if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
          if (virtualRadio[j].SS & 0x20) {
            str += " checked ";
          }
        }
      }
    } else {
      str += " checked ";
    }
    str += "> Контролировать датчик вскрытия</label>";

    str += "</tr></table>";
  }
  else if (modelDevice === "15830") {
    $.show("#modal_r_device_save");
    str += "<b>Настройка зон устройства:</b>";
    str += '<table class="w3-table w3-table-all"><tbody>';
    str += "<tr>";
    str += "<td>№ Зоны</td>";

    str += "<td></td>";
    str += "<td>Тип</td>";
    str += "<td>Псевдоним</td>";
    str += "<td title='Формировать сообщение востановление (Газ, Вода)'>Восст.</td>";
    str += "<td>Задержка(вход)</td>";
    str += "<td>Задержка(выход)</td>";
    str += "<td>Раздел</td>";
    str += "</tr>";
    // Основная зона устрйоства
    str += "<tr>";

    str += "<td><input ";
    if (modelDevice == "-1") {
      str += "  "; // здесь можно поставить disable
    }
    str += " onchange='' type='number' id='adresZone_1' style='width:60px' value='";
    if (zone_1 == undefined) {
      // str += pickUpYzLw("lw", "2")[0]; АВТОМАТИЧЕСКИЙ ПОДБОР ЗОНЫ ПРИ СОЗДАНИИ КАРТОЧКИ
      str += 0;
      // генерируем новые свободные адреса
    } else {
      str += zone_1;
      // тянем адреса из конфига
    }

    str += "'></td>";
    str += "<td>Основная</td>";
    str +=
      "<td>" +
      selectedTypeGuardZone(modelDevice, paramZone_1.type, paramZone_1.param, 1, paramZone_1.delay, "modal", "1") +
      "</td>";
    //Псевдоним и чекбокс

    str +=
      "<td><input value='" +
      paramZoneDefault_1 +
      "' onchange='setNameZone(this)' name='lb" +
      paramZone_1.numberZone +
      "' style='width:110px'>" +
      "</td>";
    str +=
      '<td><input onchange="recoverTypeZone(this)" type="checkbox" class="w3-check" id="recoveryLw_Tabl_' +
      paramZone_1.numberZone +
      '" ';
    if (checkRecoverZone(paramZone_1.type, paramZone_1.param)) {
      str += " checked ";
    }

    if (+paramZone_1.type !== 2) {
      str += " disabled ";
    }
    str += "></td>";
    // Задержка на вход
    str += "<td><input";
    let disablDelay = delaySection_DISABLED(paramZone_1.type, paramZone_1.param);
    let valueDelay = "";
    if (disablDelay.yes) {
      if (paramZone_1.delay == 0 || paramZone_1.delay == "" || paramZone_1.delay == undefined) {
        str += " disabled ";
        valueDelay = "";
      } else {
        valueDelay = paramZone_1.delay;
      }
    } else {
      valueDelay = paramZone_1.delay;
    }
    str += " style='width:60px' id='modal_r_device_zone_delay_1' value='";
    str += valueDelay;
    str += "' type='number'></td>";
    // ...Задержка на вход
    // Задержка на выход
    str += "<td><input";
    let valueDelayExit = "";
    if (disablDelay.yes) {
      if (paramZone_1.delay == 0 || paramZone_1.delay == "" || paramZone_1.delay == undefined) {
        str += " disabled ";
        valueDelayExit = "";
      } else {
        valueDelayExit = paramZone_1.delayExit;
      }
    } else {
      valueDelayExit = paramZone_1.delayExit;
    }
    str += " style='width:60px' id='modal_r_device_zone_delay_EXIT_1' value='";
    str += valueDelayExit;
    str += "' type='number'></td>";
    // ...Задержка на выход

    str += "<td>";
    str += "<select id='nomberZone_Section_1'>";
    // str += "<label><option>";
    // str += "Не выбран";
    // str += "</option></label>";

    for (var r = 1; DEVICEINFO[DEVICEMODEL].sections >= r; r++) {
      str += "<label>";
      str += "<option ";
      if (CACHE_EDIT_R_DEVICE.section !== null && +paramZone_1.section !== r) {
        // Проверка на клик из блока раздела на добавление устройства
        if (+CACHE_EDIT_R_DEVICE.section == r) {
          str += " selected ";
        }
      } else if (+paramZone_1.section == r) {
        str += " selected ";
      } else {
      }
      str += " value='" + r + "' name='" + r + "'  ";
      str += " > Раздел " + r + "</option></label>";
    }
    str += "</select>";
    str += "</td>";
    str += "</tr>";
    // Дополнительная зона
    str += "<tr>";
    str += "<td><input ";
    if (modelDevice == "-1") {
      str += "  "; // здесь можно поставить disable
    }
    str += " onchange='' type='number' id='adresZone_2' style='width:60px' value='";

    if (zone_2 == undefined) {
      // str += pickUpYzLw("lw", "2")[1]; АВТОМАТИЧЕСКИЙ ПОДБОР ЗОНЫ ПРИ СОЗДАНИИ КАРТОЧКИ
      str += 0;
      // генерируем новые свободные адреса
    } else {
      str += zone_2;
      // тянем адреса из конфига
    }

    str += "'></td>";
    str += "<td>Доп.</td>";
    str +=
      "<td>" +
      selectedTypeGuardZone(modelDevice, paramZone_2.type, paramZone_2.param, 2, paramZone_2.delay, "modal", "2") +
      "</td>";
    //Псевдоним и чекбокс

    str +=
      "<td><input value='" +
      paramZoneDefault_2 +
      "' onchange='setNameZone(this)' name='lb" +
      paramZone_2.numberZone +
      "' style='width:110px'>" +
      "</td>";
    str +=
      '<td><input onchange="recoverTypeZone(this)" type="checkbox" class="w3-check" id="recoveryLw_Tabl_' +
      paramZone_2.numberZone +
      '" ';
    if (checkRecoverZone(paramZone_2.type, paramZone_2.param)) {
      str += " checked ";
    }

    if (+paramZone_2.type !== 2) {
      str += " disabled ";
    }
    str += "></td>";
    // Задержка на вход
    str += "<td><input";
    let disablDelay2 = delaySection_DISABLED(paramZone_2.type, paramZone_2.param);
    let valueDelay2 = "";
    if (disablDelay2.yes) {
      if (paramZone_2.delay == 0 || paramZone_2.delay == "" || paramZone_2.delay == undefined) {
        str += " disabled ";
        valueDelay2 = "";
      } else {
        valueDelay2 = paramZone_2.delay;
      }
    } else {
      valueDelay2 = paramZone_2.delay;
    }
    str += " style='width:60px' id='modal_r_device_zone_delay_2' value='";
    str += valueDelay2;
    str += "' type='number'></td>";

    //... Задержка на вход
    // Задержка на выход
    str += "<td><input";
    let valueDelay2Exit = "";
    if (disablDelay2.yes) {
      if (paramZone_2.delay == 0 || paramZone_2.delay == "" || paramZone_2.delay == undefined) {
        str += " disabled ";
        valueDelay2Exit = "";
      } else {
        valueDelay2Exit = paramZone_2.delayExit;
      }
    } else {
      valueDelay2Exit = paramZone_2.delayExit;
    }
    str += " style='width:60px' id='modal_r_device_zone_delay_EXIT_2' value='";
    str += valueDelay2Exit;
    str += "' type='number'></td>";

    //... Задержка на выход
    str += "<td>";
    str += "<select id='nomberZone_Section_2'>";
    // str += "<label><option>";
    // str += "Не выбран";
    // str += "</option></label>";

    for (var r = 1; DEVICEINFO[DEVICEMODEL].sections >= r; r++) {
      str += "<label>";
      str += "<option ";

      if (CACHE_EDIT_R_DEVICE.section !== null && +paramZone_2.section !== r) {
        // Проверка на клик из блока раздела на добавление устройства
        if (+CACHE_EDIT_R_DEVICE.section == r) {
          str += " selected ";
        }
      } else if (+paramZone_2.section == r) {
        str += " selected ";
      } else {
      }

      str += " value='" + r + "' name='" + r + "'  ";
      str += " > Раздел " + r + "</option></label>";
    }
    str += "</select>";
    str += "</td>";
    str += "</tr>";

    str += "</tbody></table>";
    // настройки элементов питания
    str +=
      "<div style='display:flex'> <div style='margin-right:10px;'>" +
      'Элемент питания' +
      "</div><div style='display:flex'><label style='margin-right:10px;'><input title=''   class='w3-radio' name='" +
      'this.key' +
      "' type='radio' value='0' ";
    if (CACHE_EDIT_R_DEVICE.id !== "-1") {
      for (j in virtualRadio) {
        if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
          if (!(virtualRadio[j].SS & 0x40)) {
            str += " checked ";
          }
        }
      }
    } else {
      str += " checked ";
    }
    str +=
      "> ER14250(3,6 В)  </label></br><label> <input class='w3-radio' id='XXSS_main_battery_type_CR2'   name='" +
      'this.key' +
      "' type='radio' value='1'";
    if (CACHE_EDIT_R_DEVICE.id !== "-1") {
      for (j in virtualRadio) {
        if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
          if (virtualRadio[j].SS & 0x40) {
            str += " checked ";
          }
        }
      }
    } else {
      str += "";
    }
    str += "> CR2 (3,0 В)</p> </div></div>";
    str += "<b>Настройки:</b>";
    str += "<table><tr><td><label><input ";
    for (j in virtualRadio) {
      if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
        if (virtualRadio[j].SS & 1) {
          str += " checked ";
        }
      }
    }
    str += ' id="range_less_4" type="checkbox" class="w3-check"> Дистанция менее 4 метров </label>';
    str += "<label><input ";
    for (j in virtualRadio) {
      if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
        if (virtualRadio[j].SS & 2) {
          str += " checked ";
        }
      }
    }
    str +=
      ' type="checkbox" id="glass_2" class="w3-check"> Стекло размером менее 0,2 м<sup><small>2</small></sup></label>';
    str += "<label><input ";
    for (j in virtualRadio) {
      if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
        if (virtualRadio[j].SS & 4) {
          str += " checked ";
        }
      }
    }
    str += ' type="checkbox" id="glass_crash" class="w3-check"> Выпадение осколков</label></td><tr><td>';
    str +=
      '<label>  <input class="w3-radio w3-radio-7620" onchange="setTamperControl(this)" id="XXSS_tamper_control" name="XXSS_tamper_control" type="checkbox"';
    if (CACHE_EDIT_R_DEVICE.id !== "-1") {
      for (j in virtualRadio) {
        if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
          if (virtualRadio[j].SS & 0x20) {
            str += " checked ";
          }
        }
      }
    } else {
      str += " checked ";
    }
    str += "> Контролировать датчик вскрытия</label>";

    str += "</tr></table>";
  }
  else if (modelDevice === "16270") {
    $.show("#modal_r_device_save");
    let THIS_EXT = {};
    let ext = {
      name: "",
      soft: "",
      model: "",
      zone: [],
      activeSections: []
    };
    THIS_EXT.exe = []
    for (i in virtualRadio) {
      if (virtualRadio[i].numberRadio === CACHE_EDIT_R_DEVICE.id) {
        ext.name = virtualRadio[i].type;
        ext.soft = virtualRadio[i].SS;
        ext.model = virtualRadio[i].name;
        let hex = dataDevice["xxkb" + virtualRadio[i].numberRadio].value
        /*  if (!hex) {
           hex = 0
         } */
        let hextobin = ''
        const hexObj = {
          '0': '0000',
          '1': '1000',
          '2': '0100',
          '3': '1100',
          '4': '0010',
          '5': '1010',
          '6': '0110',
          '7': '1110',
          '8': '0001',
          '9': '1001',
          'A': '0101',
          'B': '1101',
          'C': '0011',
          'D': '1011',
          'E': '0111',
          'F': '1111',
        }
        //Переводим hex из прибора в bin
        for (let i = 0; i < hex.length; i++) {
          el = hex[((i + 1) % 2) + (i & 0xFFFFFFFE)]
          for (const key in hexObj) {
            if (el === key) {
              hextobin += hexObj[key]
            }
          }
        }
        let allSectorHex = hextobin.split('')

        let numSection = []
        for (let i = 0; i < allSectorHex.length; i++) {
          if (allSectorHex[i] == 1) {
            numSection.push(i + 1)
          }

        }
        let sectionValue = numSection.join(",")

        virtualRadio[i].activeSections = sectionValue

        THIS_EXT.exe.push(virtualRadio[i]);
      }
    }

    // str += "<b>Настройка выходов управления:</b>";
    str += '<table class="w3-table w3-table-all" style="margin-top:10px">';
    str += "<tr>";
    str += "<td>Разделы</td>";
    str += "</tr>";
    str += "<td>";
    str +=
      "<div id='sectionXXKB'"
    /* if (CACHE_EDIT_R_DEVICE.id == -1) {
      str += ' disabled'
    } */
    str += "class='w3-dropdown-hover w3-mobile'>" +
      "<button class='w3-border w3-border-red w3-btn w3-white'>Разделы</button>" +
      "<div";


    str += ' id="section_RV" ';


    str += " class='w3-dropdown-content w3-bar-block w3-border w3-border-red' style='width:300px'>";
    if (CACHE_EDIT_R_DEVICE.id == -1) {

      for (var r = 1; DEVICEINFO[DEVICEMODEL].sections >= r; r++) {
        str +=
          "<label class='w3-button' style='width:70px'><label class='" +
          undefined + //?
          "'><input class='w3-check inputSections6270'  ' name='" +
          r +
          "' type='checkbox' ";

        str += " > " + r + " </label></label>";
      }
      str += "</div>" + "</div>";
      str += "</td>";
      str += "</table>";

    }

    for (var k = 0; k < THIS_EXT.exe.length; k++) {
      let activeArr = [];
      if (THIS_EXT.exe[k].activeSections !== null) {
        activeArr = THIS_EXT.exe[k].activeSections.split(",");
      }
      for (var r = 1; DEVICEINFO[DEVICEMODEL].sections >= r; r++) {
        str +=
          "<label class='w3-button' style='width:70px'><label class='" +
          THIS_EXT.exe[k].numberRadio +
          "'><input class='w3-check inputSections6270'  'name='" +
          r +
          "' type='checkbox' ";
        if (THIS_EXT.exe[k].activeSections !== null) {
          if (activeArr.includes(r + "")) {
            str += " checked ";
          }
        }
        str += " > " + r + " </label></label>";
      }
      str += "</div>" + "</div>";
      str += "</td>";
      str += "</table>";

    }
    // настройки элементов питания
    str +=
      "<div style='display:flex'> <div style='margin-right:10px;'>" +
      'Элементы питания' +
      "</div><div style='display:flex'><label style='margin-right:10px;'><input title=''   class='w3-radio' name='" +
      'this.key' +
      "' type='radio' value='0' ";
    if (CACHE_EDIT_R_DEVICE.id !== "-1") {
      for (j in virtualRadio) {
        if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
          if (!(virtualRadio[j].SS & 0x40)) {
            str += " checked ";
          }
        }
      }
    } else {
      str += " checked ";
    }
    str +=
      "> ER14250(3,6 В)  </label></br><label> <input class='w3-radio' id='XXSS_main_battery_type_CR2'   name='" +
      'this.key' +
      "' type='radio' value='1'";
    if (CACHE_EDIT_R_DEVICE.id !== "-1") {
      for (j in virtualRadio) {
        if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
          if (virtualRadio[j].SS & 0x40) {
            str += " checked ";
          }
        }
      }
    } else {
      str += "";
    }
    str += "> CR2 (3,0 В)</p> </div></div>";


    str += "</tr></table>";



  }
  else if (modelDevice === "13431" || modelDevice === "13438" || modelDevice === "13439") {
    $.show("#modal_r_device_save");
    // Использовать систему рангов            Контролировать датчик вскрытия

    //отключил вкл/выкл checkbox,  система всегда вкл и начинается с 3-го ранга 18.11.22г.
    /* str +=
      '<label>  <input class="w3-radio w3-radio-7620" onchange="setTamperControl(this)" id="XXSS_rank_control" name="XXSS_rank_control" type="checkbox" ';
    if (CACHE_EDIT_R_DEVICE.id !== "-1") {
      for (j in virtualRadio) {
        if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
          if (virtualRadio[j].SS == 5 || virtualRadio[j].SS == 6 || virtualRadio[j].SS == 7) {
            str += " checked ";
          }
        }
      }
    }
    else {
      str += '' //" checked ";
    }
    str += "> Использовать систему рангов </label><br>"; */
    //Ранг
    let selected;
    let disabled = false;
    if (CACHE_EDIT_R_DEVICE.id !== "-1") {
      for (j in virtualRadio) {
        if (virtualRadio[j].numberRadio === CACHE_EDIT_R_DEVICE.id) {
          if (virtualRadio[j].SS == 7/*0x03*/) {
            console.log("popal 7")
            selected = 3;
          } else if (virtualRadio[j].SS == 6 /*0x02*/) {
            console.log("popal 6")
            selected = 2;
          } else if (virtualRadio[j].SS == 5 /*0x01*/) {
            console.log("popal 5")
            selected = 1;
          } else if (virtualRadio[j].SS == 3 /*0x01*/) {
            console.log("popal 3")
            selected = 3;
            disabled = true
          } else if (virtualRadio[j].SS == 2 /*0x01*/) {
            console.log("popal 2")
            selected = 2;
            disabled = true
          } else if (virtualRadio[j].SS == 1 /*0x01*/) {
            console.log("popal 1")
            selected = 1;
            disabled = true
          }
        }
      }
      disabled = false
    }

    else {
      console.log("popal default")
      selected = 3;
      disabled = false
    }
    str += '<label>Ранг</label>'
    str +=
      '<select class="trinket_func_select_rank" float:left id="trinket_click_usr_1"'
    if (disabled) {
      str += "disabled"
    }
    str += '>';

    str += "<option";
    if (selected === 1) {
      str += " selected ";
    }
    str += ' value="1">1</option>';
    str += "<option";
    if (selected === 2) {
      str += " selected ";
    }
    str += ' value="2">2</option>';
    str += "<option";
    if (selected === 3) {
      str += " selected ";
    }
    str += ' value="3">3</option>';
    str += "</select>";
  }


  else if (modelDevice === "16370") {
    $.show("#modal_r_device_save");
    let TRINKED_CONFIG = [];
    let nameKey = "xxnb" + CACHE_EDIT_R_DEVICE.id + "_1"; //Название ключа xxnb
    if (CACHE_EDIT_R_DEVICE.id === "-1") {
      // ПРИ ДОБАВЛЕНИИ НОВОГО БРЕЛКА
      TRINKED_CONFIG.push("0,0,0,0");
      TRINKED_CONFIG.push("0,0,0,0");
      TRINKED_CONFIG.push("0,0,0,0");
      TRINKED_CONFIG.push("0,0,0,0");
    } else {
      // ПРИ ОТКРЫТИИ РАДИОБРЕЛКА
      TRINKED_CONFIG = dataDevice[nameKey].value.split(";");
    }

    str += "<b>Настройка кнопок устройства:</b>";
    str += '<table class="w3-table w3-table-all"><thead>';
    str += "</thead>";

    str += "<tbody>";
    str += "<tr>";
    str += '<td><img class="img_brelok" src="images/6370/6370_1.png"></img></td>';
    str += '<td style="border-right:1px solid #a2a2a2">' + trinketFunction_list(0, TRINKED_CONFIG[0]) + "</td>";
    str += '<td><img class="img_brelok" src="images/6370/6370_2.png"></img></td>';
    str += "<td>" + trinketFunction_list(1, TRINKED_CONFIG[1]) + "</td>";
    str += "</tr>";
    str += '<td><img class="img_brelok" src="images/6370/6370_3.png"></img></td>';
    str += '<td style="border-right:1px solid #a2a2a2">' + trinketFunction_list(2, TRINKED_CONFIG[2]) + "</td>";
    str += '<td><img class="img_brelok" src="images/6370/6370_4.png"></img></td>';
    str += "<td>" + trinketFunction_list(3, TRINKED_CONFIG[3]) + "</td>";
    str += "</tr>";
    str += "</tbody>";
    str += "</table>";
  }
  else if (modelDevice === "17620") {
    setTimeout(() => {
      $.hide("#modal_r_device_save");
      $.show("#modal_r_exe_save");
      $.hide("#modal_integral_save");
    }, 110)

    str += card_Jupiter7620();
  }
  else {
    //str += "Предназначено для обеспечения электропитания внешних устройств (сирен, ламп, приводов)";
  }
  document.getElementById("open_modal_Rdevice_confZone").innerHTML = str; // всталяем настройки зон устройства
  if (modelDevice === "17620") {
    $.hide("#modal_r_device_save");
    if (CACHE_EDIT_R_DEVICE.id !== "-1") {
      if (dataDevice["xxss" + CACHE_EDIT_R_DEVICE.id]) {
        let xxssValue = dataDevice["xxss" + CACHE_EDIT_R_DEVICE.id].value;

        if (xxssValue & 0x1) {
          // Генерация источником питания
          document.getElementById("XXSS_power_24").checked = true;
        } else {
          document.getElementById("XXSS_power_12").checked = true;
        }

        if (xxssValue & 0x2) {
          // Обрыв ичтоника питания
          document.getElementById("XXSS_break_true").checked = true;
        } else {
          document.getElementById("XXSS_break_false").checked = true;
        }

        if (xxssValue & 0x20) {
          // Датчик вскрытия
          if (document.getElementById("XXSS_tamper_control")) {
            document.getElementById("XXSS_tamper_control").checked = true;
          }

        }
      }

      for (var i = 0; i < virtualRadio.length; i++) {
        if (CACHE_EDIT_R_DEVICE.id == virtualRadio[i].numberRadio) {
          for (var k = 0; k < virtualExe.length; k++) {
            if (virtualRadio[i].PV[0] == virtualExe[k].numberExe) {
              if (virtualExe[k].type == "12") {
                // при открытии карточки устройства если режим работы НЕ ИСПОЛЬЗУЕТСЯ то лочим
                document.getElementById("XXSS_power_12").disabled = true;
                document.getElementById("XXSS_power_24").disabled = true;
                document.getElementById("XXSS_break_true").disabled = true;
                document.getElementById("XXSS_break_false").disabled = true;
                document.getElementById("XXSS_tamper_control").disabled = true;
              } else {
                // анлочим
                document.getElementById("XXSS_power_12").disabled = false;
                document.getElementById("XXSS_power_24").disabled = false;
                document.getElementById("XXSS_break_true").disabled = false;
                document.getElementById("XXSS_break_false").disabled = false;
                if (document.getElementById("XXSS_tamper_control")) {
                  document.getElementById("XXSS_tamper_control").disabled = false;
                }

              }
            }
          }
        }
      }
    } else {
      // при добавлении нового устроства блокируем XXSS
      document.getElementById("XXSS_power_12").disabled = true;
      document.getElementById("XXSS_power_24").disabled = true;
      document.getElementById("XXSS_break_true").disabled = true;
      document.getElementById("XXSS_break_false").disabled = true;
      document.getElementById("XXSS_power_12").checked = true;
      document.getElementById("XXSS_break_false").checked = true;
      if (document.getElementById("XXSS_tamper_control")) {
        document.getElementById("XXSS_tamper_control").checked = true;
      }

      //document.getElementById("XXSS_power_24").checked = false;
      //document.getElementById("XXSS_break_true").checked = false;
    }
  }

  let description = R_DEVICE_NAME[modelDevice].description; // Достаем описание устройства
  document.getElementById("modal_r_device_description").innerHTML = description; // вставлем описание устройства

  // if (R_DEVICE_NAME[data.value].zone == "0") {
  //   $.hide("#modal_r_device_zone");
  //   $.hide("#modal_r_device_zone_1");
  //   $.hide("#modal_r_device_zone_2");
  // } else if (R_DEVICE_NAME[data.value].zone == "1") {
  //   $.show("#modal_r_device_zone");
  //   $.show("#modal_r_device_zone_1");
  //   $.hide("#modal_r_device_zone_2");
  // } else if (R_DEVICE_NAME[data.value].zone == "2") {
  //   $.show("#modal_r_device_zone_1");
  //   $.show("#modal_r_device_zone_2");
  //   $.show("#modal_r_device_zone");
  // }
  setTimeout(() => {
    if (checkCall) {

      $.hide("#modal_r_exe_save");
      $.hide("#modal_integral_save");
      $.hide("#modal_r_device_save");
    }
  }, 110)

}


function trinketFunction_list(button, TRINKED_CONFIG) {
  let configArr = TRINKED_CONFIG.split(",");
  let value = { click: +configArr[0], clickUsr: +configArr[1], longClick: +configArr[2], longUsr: +configArr[3] };
  const _minNewVersion = '2.0i'
  let currentVersion = findCurrentVersion()

  // НАЖАТИЕ . . .
  let str = '<label>Нажатие <select class="trinket_func_select" id="trinket_fn_clck_' + button + '">';
  str += "<option";
  if (value.click === 0) {
    str += " selected ";
  }
  str += ' value="0">Не назначена</option>';
  str += "<option";
  if (value.click === 1) {
    str += " selected ";
  }
  str += ' value="1">Взять под охрану</option>';
  str += "<option";
  str += ' value="2"';
  if (value.click === 2) {
    str += " selected ";
  }
  str += ">Снять с охраны</option>";

  str += "<option";
  if (value.click === 3) {
    str += " selected ";
  }
  str += ' value="3">Взятие под принуждением</option>';

  str += "<option";
  if (value.click === 4) {
    str += " selected ";
  }
  str += ' value="4">Снятие под принуждением</option>';

  str += "<option";
  if (value.click === 5) {
    str += " selected ";
  }
  str += ' value="5">Активировать исполнительное устройство</option>';
  str += "<option";
  if (value.click === 6) {
    str += " selected ";
  }
  str += ' value="6">Деактивировать исполнительное устройство</option>';
  str += "<option";
  if (value.click === 7) {
    str += " selected ";
  }
  str += ' value="7">Изменить состояние исполнительного устройства</option>';
  str += "<option";
  if (value.click === 8) {
    str += " selected ";
  }
  str += ' value="8">Патруль</option>';
  str += "<option";
  if (value.click === 9) {
    str += " selected ";
  }
  str += ' value="9">КТС</option>';

  if (verElestaToInt(_minNewVersion) <= verElestaToInt(currentVersion) && currentVersion !== '-1' && currentVersion !== '') {
    str += "<option";
    if (value.click === 10) {
      str += " selected ";
    }
    str += ' value="10">Взять под охрану без задержки</option>';
    str += "<option";
    if (value.click === 11) {
      str += " selected ";
    }
    str += ' value="11">Взятие под принуждением без задержки</option>';
  }

  str += "</select></label>";
  // ...НАЖАТИЕ

  // Пользователь НАЖАТИЯ ...
  str +=
    '</br><label>Номер кода<select class="trinket_func_select" id="trinket_clc_usr_' +
    button +
    '"><option value="0">Не выбран</option>';
  for (i in key_UA_UZ) {
    str += "<option ";
    if (value.clickUsr === +key_UA_UZ[i].number) {
      str += " selected ";
    }
    str += ' value="' + key_UA_UZ[i].number + '">';
    str += key_UA_UZ[i].number;
    str += "</option>";
  }
  str += "</select></label>";
  // ... Пользователь НАЖАТИЯ

  // ДЛИННОЕ НАЖАТИЕ . . .
  str +=
    '<hr><label>Долгое нажатие <select style="width:150px" class="trinket_func_select" id="trinket_fn_long_clck_' +
    button +
    '">';
  str += "<option";
  if (value.longClick === 0) {
    str += " selected ";
  }
  str += ' value="0">Не назначена</option>';
  str += "<option";
  if (value.longClick === 1) {
    str += " selected ";
  }
  str += ' value="1">Взять под охрану</option>';
  str += "<option";
  if (value.longClick === 2) {
    str += " selected ";
  }
  str += ' value="2"';
  if (value.longClick === 3) {
    str += " selected ";
  }
  str += ">Снять с охраны</option>";

  str += "<option";
  if (value.longClick === 3) {
    str += " selected ";
  }
  str += ' value="3">Взятие под принуждением</option>';

  str += "<option";
  if (value.longClick === 4) {
    str += " selected ";
  }
  str += ' value="4">Снятие под принуждением</option>';

  str += "<option";
  if (value.longClick === 5) {
    str += " selected ";
  }
  str += ' value="5">Активировать исполнительное устройство</option>';
  str += "<option";
  if (value.longClick === 6) {
    str += " selected ";
  }
  str += ' value="6">Деактивировать исполнительное устройство</option>';
  str += "<option";
  if (value.longClick === 7) {
    str += " selected ";
  }
  str += ' value="7">Изменить состояние исполнительного устройства</option>';
  str += "<option";
  if (value.longClick === 8) {
    str += " selected ";
  }
  str += ' value="8">Патруль</option>';
  str += "<option";
  if (value.longClick === 9) {
    str += " selected ";
  }
  str += ' value="9">КТС</option>';

  if (verElestaToInt(_minNewVersion) <= verElestaToInt(currentVersion) && currentVersion !== '-1' && currentVersion !== '') {
    str += "<option";
    if (value.longClick === 10) {
      str += " selected ";
    }
    str += ' value="10">Взять под охрану без задержки</option>';
    str += "<option";
    if (value.longClick === 11) {
      str += " selected ";
    }
    str += ' value="11">Взятие под принуждением без задержки</option>';
  }

  str += "</select></label>";
  //  . . . ДЛИННОЕ НАЖАТИЕ
  // Пользователь НАЖАТИЯ ...
  str +=
    '</br><label>Номер кода<select class="trinket_func_select" id="trinket_long_usr_' +
    button +
    '"><option value="0">Не выбран</option>';
  for (i in key_UA_UZ) {
    str += "<option ";
    if (value.longUsr === +key_UA_UZ[i].number) {
      str += " selected ";
    }
    str += ' value="' + key_UA_UZ[i].number + '">';
    str += key_UA_UZ[i].number;
    str += "</option>";
  }
  str += "</select></label>";
  // ... Пользователь НАЖАТИЯ

  return str;
}

function modal_name_Rdevice(data) {
  let str = "";
  str +=
    "<select id='modal_r_device_name' style='height:33px; width:100%;' onchange='set_r_device_name(this.value,undefined,undefined,undefined)'>";
  for (i in R_DEVICE_NAME) {
    if (data === null) {
      str += '<option value="' + i + '" ';
      if (data == i) {
        str += " selected ";
      }
      str += " >";
      str += R_DEVICE_NAME[i].name;
      str += "</option>";
    } else {
      if (+R_DEVICE_NAME[i].zone >= 0) {
        str += '<option value="' + i + '" ';
        if (data == i) {
          str += " selected ";
        }
        str += " >";
        str += R_DEVICE_NAME[i].name;
        str += "</option>";
      }
    }
  }

  str += "</select>";
  return str;
}

function delaySection_DISABLED(typeLW, param) {
  // В случае если задержки нет возвращает true
  let type = typeLW + "_" + param;
  let delay = {};
  switch (type) {
    case "5_0":
      delay = { yes: true, time: "" };
      return delay;
      break;
    case "5_0D":
      delay = { yes: false, time: 90 };
      return delay;
      break;
    case "5_4":
      delay = { yes: false, time: 90 };
      return delay;
      break;
    case "5_2":
      delay = { yes: true, time: "" };
      return delay;
      break;
    case "5_8":
      delay = { yes: true, time: "" };
      return delay;
      break;
    case "5_10":
      delay = { yes: true, time: "" };
      return delay;
      break;
    case "5_1":
      delay = { yes: true, time: "" };
      return delay;
      break;

    case "noused":
      delay = { yes: true, time: "" };
      return delay;
    //break;
    default:
      delay = { yes: true, time: "" };
      //console.log("unknown type zone");
      return delay;

  }
}

function recoverTypeZone(elem) {
  if (elem.id.indexOf("recoveryLw_Tabl") != -1) {
    // после проверки того что произошел вызов из таблицы разделов
    modal_r_device_setTypeZone(elem.parentElement.parentElement.getElementsByTagName("select")[0]); //Вытаскиваем Тип зоны и отправляем её на сохранение
  }
}

function modal_r_device_setTypeZone(data) {

  let idDelay,
    idDelayExit,
    idRecover,
    keyLW,
    adresZone,
    who = "";
  let idRecover_Val = null;
  let idRecoverModal = ''
  if (data.id.indexOf("modal_r_device_zone_type_S_") != -1) {
    who = "table";
    keyLW = "lw" + data.id.slice(27); // номер ключа
    idDelay = "delay_S_" + data.id.slice(27); // ID задержки
    idDelayExit = "delay_S_EXIT_" + data.id.slice(27); // ID задержки на выход
    idRecover = "recoveryLw_Tabl_" + data.id.slice(27);
    //idRecoverModal = "recoveryLw_Cart_" + data.id.slice(27) // ID восстановление

  } else if (data.id.indexOf("modal_r_device_zone_type_E_") != -1) {
    who = "ext";
    keyLW = "lw" + data.id.slice(27); // номер ключа
    idDelay = "delayZoneExt_" + data.id.slice(27); // ID задержки
    idDelayExit = "delayZoneExt_EXIT_" + data.id.slice(27);
    idRecover = "recoveryLw_Tabl_" + data.id.slice(27);
    idRecoverModal = "recoveryLw_Cart_" + data.id.slice(27) // ID восстановление
    let id = data.id.slice(27)
    let idZone = "adrZoneExt_" + id

    // if (document.getElementById(idZone).value == '0') {
    //   document.getElementById(idZone).value = pickUpYzLw("lw", "2")[0]
    // }
    if (data.value === "noused") {
      // localStorage.setItem('tmp', document.getElementById(idZone).value)

      document.getElementById(idZone) ? (document.getElementById(idZone).value = 0) : "";

      // } else {
      //   if (document.getElementById(idZone).value == 0) {
      //     document.getElementById(idZone).value = pickUpYzLw("lw", "2")[2]
      //   }
    } else {
      if (document.getElementById(idZone).value == 0) {
        document.getElementById(idZone) ? (document.getElementById(idZone).value = pickUpYzLw("lw", "2")[id]) : "";
      }
    }
    // else {
    //   let loadtmp = localStorage.getItem('tmp')

    //   document.getElementById(idZone)
    //     ? (document.getElementById(idZone).value = loadtmp)
    //     : "";
    // }
  }
  else {
    who = "card";
    idDelay = data.name;
    idDelayExit = data.name.replace("delay_", "delay_EXIT_");
    adresZone = "adresZone_" + data.name.slice(26)
    //idRecover = "recoveryLw_Tabl_" + document.getElementById(adresZone).defaultValue;
    idRecoverModal = "recoveryLw_Cart_" + data.id.slice(25)


    if (data.value === "noused") {
      //localStorage.setItem('tmp', document.getElementById("adresZone_1").value)
      // localStorage.setItem('tmp2', document.getElementById("adresZone_2").value)

      if (data.id == "modal_r_device_zone_type_1") {
        document.getElementById("adresZone_1") ? (document.getElementById("adresZone_1").value = 0) : "";
      } else if (data.id == "modal_r_device_zone_type_2") {
        document.getElementById("adresZone_2") ? (document.getElementById("adresZone_2").value = 0) : "";
      } else {
        console.error(data.id);
      }
    } else {
      if (data.id == "modal_r_device_zone_type_1" && document.getElementById("adresZone_1").value == 0) {
        //let loadtmp = localStorage.getItem('tmp')

        document.getElementById("adresZone_1")
          ? (document.getElementById("adresZone_1").value = pickUpYzLw("lw", "2")[0])
          : "";
      } else if (data.id == "modal_r_device_zone_type_2" && document.getElementById("adresZone_2").value == 0) {

        //let loadtmp2 = localStorage.getItem('tmp2')
        document.getElementById("adresZone_2")
          ? (document.getElementById("adresZone_2").value = pickUpYzLw("lw", "2")[1])
          : "";
      } /* else {
        console.error(data.id);
      } */
    }
  }
  if (data.value !== '2_2' || data.value !== '2_5' || data.value !== '2_8') {
    if (idRecoverModal) {
      document.getElementById(idRecoverModal) ? document.getElementById(idRecoverModal).disabled = true : null
    }
  }
  switch (data.value) {
    case "5_0":
      if (document.getElementById(idDelay)) {
        idRecover_Val = "0";
        document.getElementById(idDelay).value = "";
        document.getElementById(idDelayExit).value = "";
        document.getElementById(idDelay).disabled = true;
        document.getElementById(idDelayExit).disabled = true;
        //document.querySelectorAll('#' + idRecover).forEach((item) => item ? item.disabled = true : null);

      }
      break;
    case "5_0D":
      if (document.getElementById(idDelay)) {
        idRecover_Val = "0";
        document.getElementById(idDelay).value = 90;
        document.getElementById(idDelayExit).value = 90;
        document.getElementById(idDelay).disabled = false;
        document.getElementById(idDelayExit).disabled = false;
        //document.querySelectorAll('#' + idRecover).forEach((item) => item ? item.disabled = true : null);

      }
      break;

    case "5_4":
      if (document.getElementById(idDelay)) {
        idRecover_Val = "4";
        document.getElementById(idDelay).value = 90;
        document.getElementById(idDelayExit).value = 90;
        document.getElementById(idDelay).disabled = false;
        document.getElementById(idDelayExit).disabled = false;
        //document.querySelectorAll('#' + idRecover).forEach((item) => item ? item.disabled = true : null);

      }
      break;
    case "5_2":
      if (document.getElementById(idDelay)) {
        idRecover_Val = "2";
        document.getElementById(idDelay).value = "";
        document.getElementById(idDelayExit).value = "";
        document.getElementById(idDelay).disabled = true;
        document.getElementById(idDelayExit).disabled = true;
        // document.querySelectorAll('#' + idRecover).forEach((item) => item ? item.disabled = true : null);
      }
      break;
    case "5_8":
      if (document.getElementById(idDelay)) {
        idRecover_Val = "8";
        document.getElementById(idDelay).value = "";
        document.getElementById(idDelayExit).value = "";
        document.getElementById(idDelay).disabled = true;
        document.getElementById(idDelayExit).disabled = true;
        // document.querySelectorAll('#' + idRecover).forEach((item) => item ? item.disabled = true : null);
      }
      break;
    case "5_10":
      if (document.getElementById(idDelay)) {
        idRecover_Val = "10";
        document.getElementById(idDelay).value = "";
        document.getElementById(idDelayExit).value = "";
        document.getElementById(idDelay).disabled = true;
        document.getElementById(idDelayExit).disabled = true;
        // document.querySelectorAll('#' + idRecover).forEach((item) => item ? item.disabled = true : null);
      }
      break;
    case "5_1":
      if (document.getElementById(idDelay)) {
        idRecover_Val = "1";
        document.getElementById(idDelay).value = "";
        document.getElementById(idDelayExit).value = "";
        document.getElementById(idDelay).disabled = true;
        document.getElementById(idDelayExit).disabled = true;
        // document.querySelectorAll('#' + idRecover).forEach((item) => item ? item.disabled = true : null);
      }
      break;
    case "5_32":
      if (document.getElementById(idDelay)) {
        idRecover_Val = "32";
        document.getElementById(idDelay).value = "";
        document.getElementById(idDelayExit).value = "";
        document.getElementById(idDelay).disabled = true;
        document.getElementById(idDelayExit).disabled = true;
        // document.querySelectorAll('#' + idRecover).forEach((item) => item ? item.disabled = true : null);
      }
      break;
    case "4_2":
      if (document.getElementById(idDelay)) {
        document.getElementById(idDelay).value = "";
        document.getElementById(idDelayExit).value = "";
        document.getElementById(idDelay).disabled = true;
        document.getElementById(idDelayExit).disabled = true;
        idRecover_Val = "2";
        // document.querySelectorAll('#' + idRecover).forEach((item) => item ? item.disabled = true : null);
      }
      break;
    case "2_2":
      if (document.getElementById(idDelay)) {
        document.getElementById(idDelay).value = "";
        document.getElementById(idDelayExit).value = "";
        document.getElementById(idDelay).disabled = true;
        document.getElementById(idDelayExit).disabled = true;
        document.getElementById(idRecoverModal) && document.getElementById(idRecoverModal).disabled ? document.getElementById(idRecoverModal).disabled = false : null
        // document.querySelectorAll('#' + idRecover).forEach((item) => item ? item.disabled = false : null);
        idRecover_Val = (function () {
          if (document.getElementById(idRecover) && document.getElementById(idRecover).checked) { //?
            return "3";
          } else {
            return "2";
          }
        })();
      }
      break;
    case "2_5":
      if (document.getElementById(idDelay)) {
        document.getElementById(idDelay).value = "";
        document.getElementById(idDelayExit).value = "";
        document.getElementById(idDelay).disabled = true;
        document.getElementById(idDelayExit).disabled = true;
        document.getElementById(idRecoverModal) && document.getElementById(idRecoverModal).disabled ? document.getElementById(idRecoverModal).disabled = false : null
        //document.querySelectorAll('#' + idRecover).forEach((item) => item ? item.disabled = false : null);
        idRecover_Val = (function () {
          if (document.getElementById(idRecover) && document.getElementById(idRecover).checked) { //?
            return "5";
          } else {
            return "4";
          }
        })();
      }
      break;

    case "2_8":
      if (document.getElementById(idDelay)) {
        document.getElementById(idDelay).value = "";
        document.getElementById(idDelayExit).value = "";
        document.getElementById(idDelay).disabled = true;
        document.getElementById(idDelayExit).disabled = true;
        document.getElementById(idRecoverModal) && document.getElementById(idRecoverModal).disabled ? document.getElementById(idRecoverModal).disabled = false : null
        //document.querySelectorAll('#' + idRecover).forEach((item) => item ? item.disabled = false : null);
        idRecover_Val = (function () {
          if (document.getElementById(idRecover).checked) { //
            return "9";
          } else {
            return "8";
          }
        })();
      }
      break;

    case "noused":
      if (document.getElementById(idDelay)) {
        document.getElementById(idDelay).value = "";
        document.getElementById(idDelayExit).value = "";
        document.getElementById(idDelay).disabled = true;
        document.getElementById(idDelayExit).disabled = true;
        // document.querySelectorAll('#' + idRecover).forEach((item) => item ? item.disabled = true : null);
        if (idRecoverModal) {
          document.getElementById(idRecoverModal) ? document.getElementById(idRecoverModal).disabled = true : null
        }


      }
      break;
    default:
      if (document.getElementById(idDelay)) {
        document.getElementById(idDelay).value = "";
        document.getElementById(idDelayExit).value = "";
        document.getElementById(idDelay).disabled = true;
        document.getElementById(idDelayExit).disabled = true;
      }
      console.log("Type zone " + data.value + " not identified");
  }

  if (who === "table") {
    // Сохранение типа зоны в таблице разделы
    let typeLW = "";
    if (data.value !== null) {
      typeLW = data.value.replace("D", ""); // Убираем из Охр. с фикс. зад. D
      typeLW = data.value.replace("noused", "1"); // Заменяем неиспользуемое на 0
    }

    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key === keyLW) {
        if (keyLW !== "lw") {
          //проверяем что ключ зоны корректен
          // console.log('idRecover_Val', idRecover_Val);
          deviceJSON.config[i].subvalues[0].value = typeLW.charAt(0);
          let parametrLW = null;
          if (typeLW === "0") {
            if (idRecover_Val !== null) {
              parametrLW = idRecover_Val;
            } else {
              parametrLW = "0";
            }
            deviceJSON.config[i].subvalues[1].value = parametrLW;
            // deviceJSON.config[i].subvalues[1].value = "0"; Вернуть если план с рекавери провалился
            deviceJSON.config[i].subvalues[2].value = (function () {
              if (document.getElementById(idDelay).value === "") {
                //return "0";  До введения задержки на выход
                return "0,0";
              } else {
                return document.getElementById(idDelay).value + "," + document.getElementById(idDelayExit).value;
              }
            })();
            // если зона не Используется
          } else {
            //                        deviceJSON.config[i].subvalues[1].value = typeLW.slice(2);
            let parametrLW = null;

            if (idRecover_Val !== null) {
              parametrLW = idRecover_Val;
            } else {
              parametrLW = "0";
            }

            deviceJSON.config[i].subvalues[1].value = parametrLW;
            deviceJSON.config[i].subvalues[2].value = (function () {
              if (document.getElementById(idDelay).value === "") {
                //return "0"; До введения задаржки на выход
                return "0,0";
              } else {
                return document.getElementById(idDelay).value + "," + document.getElementById(idDelayExit).value;
              }
            })();
          }
        }
        saveConfig(deviceJSON.config[i]);
        parseAppKey("update_notabs");
      }
    }
  }
}

function checkRecoverZone(type, param) {
  type = +type;
  param = +param;
  if (type === 2 && param === 3) {
    return true;
  } else if (type === 2 && param === 5) {
    return true;
  } else if (type === 2 && param === 9) {
    return true;
  } else {
    return false;
  }
}

function swapSectionDelay(data, who) {
  // Сохранение задержки на вход/выход

  data.value = data.value.replace(/\D/g, '')
  if ((data.value < 1) & (data.value !== "")) {
    data.value = 1
    data.style.color = 'red';
    setTimeout(() => data.style.color = 'black', 1000)
    return
  } else if ((data.value > 254) & (data.value !== "")) {
    data.value = 255
    data.style.color = 'red';
    setTimeout(() => data.style.color = 'black', 1000)

    return
  }
  let keyLw = "";
  if (who == "entry") {
    keyLw = "lw" + data.id.slice(8);
  } else {
    keyLw = "lw" + data.id.slice(13);
  }
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key === keyLw) {
      switch (who) {
        case "entry":
          if (deviceJSON.config[i].subvalues[2].value.indexOf(",") != -1) {
            let oldValue = deviceJSON.config[i].subvalues[2].value.split(",");
            let newValue = data.value + "," + oldValue[1];
            deviceJSON.config[i].subvalues[2].value = newValue;
            saveConfig(deviceJSON.config[i]);
            parseAppKey("update_notabs");
          } else {
            console.log("не поддерживается прошивка на выход");
          }

          break;
        case "exit":
          if (deviceJSON.config[i].subvalues[2].value.indexOf(",") != -1) {
            let oldValue = deviceJSON.config[i].subvalues[2].value.split(",");
            let newValue = oldValue[0] + "," + data.value;
            deviceJSON.config[i].subvalues[2].value = newValue;
            saveConfig(deviceJSON.config[i]);
            parseAppKey("update_notabs");
          } else {
            console.log("не поддерживается прошивка на выход");
          }

          break;

        default:
          break;
      }
    }
  }
}

function section_list_add_zone(numberSections) {
  console.log(numberSections);
}

function section_create_list(data) {
  let secNumber = data.subvalues[0].value;
  let sensorNumber = data.key.slice(2);

  if (data.subvalues[0].value != "") {
    let nameLw = "lw" + sensorNumber + "_0";
    let type = dataDevice[nameLw].value;
    list_section[secNumber] = { free: false, type: type, sensors: [] };
    list_section[secNumber].sensors.push(sensorNumber);
  }
}

function program_mod_xxpg() {
  document.getElementById("modal_depassivation").style.display = "none";

  
  $.hide("#modal_no_connect_XXAD");
  spiner_start();
  initSearchRadio = adres = idProgrammDeviceRKPS; // Включен поиск РК датчика
  getQuerty(vhost + CMD_SEARCH_RADIO + adres);

  setTimeout("searchKey_OC()", 29000);
  setTimeout("spiner_stop()", 31000);
  setTimeout("initSearchRadio_stop()", 35000);
  modal_progres_detected();
  setTimeout("parseAppKey('update_notabs')", 36000)
}

let idProgrammDeviceRKPS; // НОМЕР ДАТЧИКА ДЛЯ ПРОГРАММИРОВАНИЯ
function search_mod_xxpg(data) {
  idProgrammDeviceRKPS = data;

  let ERROR_KEY = false;
  if (dataDevice["xxcc_0"]) {
    if (dataDevice["xxcc_0"].value < 3 || dataDevice["xxcc_1"].value == 0) {
      ERROR_KEY = true;
      document.getElementById("modal_conf_toDev").style.display = "none";
      $.modal("#modal_error_core");
      document.getElementById("modal_error_text").innerHTML = ERROR_DSC_XXCC;
      let elmMenu = document.getElementsByClassName("tab_r_device");
      for (var i = 0; i < elmMenu.length; i++) {
        elmMenu[i].click();
      }
    }
  }

  if (!ERROR_KEY) {
    let adres = idProgrammDeviceRKPS;
    let lock = false;
    KEYFORSAVE.forEach(function (item, i, arr) {
      if (item.key == "xxad" + adres) {
        lock = true;
      }
    });

    // проверка на наличие батарейки

    if (!lock) {
      for (var i = 0; i < virtualRadio.length; i++) {
        if (virtualRadio[i].numberRadio == adres) {
          if (virtualRadio[i].name.indexOf("343") != -1 || virtualRadio[i].name.indexOf("6370") != -1) {
            program_mod_xxpg();
          } else {
            $.modal("#modal_depassivation");
          }
          break;
        }
      }
    } else {
      document.getElementById("modal_no_connect_XXAD_number").innerHTML = adres;
      $.modal("#modal_no_connect_XXAD");
    }
  }
}

function initSearchRadio_stop() {
  initSearchRadio = false; // Выключили режим поиска РК датчика
  searchKey_OC();
  //parseAppKey('update_notabs')
}

function modal_progres_detected(time) {
  if (time < 100 || !time) {
    if (!time) {
      time = 0;
    } else {
    }
    time = time + 10;
    initSearchRadio ? setTimeout("modal_progres_detected(" + time + ")", 3000) : "";
    initSearchRadio ? $.modal("#modal_progres_detected") : "";
    document.getElementById("modal_progres_detected_text_cancel").innerHTML = "Поиск радиоустройства . . . ";
    document.getElementById("continBarDetected").style.width = time + "%";
    document.getElementById("continBarProcDetected").innerHTML = time + "%";
    if (!initSearchRadio) {

      $.hide("#modal_progres_detected");

    }
  }
  else if (time >= 100) {
    $.hide("#modal_progres_detected");
  }

}

// function checkCorrectZon(data) {
//   if (data.value > 192) {
//     data.value = 192;
//   }
//   if (data.value < 1) {
//     data.value = 1;
//   }

//   if (data.id == "adresZone_1") {
//     let numberZone1 = document.getElementById("adresZone_2") ? document.getElementById("adresZone_1").value : null;
//     let numberZone2 = document.getElementById("adresZone_2") ? document.getElementById("adresZone_2").value : null;
//     if (numberZone1 == numberZone2) {
//       data.value = pickUpYzLw("lw", "2")[0];
//     }
//   }

//   if (data.id == "adresZone_2") {
//     let numberZone1 = document.getElementById("adresZone_1") ? document.getElementById("adresZone_1").value : null;
//     let numberZone2 = document.getElementById("adresZone_1") ? document.getElementById("adresZone_2").value : null;
//     if (numberZone1 == numberZone2) {
//       data.value = pickUpYzLw("lw", "2")[1];
//     }
//   }
// }

function swapSectionNumber(data) {

  let trElem = data.parentElement.parentElement;
  let idElem = data.id;
  //trElem.style.background = 'red';
  trElem.classList = "focusEditsect";
  let keyYz = "yz" + data.id.slice(7);
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key === keyYz) {
      deviceJSON.config[i].subvalues[0].value = data.value; // номер первого зоны
      saveConfig(deviceJSON.config[i]);
    }
  }
  setTimeout("focusEditSections(" + idElem + ")", 1000);
}

function focusEditSections(id) {
  parseAppKey("update_notabs");
  document.getElementById(id.id).focus();
  document.getElementById(id.id).parentElement.parentElement.classList = "focusEditsect";
  setTimeout('document.getElementById("' + id.id + '").parentElement.parentElement.classList = "";', 1000);
}

function sectionZoneList(numberZone, value) {
  let str = "";
  str += '<select onchange="swapSectionNumber(this)" id="sect_S_' + numberZone + '" name="' + numberZone + '" >';
  // str += '<option value="" '
  // if (value === '') {
  //   str += ' selected ';
  // }
  // str += '> - </option>';

  for (var i = 1; i <= DEVICEINFO[DEVICEMODEL].sections; i++) {
    str += "<option ";
    if (+value === i) {
      str += " selected ";
    }
    str += ">";
    str += i + "</option>";
  }
  str += "</select>";

  return str;
}

function typeZoneList(numberZone, type, param) {
  let str = "";
  let typeName = {
    1: "Охранный с задержкой",
    2: "Охранный без задержки",
    3: "Охранный без задержки с контролем взлома извещателей",
    4: "Охранный проходной",
    5: "Охранный проходной с контролем взлома",
    6: "Охранный КТС",
    7: "Шлейф исключен",
    8: "Пожарный тип 1",
    9: "Пожарный тип 2",
    10: "Пожарный тип 3",
    11: "Пожарный тип 1 с контр. сбросом",
    12: "Пожарный тип 2 с контр. сбросом",
    14: "Патруль",
    15: "Управление разделом",
    16: "Охранный с фиксированной задержкой",
    17: "Газ",
    18: "Вода",
  };
  str += '<select name="' + numberZone + '" >';
  str += '<option value="0" ';
  if (param === "" && param !== "0") {
    str += " selected ";
  }
  str += "> - </option>";

  for (var i = 1; i <= 18; i++) {
    str += "<option ";
    if (+param === i) {
      str += " selected ";
    }
    str += ">";
    str += typeName[i] + "</option>";
  }
  str += "</select>";

  return str;
}

function saveModalRadio() {

   if (CACHE_EDIT_R_DEVICE.id === "thisDevice") {
    saveModalIntegrationZone();
  } else {
    saveModalRadio_NEW();  
  }
}


function closeModalR_dev() {
  // Закрытие карточки радиоканального прибора
  document.getElementById("modal_r_device").style.display = "none";
  // Чистим кэш
  CACHE_EDIT_R_DEVICE.id = null;
  CACHE_EDIT_R_DEVICE.numberSection = null;
  CACHE_EDIT_R_DEVICE.serial = null;
  //возвращаем кнопку сохранить в изначальное состояние
  document.getElementById('modal_r_device_save').innerHTML = `&#10004; Сохранить`
  document.getElementById('modal_r_exe_save').innerHTML = `&#10004; Сохранить`
  document.getElementById('modal_r_exe_save').setAttribute('onclick', 'saveModalRadioEXT_NEW()')
  document.getElementById('modal_r_device_save').setAttribute('onclick', 'saveModalRadio()')
  document.getElementById('modal_r_exe_save').disabled = ''
  document.getElementById('modal_r_device_save').disabled = ''
  document.getElementById('errorAddDevice').innerHTML = ''
  //rollUp()

}
function closeModalintegral() {

  // Закрытие карточки радиоканального прибора
  document.getElementById("modal_r_device").style.display = "none";
  parseAppKey("update_notabs");
  // Чистим кэш
  CACHE_EDIT_R_DEVICE.id = null;
  CACHE_EDIT_R_DEVICE.numberSection = null;
  CACHE_EDIT_R_DEVICE.serial = null;
}

function saveModalRadio_EDIT() { }
function saveModalRadio_REMOVE_All() {

  for (let n = 0; n < virtualRadio.length; n++) {
    if (virtualRadio[n].name !== "17620") {
      let keyXXAD = "xxad" + virtualRadio[n].numberRadio;
      let keyXXDR = "xxdr" + virtualRadio[n].numberRadio;
      let keyLw1 = "lw" + virtualRadio[n].zone_1; // Ключ номера зоны 1
      let keyLw2 = "lw" + virtualRadio[n].zone_2; // Ключ номера зоны 2
      let keyYz1 = "yz" + virtualRadio[n].zone_1; // Ключ номера раздела 1
      let keyYz2 = "yz" + virtualRadio[n].zone_2; // Ключ номера раздела 2
      let keyXXKB = "xxkb" + virtualRadio[n].numberRadio; // Ключ номера раздела 2

      if (!false) {
        for (i in deviceJSON.config) {
          if (deviceJSON.config[i].key === keyXXAD) {
            // XXAD
            deviceJSON.config[i].subvalues[0].value = "0"; // Тип устройства согласно ЕСОП
            deviceJSON.config[i].subvalues[1].value = "0"; // Модель устройства
            deviceJSON.config[i].subvalues[2].value = "0"; // Serial устройства
            saveConfigAll(deviceJSON.config[i]);
          }

          if (deviceJSON.config[i].key === keyXXDR) {
            // XXDR
            deviceJSON.config[i].subvalues[0].value = "0"; // Тип устройства согласно ЕСОП
            deviceJSON.config[i].subvalues[1].value = "0"; // Модель устройства
            saveConfigAll(deviceJSON.config[i]);
          }
          //LW
          if (deviceJSON.config[i].key === keyLw1 || deviceJSON.config[i].key === keyLw2) {
            deviceJSON.config[i].subvalues[0].value = "0"; // Тип устройства согласно ЕСОП
            deviceJSON.config[i].subvalues[1].value = "0"; // Модель устройства
            deviceJSON.config[i].subvalues[2].value = "0"; // Модель устройства
            saveConfigAll(deviceJSON.config[i]);
          }
          //YZ
          if (deviceJSON.config[i].key === keyYz1 || deviceJSON.config[i].key === keyYz2) {
            deviceJSON.config[i].subvalues[0].value = "0";
            saveConfigAll(deviceJSON.config[i]);
          }
          if (deviceJSON.config[i].key === keyXXKB) {
            deviceJSON.config[i].subvalues[0].value = "0";
            saveConfigAll(deviceJSON.config[i]);
          }

        }
      }

    }
    else {

      // УДАЛЕНИЕ РАДИКАНАЛЬНЫХ УСТРОЙСТВ С ВЫХОДАМИ УПРАВЛЕНИЯ
      let CARD_DEVICE = {
        id: "xxad" + virtualRadio[n].numberRadio, //Номер XXAD
        xxIndex: virtualRadio[n].numberRadio,
        typeDevice: null,
        numberPV: null,
        numberRV: null,
        typeActionPV: null,
        typeActionRV: null,
        delayPV: null,
        delayRV: null,
        triggerPV: [],
        triggerRV: [],
        sectionRV: [],
        sectionPV: [],
        typeESOP: null,
        PARAM_XXSS: null,
        PARAM_XXNB: null,
      };

      //let modelRemoveDevice;
      for (var i = 0; i < virtualRadio.length; i++) {
        if (virtualRadio[n].numberRadio === virtualRadio[i].numberRadio) {
          CARD_DEVICE.numberPV = virtualRadio[i].PV[0];
          CARD_DEVICE.numberRV = virtualRadio[i].RV[0];
        }
      }
 

      console.log(CARD_DEVICE); // ▼ ТИП УСТРОЙСТВА СОГЛАСНО ЕСОП ▼

      if (virtualRadio[n].name === "17620") {
        CARD_DEVICE.typeESOP = "70";
        // так же для 3438, 3439 ЕСОП - 91
      } else {
        CARD_DEVICE.typeESOP = 0;
      }

      
      // СОХРАНЯЕМ
      for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key == CARD_DEVICE.id) {
          deviceJSON.config[i].subvalues[0].value = "0";
          deviceJSON.config[i].subvalues[1].value = "0";
          deviceJSON.config[i].subvalues[2].value = "0";
          deviceJSON.config[i].subvalues[3].value = "0";
          saveConfigAll(deviceJSON.config[i]);
        } else if (deviceJSON.config[i].key == CARD_DEVICE.xxdr) {
          deviceJSON.config[i].subvalues[0].value = "0";
          deviceJSON.config[i].subvalues[1].value = "0";
          saveConfigAll(deviceJSON.config[i]);
        } else if (deviceJSON.config[i].key === "xxnu" + CARD_DEVICE.xxIndex) {
          deviceJSON.config[i].subvalues[0].value = "0";
          deviceJSON.config[i].subvalues[1].value = "0";
          saveConfigAll(deviceJSON.config[i]);
        } else if (deviceJSON.config[i].key === "xxnr" + CARD_DEVICE.xxIndex) {
          deviceJSON.config[i].subvalues[0].value = "0";
          deviceJSON.config[i].subvalues[1].value = "0";
          saveConfigAll(deviceJSON.config[i]);
        } else if (deviceJSON.config[i].key === "oo" + CARD_DEVICE.numberPV) {
          // ПВ режим/время
          deviceJSON.config[i].subvalues[0].value = "0";
          deviceJSON.config[i].subvalues[1].value = "0";
          saveConfigAll(deviceJSON.config[i]);
        } else if (deviceJSON.config[i].key === "oo" + CARD_DEVICE.numberRV) {
          // РВ режим/время
          deviceJSON.config[i].subvalues[0].value = "0";
          deviceJSON.config[i].subvalues[1].value = "0";
          saveConfigAll(deviceJSON.config[i]);
        } else if (deviceJSON.config[i].key === "oq" + CARD_DEVICE.numberPV) {
          // РВ режим/время
          deviceJSON.config[i].subvalues[0].value = "0";
          saveConfigAll(deviceJSON.config[i]);
        } else if (deviceJSON.config[i].key === "oq" + CARD_DEVICE.numberRV) {
          // РВ режим/время
          deviceJSON.config[i].subvalues[0].value = "0";
          saveConfigAll(deviceJSON.config[i]);
        }
      }

      for (var k = 0; k < CARD_DEVICE.triggerPV.length; k++) {
        // Сохраняем сработки ПВ
        for (i in deviceJSON.config) {
          if (deviceJSON.config[i].key == CARD_DEVICE.triggerPV[k].name) {
            deviceJSON.config[i].subvalues[0].value = "0";
            saveConfigAll(deviceJSON.config[i]);
            break;
          }
        }
      }

      for (var k = 0; k < CARD_DEVICE.triggerRV.length; k++) {
        // Сохраняем сработки РВ
        for (i in deviceJSON.config) {
          if (deviceJSON.config[i].key == CARD_DEVICE.triggerRV[k].name) {
            deviceJSON.config[i].subvalues[0].value = "1";
            saveConfigAll(deviceJSON.config[i]);
            break;
          }
        }
      }
    }
  }
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key == "xxmn") {
      deviceJSON.config[i].subvalues[0].value = "0";  
      saveConfigAll(deviceJSON.config[i]);
    }
    if (deviceJSON.config[i].key == "xxcc") {
      deviceJSON.config[i].subvalues[0].value = "0";  
      deviceJSON.config[i].subvalues[1].value = "0";  
      saveConfigAll(deviceJSON.config[i]);
    }
  }
  
  liveSaveInterface();
  parseAppKey("update_notabs");
  closeModalR_dev(); // Чистим кэш и закрывем карточку
}
function saveModalRadio_REMOVE() {
  let CARD_DEVICE = {
    id: null, //Номер XXAD
    typeDevice: null, //Тип устройства
    numberZone_1: null, //Номер зоны 1
    numberZone_2: null, //Номер зоны 2
    typeZone_1: null, //Тип зоны 1
    typeZone_2: null, //Тип зоны 2
    delayZone_1: null, // Задержка зоны 1
    delayZone_2: null, // Задержка зоны 2
    sectionZone_1: null, // Раздел зоны 1
    sectionZone_2: null, // Раздел зоны 2
    typeESOP: null,
  };

  // ▼ Тип устройства ▼
  CARD_DEVICE.typeDevice = document.getElementById("modal_r_device_name").value;
  if (CARD_DEVICE.typeDevice !== "17620") {
    // УДАЛЕНИЕ РАДИКАНАЛЬНЫХ УСТРОЙСТВ С ЗОНАМИ
    // ▼ Номер зоны 1 ▼
    CARD_DEVICE.numberZone_1 = document.getElementById("adresZone_1")
      ? document.getElementById("adresZone_1").value
      : null;
    // ▼ Номер зоны 2 ▼
    CARD_DEVICE.numberZone_2 = document.getElementById("adresZone_2")
      ? document.getElementById("adresZone_2").value
      : null;
    // ▼ Тип зоны 1 ▼
    CARD_DEVICE.typeZone_1 = document.getElementById("modal_r_device_zone_type_1")
      ? document.getElementById("modal_r_device_zone_type_1").value
      : null;
    // ▼ Тип зоны 2 ▼
    CARD_DEVICE.typeZone_2 = document.getElementById("modal_r_device_zone_type_2")
      ? document.getElementById("modal_r_device_zone_type_2").value
      : null;
    // ▼ Задержка зоны 1 ▼
    CARD_DEVICE.delayZone_1 = document.getElementById("modal_r_device_zone_delay_1")
      ? document.getElementById("modal_r_device_zone_delay_1").value
      : null;
    // ▼ Задержка зоны 2 ▼
    CARD_DEVICE.delayZone_2 = document.getElementById("modal_r_device_zone_delay_2")
      ? document.getElementById("modal_r_device_zone_delay_2").value
      : null;
    // ▼ Раздел зоны 1 ▼
    CARD_DEVICE.sectionZone_1 = document.getElementById("nomberZone_Section_1")
      ? document.getElementById("nomberZone_Section_1").value
      : null;
    // ▼ Раздел зоны 2 ▼
    CARD_DEVICE.sectionZone_2 = document.getElementById("nomberZone_Section_2")
      ? document.getElementById("nomberZone_Section_2").value
      : null;

    let keyXXAD = "xxad" + CACHE_EDIT_R_DEVICE.id;
    let keyXXDR = "xxdr" + CACHE_EDIT_R_DEVICE.id;
    let keyLw1 = "lw" + CARD_DEVICE.numberZone_1; // Ключ номера зоны 1
    let keyLw2 = "lw" + CARD_DEVICE.numberZone_2; // Ключ номера зоны 2
    let keyYz1 = "yz" + CARD_DEVICE.numberZone_1; // Ключ номера раздела 1
    let keyYz2 = "yz" + CARD_DEVICE.numberZone_2; // Ключ номера раздела 2
    let keyXXKB = "xxkb" + CACHE_EDIT_R_DEVICE.id; // Ключ номера раздела 2

    if (!false) {
      for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key === keyXXAD) {
          // XXAD
          deviceJSON.config[i].subvalues[0].value = "0"; // Тип устройства согласно ЕСОП
          deviceJSON.config[i].subvalues[1].value = "0"; // Модель устройства
          deviceJSON.config[i].subvalues[2].value = "0"; // Serial устройства
          saveConfig(deviceJSON.config[i]);
        }

        if (deviceJSON.config[i].key === keyXXDR) {
          // XXDR
          deviceJSON.config[i].subvalues[0].value = "0"; // Тип устройства согласно ЕСОП
          deviceJSON.config[i].subvalues[1].value = "0"; // Модель устройства
          saveConfig(deviceJSON.config[i]);
        }
        //LW
        if (deviceJSON.config[i].key === keyLw1 || deviceJSON.config[i].key === keyLw2) {
          deviceJSON.config[i].subvalues[0].value = "0"; // Тип устройства согласно ЕСОП
          deviceJSON.config[i].subvalues[1].value = "0"; // Модель устройства
          deviceJSON.config[i].subvalues[2].value = "0"; // Модель устройства
          saveConfig(deviceJSON.config[i]);
        }
        //YZ
        if (deviceJSON.config[i].key === keyYz1 || deviceJSON.config[i].key === keyYz2) {
          deviceJSON.config[i].subvalues[0].value = "0";
          saveConfig(deviceJSON.config[i]);
        }
        if (deviceJSON.config[i].key === keyXXKB) {
          deviceJSON.config[i].subvalues[0].value = "0";
          saveConfig(deviceJSON.config[i]);
        }
      }
    }
  } else {
    // УДАЛЕНИЕ РАДИКАНАЛЬНЫХ УСТРОЙСТВ С ВЫХОДАМИ УПРАВЛЕНИЯ
    let CARD_DEVICE = {
      id: "xxad" + CACHE_EDIT_R_DEVICE.id, //Номер XXAD
      xxIndex: CACHE_EDIT_R_DEVICE.id,
      typeDevice: null,
      numberPV: null,
      numberRV: null,
      typeActionPV: null,
      typeActionRV: null,
      delayPV: null,
      delayRV: null,
      triggerPV: [],
      triggerRV: [],
      sectionRV: [],
      sectionPV: [],
      typeESOP: null,
      PARAM_XXSS: null,
      PARAM_XXNB: null,
    };

    //let modelRemoveDevice;
    for (var i = 0; i < virtualRadio.length; i++) {
      if (CACHE_EDIT_R_DEVICE.id === virtualRadio[i].numberRadio) {
        CARD_DEVICE.numberPV = virtualRadio[i].PV[0];
        CARD_DEVICE.numberRV = virtualRadio[i].RV[0];
      }
    }

    let event_PV = document.getElementById("event_PV").childNodes;
    for (var i = 0; i < event_PV.length; i++) {
      CARD_DEVICE.triggerPV.push({
        name: event_PV[i].childNodes[0].childNodes[0].name + CARD_DEVICE.numberPV,
        value: event_PV[i].childNodes[0].childNodes[0].checked,
      });
    }

    let event_RV = document.getElementById("event_RV").childNodes;
    for (var i = 0; i < event_PV.length; i++) {
      CARD_DEVICE.triggerRV.push({
        name: event_RV[i].childNodes[0].childNodes[0].name + CARD_DEVICE.numberRV,
        value: event_RV[i].childNodes[0].childNodes[0].checked,
      });
    }

    let section_PV = document.getElementById("section_PV").childNodes;
    for (var i = 0; i < section_PV.length; i++) {
      if (section_PV[i].childNodes[0].childNodes[0].checked) {
        CARD_DEVICE.sectionPV.push(section_PV[i].childNodes[0].childNodes[0].name);
      }
    }

    let section_RV = document.getElementById("section_RV").childNodes;
    for (var i = 0; i < section_RV.length; i++) {
      if (section_RV[i].childNodes[0].childNodes[0].checked) {
        CARD_DEVICE.sectionRV.push(section_RV[i].childNodes[0].childNodes[0].name);
      }
    }

    console.log(CARD_DEVICE); // ▼ ТИП УСТРОЙСТВА СОГЛАСНО ЕСОП ▼

    if (CARD_DEVICE.typeDevice === "17620") {
      CARD_DEVICE.typeESOP = "70";
      // так же для 3438, 3439 ЕСОП - 91
    } else {
      CARD_DEVICE.typeESOP = 0;
    }

    let keyForSave = [];
    // СОХРАНЯЕМ
    for (i in deviceJSON.config) {
      if (deviceJSON.config[i].key == CARD_DEVICE.id) {
        deviceJSON.config[i].subvalues[0].value = "0";
        deviceJSON.config[i].subvalues[1].value = "0";
        deviceJSON.config[i].subvalues[2].value = "0";
        deviceJSON.config[i].subvalues[3].value = "0";
        saveConfig(deviceJSON.config[i]);
      } else if (deviceJSON.config[i].key == CARD_DEVICE.xxdr) {
        deviceJSON.config[i].subvalues[0].value = "0";
        deviceJSON.config[i].subvalues[1].value = "0";
        saveConfig(deviceJSON.config[i]);
      } else if (deviceJSON.config[i].key === "xxnu" + CARD_DEVICE.xxIndex) {
        deviceJSON.config[i].subvalues[0].value = "0";
        deviceJSON.config[i].subvalues[1].value = "0";
        saveConfig(deviceJSON.config[i]);
      } else if (deviceJSON.config[i].key === "xxnr" + CARD_DEVICE.xxIndex) {
        deviceJSON.config[i].subvalues[0].value = "0";
        deviceJSON.config[i].subvalues[1].value = "0";
        saveConfig(deviceJSON.config[i]);
      } else if (deviceJSON.config[i].key === "oo" + CARD_DEVICE.numberPV) {
        // ПВ режим/время
        deviceJSON.config[i].subvalues[0].value = "0";
        deviceJSON.config[i].subvalues[1].value = "0";
        saveConfig(deviceJSON.config[i]);
      } else if (deviceJSON.config[i].key === "oo" + CARD_DEVICE.numberRV) {
        // РВ режим/время
        deviceJSON.config[i].subvalues[0].value = "0";
        deviceJSON.config[i].subvalues[1].value = "0";
        saveConfig(deviceJSON.config[i]);
      } else if (deviceJSON.config[i].key === "oq" + CARD_DEVICE.numberPV) {
        // РВ режим/время
        deviceJSON.config[i].subvalues[0].value = "0";
        saveConfig(deviceJSON.config[i]);
      } else if (deviceJSON.config[i].key === "oq" + CARD_DEVICE.numberRV) {
        // РВ режим/время
        deviceJSON.config[i].subvalues[0].value = "0";
        saveConfig(deviceJSON.config[i]);
      }
    }

    for (var k = 0; k < CARD_DEVICE.triggerPV.length; k++) {
      // Сохраняем сработки ПВ
      for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key == CARD_DEVICE.triggerPV[k].name) {
          deviceJSON.config[i].subvalues[0].value = "0";
          saveConfig(deviceJSON.config[i]);
          break;
        }
      }
    }

    for (var k = 0; k < CARD_DEVICE.triggerRV.length; k++) {
      // Сохраняем сработки РВ
      for (i in deviceJSON.config) {
        if (deviceJSON.config[i].key == CARD_DEVICE.triggerRV[k].name) {
          deviceJSON.config[i].subvalues[0].value = "1";
          saveConfig(deviceJSON.config[i]);
          break;
        }
      }
    }
  }
  //console.log('####CARD_DEVICE', CARD_DEVICE);
  parseAppKey("update_notabs");
  closeModalR_dev(); // Чистим кэш и закрывем карточку
}

function setNameZone(data) {
  data.value = data.value.replace(/ /g, "");
if(data.value.length > 10){
  data.value = data.value.slice(0,10)
}
  for (i in deviceJSON.config) {
    if (deviceJSON.config[i].key === data.name) {
      if (deviceJSON.config[i].key.indexOf('ua') != -1) {
        deviceJSON.config[i].subvalues[1].value = data.value;
      }
      else {
        deviceJSON.config[i].subvalues[0].value = data.value;
      }

      saveConfig(deviceJSON.config[i]);
      parseAppKey("update_notabs");
    }
  }
}

function check_mac_radio() {
  let locked = false;
  let title = "";
  let collection_block_el = document.getElementsByClassName("radio_parametr_input");
  let serial = virtualRadio.some(s => Number(s.serial) !== 0)
  if (virtualRadio.length > 0 && serial) {
    locked = true;
    title = "Настройка заблокирована, для изменения удалите радиоканальные устройства";
  } else {
    locked = false;
    title = "";
  }
  for (var i = 0; i < collection_block_el.length; i++) {
    collection_block_el[i].disabled = locked;
    collection_block_el[i].title = title;
  }
}
